VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Begin VB.Form frmMain 
   Caption         =   "Paleomagnetic Analysis Program - by Chunfu Zhang (July 2006)"
   ClientHeight    =   7290
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   12015
   BeginProperty Font 
      Name            =   "Courier"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "Paleomag.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   128.588
   ScaleMode       =   6  'Millimeter
   ScaleWidth      =   211.931
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog dlgPrinter 
      Left            =   7080
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdDeactivate 
      Caption         =   "(De)activate Record"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   2895
   End
   Begin VB.CommandButton cmdLSquarePoints 
      Caption         =   "Select/Remove  Points for Least Square Anslysis"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   7320
      TabIndex        =   3
      Top             =   120
      Width           =   4575
   End
   Begin VB.CommandButton cmdDeselectPoints 
      Caption         =   "Select/Remove Points for Z-/S-/ EQ-Plot"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3120
      TabIndex        =   2
      Top             =   120
      Width           =   3975
   End
   Begin VB.ListBox lstRecordData 
      Height          =   6585
      ItemData        =   "Paleomag.frx":0442
      Left            =   3120
      List            =   "Paleomag.frx":0444
      Style           =   1  'Checkbox
      TabIndex        =   1
      Top             =   600
      Width           =   8775
   End
   Begin VB.ListBox lstRecord 
      Height          =   6585
      Left            =   120
      Style           =   1  'Checkbox
      TabIndex        =   0
      Top             =   600
      Width           =   2895
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Index           =   0
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open"
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileConvert 
         Caption         =   "Conver&t"
         Shortcut        =   ^T
      End
      Begin VB.Menu mnuFileClose 
         Caption         =   "&Close"
         Shortcut        =   ^W
      End
      Begin VB.Menu mnuFilePrint 
         Caption         =   "&Print"
         Begin VB.Menu mnuFilePrintMain 
            Caption         =   "&Main Data Window"
         End
         Begin VB.Menu mnuFilePrintZPlot 
            Caption         =   "&Zijderveld Plot"
         End
         Begin VB.Menu mnuFilePrintSPlot 
            Caption         =   "&Stereographic Plot"
         End
         Begin VB.Menu mnuFilePrintEQPlot 
            Caption         =   "&Equal Area Plot"
         End
         Begin VB.Menu mnuFilePrintAll 
            Caption         =   "&All"
            Begin VB.Menu mnuFilePrintAllSPlot 
               Caption         =   "&Stereographic Plot"
            End
            Begin VB.Menu mnuFilePrintAllEQPlot 
               Caption         =   "&Equal Area Plot"
            End
         End
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
         Shortcut        =   ^Q
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Index           =   1
      Begin VB.Menu mnuEditCopy 
         Caption         =   "&Copy"
         Shortcut        =   ^C
      End
   End
   Begin VB.Menu mnuZijderveld 
      Caption         =   "&Zijderveld"
      Index           =   2
      NegotiatePosition=   1  'Left
      Begin VB.Menu mnuZijGeographic 
         Caption         =   "&Geographic"
      End
      Begin VB.Menu mnuZijTilt 
         Caption         =   "&Tilt-Corrected"
      End
      Begin VB.Menu mnuZijProjectionPlane 
         Caption         =   "&Projection Plane"
      End
      Begin VB.Menu mnuZijModified 
         Caption         =   "&Modified Z-Plot"
      End
   End
   Begin VB.Menu mnuStereoPlot 
      Caption         =   "&StereoPlot"
      Index           =   3
      NegotiatePosition=   1  'Left
      Begin VB.Menu mnuSPlotGeographic 
         Caption         =   "&Geographic"
      End
      Begin VB.Menu mnuSPlotTilt 
         Caption         =   "&Tilt-Corrected"
      End
   End
   Begin VB.Menu mnuEQPlot 
      Caption         =   "&EQAreaPlot"
      Index           =   4
      Begin VB.Menu mnuEQPlotGeographic 
         Caption         =   "&Geographic"
      End
      Begin VB.Menu mnuEQPlotTilt 
         Caption         =   "&Tilt-Corrected"
      End
   End
   Begin VB.Menu mnuLeastSquare 
      Caption         =   "&LeastSquare"
      Index           =   5
      NegotiatePosition=   1  'Left
      Begin VB.Menu mnuLSAnalysis 
         Caption         =   "&Least Square Analysis"
      End
      Begin VB.Menu mnuLSAllResults 
         Caption         =   "&Display All Results"
      End
   End
   Begin VB.Menu mnuAll 
      Caption         =   "&All"
      Index           =   6
      NegotiatePosition=   1  'Left
      Begin VB.Menu mnuAllSPlot 
         Caption         =   "Stereo P&lot All"
         Begin VB.Menu mnuAllSPlotNRM 
            Caption         =   "&NRM Data"
         End
         Begin VB.Menu mnuAllSPlotLSquare 
            Caption         =   "&Least Square"
         End
         Begin VB.Menu mnuAllSPlotAF 
            Caption         =   "Alternating &Field"
         End
         Begin VB.Menu mnuAllSPlotAT 
            Caption         =   "Arbitrary &Temperature"
         End
      End
      Begin VB.Menu mnuAllFisherStat 
         Caption         =   "&Fisher statistics"
         Begin VB.Menu mnuAllFisherNRM 
            Caption         =   "&NRM Data"
         End
         Begin VB.Menu mnuAllFisherLSquare 
            Caption         =   "&Least Square"
         End
         Begin VB.Menu mnuAllFisherAF 
            Caption         =   "Alternating &Field"
         End
         Begin VB.Menu mnuAllFisherAT 
            Caption         =   "Arbitrary &Temperature"
         End
      End
   End
   Begin VB.Menu mnuToolbox 
      Caption         =   "&Toolbox"
      Index           =   7
      Begin VB.Menu mnuToolboxCoorConv 
         Caption         =   "&Coordinate Conversion"
      End
      Begin VB.Menu mnuToolboxLatCal 
         Caption         =   "&Latitude Calculation"
      End
      Begin VB.Menu mnuToolboxKonoLatCalc 
         Caption         =   "&Kono (1980) Latitude Calculator"
      End
      Begin VB.Menu mnuToolboxPointProj 
         Caption         =   "&Points Projection"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Index           =   8
      Begin VB.Menu mnuHelpMain 
         Caption         =   "&Main Features"
         Shortcut        =   {F1}
      End
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About Paleomagnetic Analysis Program"
         Shortcut        =   {F2}
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type HeaderType     'Data file header: first line of file
    Name As String * 16     'Section name: one string, less than or equal to 16 characters
    Latitude As Single      'Latitude of section site
    Longitude As Single     'Longitude of section site
    MagDeclination As Single    'Current magnetic declination of section site
    MagInclination As Single    'Current magnetic inclination of section site
    Last As Long            'Last line number + 1 of file, i.e., the line number of EOF
    SampleNum As Long       'Number of samples in the data file
    LineNum As Long         'Current line number of the data file, i.e., 1
End Type

'Sample header. NOTE: in the new tab-formatted data file, only Name and Meter Level are required
Private Type RecordHeadType
    Name As String * 16 'Name of the sample
    Meters As Single    'Meter Level of the sample in the section
    LSHead As Long
    Number As Long
    NextRec As Long
    Theta As Long   'default to -2: No projection
    Active As Long
End Type

Private Type RecordNamesType
    Name As String
    RecordNum As Long
    Active As Long
End Type

Private Type DataType
    GDec As Single
    GInc As Single
    TDec As Single
    TInc As Single
    Mag As Single       'Mag:   Intensity
    Errer As Single     'Errer: Error
    DeMagLevel As Single    'DeMagLevel:    Temperature of a Demagnetization step
    DeMag As String * 3     'DeMag: NRM or TT etc.
    LSquare As Long
    Plot As Long
End Type

Private Type LSInfoType
    GDec As Single
    GInc As Single
    TDec As Single
    TInc As Single
    Mag As Single       'Mag:   Intensity
    Errer As Single     'Errer: Error
    Label As String * 3   'To store labels: N, P, NP, RP, N?, R?
    NextLs As Long
    Active As Long
    num As Long
    Tied As Long
End Type
    
Private OpenFileName As String
    
Private Const PI = 3.14159265358979
Private Header As HeaderType
Private RecordHead As RecordHeadType
Private RecordNames(1 To 500) As RecordNamesType
Private AllData(1 To 500) As DataType   'To store All NRM or TT### data for plotting.
Private Data(1 To 50) As DataType
Private LSInfo(1 To 500) As LSInfoType  'To store results of least square analysis
Private AllLSData(1 To 500) As LSInfoType   'To store all Least Square Data for plotting.
Private Counter As Long     'Current Point
Private PrevCounter As Long 'Previous Point Plotted
Private OpenFileNum As Long
Private SampleNumber As Long    'Number of samples in a file
Private SampleName As String
Private DemagStepNum As Long       'DemagStepNum: Number of analyses in a sample record
Private Radius As Single    'Stereographic Plot Radius (outermost circle)
Private RSample As Single   'Distance of sample to center in Stereographic Plot
Private CenterX As Single   'X coordinate of Stereographic Plot Center
Private CenterY As Single   'Y coordinate of Stereographic Plot Center
Private OriginX As Single   'X coordinate of Zijderveld Plot Origin
Private OriginY As Single   'Y coordinate of Zijderveld Plot Origin
Private DX As Single        'Difference in X in Stereographic Plot
Private DY As Single        'Difference in Y in Stereographic Plot
Private CurrX As Single     'Current X Position of point in Stereographic Plot
Private CurrY As Single     'Current Y Position of point in Stereographic Plot
Private ProjectionPlane As Single   'For Vertical Component of Zijderveld Plot
Private NorInc As Single, NorDec As Single, NorMag As Single
Private RevInc As Single, RevDec As Single, RevMag As Single
Private xNormal As Single, yNormal As Single, zNormal As Single 'Normal Pole
Private xReversed As Single, yReversed As Single, zReversed As Single 'Reversed Pole
Private FishInc As Single, FishDec As Single, FishMag As Single
Private Alpha95 As Single, SM As Single
'Ks: Precision parameter of Fisher Analysis
Private K As Single, NK As Single, RK As Single
Private Weighted As String  'To store the user option for Fisher Analysis using
'   Least Square Data, Good sample (N or R full weight, NP or RP half weight.
'===========================================================
'Above portion: Variable Declaration
'===========================================================

'Purpose:   To change the status of a record from active (default) to inactive
'        or vice versa.
Private Sub cmdDeactivate_Click()
    Dim Start As Long
    Dim I As Long   'As a counter, to change its value from 1 to Header.SampleNum
    Dim N As Long, M As Long
    
    For I = 1 To Header.SampleNum
        If lstRecord.Selected(I) = True Then
            If RecordNames(I).Active = 1 Then
                RecordNames(I).Active = 0
            Else
                RecordNames(I).Active = 1
            End If
        
            Start = 2
            For N = 1 To SampleNumber
                Get #OpenFileNum, Start, RecordHead
                If N = I Then
                    RecordHead.Active = RecordNames(N).Active
                    Put #OpenFileNum, Start, RecordHead
                End If
                Start = RecordHead.NextRec
            Next N
        End If
    Next I
    Form_Click
End Sub

'Purpose:   To selece or remove points to be plotted in Zijderveld-,
'       Stereographic-, and Lambert Equal-area projections.
Private Sub cmdDeselectPoints_Click()
    Dim I As Integer
    
    If lstRecord.ListIndex = 0 Then
        Exit Sub
    End If
    For I = 1 To DemagStepNum
        If lstRecordData.Selected(I) = True Then
            If Data(I).Plot = 0 Then
                Data(I).Plot = 1
            Else
                Data(I).Plot = 0
            End If
            Put #OpenFileNum, (RecordNames(lstRecord.ListIndex).RecordNum _
                + I), Data(I)
        End If
    Next I
    lstRecord_Click
End Sub

'Purpose:   To selece or remove points for Least Square Analysis.
Private Sub cmdLSquarePoints_Click()
    Dim I As Integer
    Dim N As Long
    Dim Start As Long
    Dim Counter As Long
    
    If lstRecord.ListIndex = 0 Then
        Exit Sub
    End If
    
    'Purpose: To get DemagSetpNum of currently selected sample.
    '   This is to ensure that after displaying Least Squares Aanlysis data of all samples,
    '   the DemagStepNum is still of the current, NOT the last sample.
    N = lstRecord.ListIndex
    Start = RecordNames(N).RecordNum
    Get #OpenFileNum, Start, RecordHead
    DemagStepNum = RecordHead.Number
    
    'Purpose: to read the data of current sample. To replace the date of the last sample.
    For Counter = 1 To DemagStepNum
        Get #OpenFileNum, Start + Counter, Data(Counter)
    Next Counter
    
    For I = 1 To DemagStepNum
        If lstRecordData.Selected(I) = True Then
            If Data(I).LSquare = 0 Then
                Data(I).LSquare = 1
            Else
                Data(I).LSquare = 0
            End If
            Put #OpenFileNum, (RecordNames(N).RecordNum + I), Data(I)
        End If
    Next I
    lstRecord_Click
    mnuLSAnalysis_Click
End Sub

'Purpose:   To display records in the file designated to be opened.
Private Sub Form_Click()
    Dim N As Long, temp As String
    
    If OpenFileName = "" Then
        If mnuFileOpen.Checked = True Then
            Call frmFileOpen.Show
        ElseIf mnuFileConvert.Checked = True Then
            Call frmFileConvert.Show
        End If
    Else
        lstRecord.Visible = True
        lstRecord.Enabled = True
        mnuFileOpen.Enabled = False
        mnuFileConvert.Enabled = False
        mnuFileClose.Enabled = True
        mnuFilePrint.Enabled = True
        If mnuEdit(1).Enabled = False And mnuZijderveld(2).Enabled = False _
            And mnuStereoPlot(3).Enabled = False And mnuEQPlot(4).Enabled = False Then
                Call ShowMenus
        End If
        OpenFileNum = FreeFile
        frmMain.Caption = "Paleomagnetic Analysis - " & OpenFileName
        Open OpenFileName For Random Access Read Write As #OpenFileNum Len = 64
        Get #OpenFileNum, 1, Header
        SampleNumber = Header.SampleNum
        Call LoadRecordNames(SampleNumber, OpenFileNum)
        Call lstRecord.Clear
        temp = "  Sample     Active"
        Call lstRecord.AddItem(temp)
        lstRecord.ItemData(lstRecord.NewIndex) = 1
        For N = 1 To SampleNumber
            temp = RecordNames(N).Name
            'In this procedure, the last active record is selected.
            If RecordNames(N).Active = 1 Then
                temp = temp & "Yes"
            Else
                temp = temp & " No"
            End If
            Call lstRecord.AddItem(temp)
            lstRecord.ItemData(lstRecord.NewIndex) = N + 1
        Next N
        lstRecordData.Visible = True
        lstRecordData.Enabled = True
        cmdDeselectPoints.Visible = True
        cmdLSquarePoints.Visible = True
        cmdDeactivate.Visible = True
    End If
End Sub

'Purpose:   To load the records automatically when a file is open.
Public Sub Form_GotFocus()
    Form_Click
End Sub

'Purpose:   To disable menus except the FILE menu when start up.
Private Sub Form_Load()
    Dim Msg As String
    
    On Error GoTo ErrHandler
    mnuFileClose.Enabled = False
    mnuFilePrint.Enabled = False
    Call HideMenus
    lstRecord.Visible = False
    lstRecordData.Visible = False
    cmdDeactivate.Visible = False
    cmdDeselectPoints.Visible = False
    cmdLSquarePoints.Visible = False
    Printer.Font = "Courier"
    Printer.FontSize = 12
    Printer.DrawWidth = 3
    Exit Sub
ErrHandler:
    Msg = "Error # " & Str(Err.Number) & " was generated by " _
         & Err.Source & vbCrLf & "ERROR = " & Err.Description
    Call MsgBox(Msg, vbOKOnly + vbInformation)
    Exit Sub
End Sub


'Purpose:   To show the data within one record.
Private Sub lstRecord_Click()
    Dim N As Long
    Dim Start As Long
    Dim Counter As Long         'Counter:   To read the analyses in a record
    Dim temp As String
    
    lstRecordData.Visible = True
    N = lstRecord.ListIndex
    If N = 0 Then Exit Sub
    SampleName = RecordNames(N).Name
    Start = RecordNames(N).RecordNum
    Get #OpenFileNum, Start, RecordHead
    DemagStepNum = RecordHead.Number
    Call lstRecordData.Clear
    
    'Purpose: Write title for data display
    temp = " Steps     GDec   GInc    TDec   TInc  Intensity  Error  LSquare  Plot"
    Call lstRecordData.AddItem(temp)
    lstRecordData.ItemData(lstRecordData.NewIndex) = 0
    
    For Counter = 1 To DemagStepNum
        Get #OpenFileNum, Start + Counter, Data(Counter)
        temp = LeftAlign(Data(Counter).DeMag, 4) & _
                RightAlign(Format(Data(Counter).DeMagLevel, "0"), 3) & _
                RightAlign(Format(Data(Counter).GDec, "0.0"), 8) & _
                RightAlign(Format(Data(Counter).GInc, "0.0"), 7) & _
                RightAlign(Format(Data(Counter).TDec, "0.0"), 8) & _
                RightAlign(Format(Data(Counter).TInc, "0.0"), 7) & _
                RightAlign(Format(Data(Counter).Mag, "Scientific"), 11) & _
                RightAlign(Format(Data(Counter).Errer, "0.00"), 7)
        If Data(Counter).LSquare = 1 Then
            temp = temp & "    Yes "
        Else
            temp = temp & "     No "
        End If
        If Data(Counter).Plot = 1 Then
            temp = temp & "   Yes"
        Else
            temp = temp & "    No"
        End If
        Call lstRecordData.AddItem(temp)
        lstRecordData.ItemData(lstRecordData.NewIndex) = Counter
    Next Counter
    
    'Purpose:   To add sample name in the lstRecordData Window.
    temp = "      *************** Sample: " & _
        RecordNames(N).Name _
         & " *************** "
    Call lstRecordData.AddItem(temp)
    lstRecordData.ItemData(lstRecordData.NewIndex) = DemagStepNum + 1
    
    If RecordHead.LSHead <> 0 Then
        N = lstRecord.ListIndex
        Get #OpenFileNum, RecordHead.LSHead, LSInfo(N)
        temp = "            ==========Least Square Analysis==========      "
        Call lstRecordData.AddItem(temp)
        lstRecordData.ItemData(lstRecordData.NewIndex) = DemagStepNum + 2
        
        temp = " Label     GDec   GInc    TDec   TInc  Intensity  Error  #Points  Tied"
        Call lstRecordData.AddItem(temp)
        lstRecordData.ItemData(lstRecordData.NewIndex) = DemagStepNum + 3
        temp = LeftAlign(LSInfo(N).Label, 7) & _
                RightAlign(Format(LSInfo(N).GDec, "0.00"), 8) & _
                RightAlign(Format(LSInfo(N).GInc, "0.00"), 7) & _
                RightAlign(Format(LSInfo(N).TDec, "0.00"), 8) & _
                RightAlign(Format(LSInfo(N).TInc, "0.00"), 7) & _
                RightAlign(Format(LSInfo(N).Mag, "Scientific"), 11) & _
                RightAlign(Format(LSInfo(N).Errer, "0.00"), 7) & _
                RightAlign(Format(LSInfo(N).num, "0"), 7)
        If LSInfo(N).Tied = 1 Then
            temp = temp & "    Yes "
        Else
            temp = temp & "     No "
        End If
        Call lstRecordData.AddItem(temp)
        lstRecordData.ItemData(lstRecordData.NewIndex) = DemagStepNum + 4
    End If
        
    frmSPlot.Caption = "Sample: " & SampleName 'Always change the caption of the projection form to the current sample
    frmSPlot.picSPlot.Cls
    
    If Not (mnuSPlotTilt.Checked Or mnuSPlotGeographic.Checked Or mnuEQPlotTilt.Checked _
        Or mnuEQPlotGeographic.Checked) Then
            frmSPlot.lblSPlot.Caption = ""
    End If
    
    If mnuSPlotTilt.Checked Or mnuSPlotGeographic.Checked Or mnuEQPlotTilt.Checked _
        Or mnuEQPlotGeographic.Checked Or mnuZijGeographic.Checked Or mnuZijTilt.Checked Then
            Call frmSPlot.Show
    Else
        Call frmSPlot.Hide
        Exit Sub
    End If

    'Purpose:   Check to see if need to do Stereographic Projection.
    If mnuSPlotTilt.Checked Then
        Call SPlotBackground
        Call SPlotTiltDisplay(DemagStepNum)
    ElseIf mnuSPlotGeographic.Checked Then
        Call SPlotBackground
        Call SPlotGeogDisplay(DemagStepNum)
    End If
    
    'Purpose:   Check to see if need to do Lambert Equal-area Projection.
    If mnuEQPlotTilt.Checked Then
        Call EQPlotBackground
        Call EQPlotTiltDisplay(DemagStepNum)
    ElseIf mnuEQPlotGeographic.Checked Then
        Call EQPlotBackground
        Call EQPlotGeogDisplay(DemagStepNum)
    End If
    
    'Purpose:   Check to see if need to perform Zijderveld Plot.
    If mnuZijGeographic.Checked Or mnuZijTilt.Checked Then
        frmSPlot.picZPlot.Cls
        Call ZijderveldPlot(DemagStepNum)
    End If
End Sub

'Purpose:   To perform Fisher Analysis using Data at an arbitrary temperature
Private Sub mnuAllFisherAF_Click()
    Dim Start As Long, num As Long, InactiveNum As Long, Counter As Long
    Dim Message As String, Title As String, AFStrength As Single
    Dim DataSelected As String
    Dim temp As String
    Dim I As Long   'As a counter, to change its value from 1 to Header.SampleNum
    Dim AllPointsTDec(1 To 500) As Single, AllPointsTInc(1 To 500) As Single
    Dim AllPointsGDec(1 To 500) As Single, AllPointsGInc(1 To 500) As Single
    Dim AllPointsMag(1 To 500) As Single
    Dim InactivePoints(1 To 500) As Long
    Dim G(1 To 500) As Long  'To store the sample# of selected samples
    Dim PrevNum As Long 'To store the previous num, for judging if a T step exist.
    Dim NoData(1 To 500) As Long 'To store the sample# that does not have the T step.
    Dim NoNum As Long   'To store the number of samples that do not have this T step.
    Dim EstInc As Single, EstDec As Single
    Dim RevInc As Single, RevDec As Single
    Dim NAng As Single, RAng As Single
       
    Message = "Please enter a desired strength of" & vbCrLf & _
            "Alternating Field for Fisher Analysis: "
    Title = "Alternating Field Strength Selection"
    Do
        temp = InputBox(Message, Title)
    Loop Until IsNumeric(temp) = True Or temp = ""
    If temp = "" Then Exit Sub
    AFStrength = CSng(temp)
    
    
    Message = "Please select a data set for Fisher Analysis. " & vbCrLf & _
            "Input 'G or g' to select Geographic Data, or" & vbCrLf & _
            "Input 'T or t' to select Tilt-corrected Data"
    Title = "Selecting Data for Fisher Analysis"
    Do
        DataSelected = UCase(InputBox(Message, Title))
    Loop Until DataSelected = "G" Or DataSelected = "T" Or DataSelected = ""
    
    If DataSelected <> "" Then
        frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
            "========================================================" _
            & "======================" & vbCrLf & _
            "Fisher Analysis using data at " & Format(AFStrength, "0") & _
            " mT" & vbCrLf
        If DataSelected = "G" Then
            frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
                "Geographic coordinates" & vbCrLf & vbCrLf
        Else
            frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
                "Tilt-corrected directions" & vbCrLf & vbCrLf
        End If
    Else
        Exit Sub
    End If
    

    NK = 0
    RK = 0
    num = 0
    PrevNum = 0
    NoNum = 0
    Weighted = "No"
    InactiveNum = 0
    Start = 2
    For I = 1 To Header.SampleNum
        Get #OpenFileNum, Start, RecordHead
        If RecordNames(I).Active = 1 Then
            For Counter = 1 To RecordHead.Number - 1
                Get #OpenFileNum, Start + Counter, Data(Counter)
                If (Data(Counter).DeMagLevel = AFStrength) And _
                    (Data(Counter).Plot = 1) Then
                        num = num + 1
                        G(num) = I
                        AllPointsTDec(num) = Data(Counter).TDec
                        AllPointsTInc(num) = Data(Counter).TInc
                        AllPointsGDec(num) = Data(Counter).GDec
                        AllPointsGInc(num) = Data(Counter).GInc
                        AllPointsMag(num) = Log(Data(Counter).Mag)
                End If
            Next Counter
            If PrevNum = num Then
                NoNum = NoNum + 1
                NoData(NoNum) = I
            Else
                PrevNum = num
            End If
        Else
            InactiveNum = InactiveNum + 1
            InactivePoints(InactiveNum) = I
        End If
        Start = RecordHead.NextRec
    Next I
    
    If InactiveNum <> 0 Then
        For I = 1 To InactiveNum
            frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
                RecordNames(InactivePoints(I)).Name & " omitted: inactive" & vbCrLf
        Next I
    ElseIf InactiveNum = 0 And NoNum = 0 Then
        frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
            "Every sample is active and used in Fisher Analysis." & vbCrLf
    ElseIf NoNum > 0 And num > 0 Then
        For I = 1 To NoNum
            frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
                RecordNames(NoData(I)).Name & "- Not Selected/No Such Step" & vbCrLf
        Next I
    ElseIf num = 0 Then
        frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
            "Caution: No such step. Please check your data." & vbCrLf
        Call frmFisher.Show
        Exit Sub
    End If
    Call frmFisher.Show
    
    'Purpose: Get Initial Normal Direction from the user.
    Title = "Estimated Normal Inclination (-90 to 90 Degree)"
    Message = "A rough estimate of the Normal direction is needed. " & vbCrLf & _
            "for an initial cutoff of Normal vs. Reversed Polarity." & vbCrLf & _
            "Input "
    Do
        Do
            temp = InputBox(Message & Title & ":", Title)
        Loop Until IsNumeric(temp) = True Or temp = ""
        If temp = "" Then Exit Sub
        EstInc = CSng(temp)
    Loop Until EstInc >= -90 And EstInc <= 90
    Title = "Estimated Normal Declination (0 to 360 Degree)"
    Do
        Do
            temp = InputBox(Message & Title & ":", Title)
        Loop Until IsNumeric(temp) = True Or temp = ""
        If temp = "" Then Exit Sub
        EstDec = CSng(temp)
    Loop Until EstDec >= 0 And EstDec < 360
    
    NAng = PI / 2
    RAng = PI / 2
    'NorDec, NorInc, RevDec, and RevInc are all in Radians.
    EstInc = DegToRad(EstInc)
    EstDec = DegToRad(EstDec)
    NorInc = EstInc
    NorDec = EstDec
    RevInc = -EstInc
    RevDec = EstDec + PI
    If RevDec >= 2 * PI Then RevDec = RevDec - 2 * PI
       
    'Purpose: Determine the XYZ or Normal and Reversed Comparison Vectors.
    Call XYZFisher(xNormal, yNormal, zNormal, NorDec, NorInc)
    Call XYZFisher(xReversed, yReversed, zReversed, RevDec, RevInc)
         
    If DataSelected = "G" Then
        Call Fisher(AllPointsGDec(), AllPointsGInc(), AllPointsMag(), _
            G(), num, NAng, RAng)
    Else
        Call Fisher(AllPointsTDec(), AllPointsTInc(), AllPointsMag(), _
            G(), num, NAng, RAng)
    End If
    
    'Now redo with a cutoff of 60 degrees or 2*Sigma(2*81/Sqr(K))
    If NK <> 0 Then NAng = DegToRad(162) / Sqr(NK)
    If NAng > PI / 3 Then NAng = PI / 3
    If RK <> 0 Then RAng = DegToRad(162) / Sqr(RK)
    If RAng > PI / 3 Then RAng = PI / 3
    frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
        "******************************************************" & vbCrLf & _
        vbCrLf & "Now Redone with New Cutoffs of " & _
        Format(RadToDeg(NAng), "0.00") & " Degrees for Normal and " & _
        Format(RadToDeg(RAng), "0.00") & " Degrees for Reversed." & vbCrLf
    Call XYZFisher(xNormal, yNormal, zNormal, NorDec, NorInc)
    Call XYZFisher(xReversed, yReversed, zReversed, RevDec, RevInc)
    
    If DataSelected = "G" Then
        Call Fisher(AllPointsGDec(), AllPointsGInc(), AllPointsMag(), _
            G(), num, NAng, RAng)
    Else
        Call Fisher(AllPointsTDec(), AllPointsTInc(), AllPointsMag(), _
            G(), num, NAng, RAng)
    End If
End Sub


'Purpose:   To perform Fisher Analysis using Data at an arbitrary temperature
Private Sub mnuAllFisherAT_Click()
    Dim Start As Long, num As Long, InactiveNum As Long, Counter As Long
    Dim Message As String, Title As String, Temperature As Single
    Dim DataSelected As String
    Dim temp As String
    Dim I As Long   'As a counter, to change its value from 1 to Header.SampleNum
    Dim AllPointsTDec(1 To 500) As Single, AllPointsTInc(1 To 500) As Single
    Dim AllPointsGDec(1 To 500) As Single, AllPointsGInc(1 To 500) As Single
    Dim AllPointsMag(1 To 500) As Single
    Dim InactivePoints(1 To 500) As Long
    Dim G(1 To 500) As Long  'To store the sample# of selected samples
    Dim PrevNum As Long 'To store the previous num, for judging if a T step exist.
    Dim NoData(1 To 500) As Long 'To store the sample# that does not have the T step.
    Dim NoNum As Long   'To store the number of samples that do not have this T step.
    Dim EstInc As Single, EstDec As Single
    Dim RevInc As Single, RevDec As Single
    Dim NAng As Single, RAng As Single
       
    Message = "Please enter a desired temperature for Fisher Analysis:" & vbCrLf & _
            "e.g., 250, 300, 350, 400 degree, etc. "
    Title = "Fisher Analysis - Temperature Selection"
    Do
        temp = InputBox(Message, Title)
    Loop Until IsNumeric(temp) = True Or temp = ""
    If temp = "" Then Exit Sub
    Temperature = CSng(temp)
    
    Message = "Please select a data set for Fisher Analysis. " & vbCrLf & _
            "Input 'G or g' to select Geographic Data, or" & vbCrLf & _
            "Input 'T or t' to select Tilt-corrected Data"
    Title = "Selecting Data for Fisher Analysis"
    Do
        DataSelected = UCase(InputBox(Message, Title))
    Loop Until DataSelected = "G" Or DataSelected = "T" Or DataSelected = ""
    
    If DataSelected <> "" Then
        frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
            "========================================================" _
            & "======================" & vbCrLf & _
            "Fisher Analysis using data at " & Format(Temperature, "0") & _
            " degrees (Centigrade)" & vbCrLf
        If DataSelected = "G" Then
            frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
                "Geographic coordinates" & vbCrLf & vbCrLf
        Else
            frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
                "Tilt-corrected directions" & vbCrLf & vbCrLf
        End If
    Else
        Exit Sub
    End If
    

    NK = 0
    RK = 0
    num = 0
    PrevNum = 0
    NoNum = 0
    Weighted = "No"
    InactiveNum = 0
    Start = 2
    For I = 1 To Header.SampleNum
        Get #OpenFileNum, Start, RecordHead
        If RecordNames(I).Active = 1 Then
            For Counter = 1 To RecordHead.Number - 1
                Get #OpenFileNum, Start + Counter, Data(Counter)
                If (Data(Counter).DeMagLevel = Temperature) And _
                    (Data(Counter).Plot = 1) Then
                        num = num + 1
                        G(num) = I
                        AllPointsTDec(num) = Data(Counter).TDec
                        AllPointsTInc(num) = Data(Counter).TInc
                        AllPointsGDec(num) = Data(Counter).GDec
                        AllPointsGInc(num) = Data(Counter).GInc
                        AllPointsMag(num) = Log(Data(Counter).Mag)
                End If
            Next Counter
            If PrevNum = num Then
                NoNum = NoNum + 1
                NoData(NoNum) = I
            Else
                PrevNum = num
            End If
        Else
            InactiveNum = InactiveNum + 1
            InactivePoints(InactiveNum) = I
        End If
        Start = RecordHead.NextRec
    Next I
    
    If InactiveNum <> 0 Then
        For I = 1 To InactiveNum
            frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
                RecordNames(InactivePoints(I)).Name & " omitted: inactive" & vbCrLf
        Next I
    ElseIf InactiveNum = 0 And NoNum = 0 Then
        frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
            "Every sample is active and used in Fisher Analysis." & vbCrLf
    ElseIf NoNum > 0 And num > 0 Then
        For I = 1 To NoNum
            frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
                RecordNames(NoData(I)).Name & "- Not Selected/No Such Step" & vbCrLf
        Next I
    ElseIf num = 0 Then
        frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
            "Caution: No such step. Please check your data." & vbCrLf
        Call frmFisher.Show
        Exit Sub
    End If
    Call frmFisher.Show
    
    'Purpose: Get Initial Normal Direction from the user.
    Title = "Estimated Normal Inclination (-90 to 90 Degree)"
    Message = "A rough estimate of the Normal direction is needed. " & vbCrLf & _
            "for an initial cutoff of Normal vs. Reversed Polarity." & vbCrLf & _
            "Input "
    Do
        Do
            temp = InputBox(Message & Title & ":", Title)
        Loop Until IsNumeric(temp) = True Or temp = ""
        If temp = "" Then Exit Sub
        EstInc = CSng(temp)
    Loop Until EstInc >= -90 And EstInc <= 90
    Title = "Estimated Normal Declination (0 to 360 Degree)"
    Do
        Do
            temp = InputBox(Message & Title & ":", Title)
        Loop Until IsNumeric(temp) = True Or temp = ""
        If temp = "" Then Exit Sub
        EstDec = CSng(temp)
    Loop Until EstDec >= 0 And EstDec < 360
    
    NAng = PI / 2
    RAng = PI / 2
    'NorDec, NorInc, RevDec, and RevInc are all in Radians.
    EstInc = DegToRad(EstInc)
    EstDec = DegToRad(EstDec)
    NorInc = EstInc
    NorDec = EstDec
    RevInc = -EstInc
    RevDec = EstDec + PI
    If RevDec >= 2 * PI Then RevDec = RevDec - 2 * PI
       
    'Purpose: Determine the XYZ or Normal and Reversed Comparison Vectors.
    Call XYZFisher(xNormal, yNormal, zNormal, NorDec, NorInc)
    Call XYZFisher(xReversed, yReversed, zReversed, RevDec, RevInc)
         
    If DataSelected = "G" Then
        Call Fisher(AllPointsGDec(), AllPointsGInc(), AllPointsMag(), _
            G(), num, NAng, RAng)
    Else
        Call Fisher(AllPointsTDec(), AllPointsTInc(), AllPointsMag(), _
            G(), num, NAng, RAng)
    End If
    
    'Now redo with a cutoff of 60 degrees or 2*Sigma(2*81/Sqr(K))
    If NK <> 0 Then NAng = DegToRad(162) / Sqr(NK)
    If NAng > PI / 3 Then NAng = PI / 3
    If RK <> 0 Then RAng = DegToRad(162) / Sqr(RK)
    If RAng > PI / 3 Then RAng = PI / 3
    frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
        "******************************************************" & vbCrLf & _
        vbCrLf & "Now Redone with New Cutoffs of " & _
        Format(RadToDeg(NAng), "0.00") & " Degrees for Normal and " & _
        Format(RadToDeg(RAng), "0.00") & " Degrees for Reversed." & vbCrLf
    Call XYZFisher(xNormal, yNormal, zNormal, NorDec, NorInc)
    Call XYZFisher(xReversed, yReversed, zReversed, RevDec, RevInc)
    
    If DataSelected = "G" Then
        Call Fisher(AllPointsGDec(), AllPointsGInc(), AllPointsMag(), _
            G(), num, NAng, RAng)
    Else
        Call Fisher(AllPointsTDec(), AllPointsTInc(), AllPointsMag(), _
            G(), num, NAng, RAng)
    End If
End Sub

'Purpose:   To perform Fisher Analysis using Least Square Data.
Private Sub mnuAllFisherLSquare_Click()
    Dim Start As Long, num As Long, InactiveNum As Long, Counter As Long
    Dim NumNor As Long, NumRev As Long, G(1 To 500) As Long
    Dim NPTDec(1 To 500) As Single, NPTInc(1 To 500) As Single
    Dim NPGDec(1 To 500) As Single, NPGInc(1 To 500) As Single
    Dim NPMag(1 To 500) As Single
    Dim RPTDec(1 To 500) As Single, RPTInc(1 To 500) As Single
    Dim RPGDec(1 To 500) As Single, RPGInc(1 To 500) As Single
    Dim RPMag(1 To 500) As Single
    Dim Message As String, Title As String, Temperature As Single
    Dim DataSelected As String
    Dim temp As String
    Dim I As Long   'As a counter, to change its value from 1 to Header.SampleNum
    Dim AllPointsTDec(1 To 500) As Single, AllPointsTInc(1 To 500) As Single
    Dim AllPointsGDec(1 To 500) As Single, AllPointsGInc(1 To 500) As Single
    Dim AllPointsMag(1 To 500) As Single
    Dim Nor(1 To 500) As Long  'To store the sample# of N or NP samples
    Dim Rev(1 To 500) As Long  'To store the sample# of R or RP samples
    Dim EstInc As Single, EstDec As Single
    Dim RevInc As Single, RevDec As Single
    Dim NAng As Single, RAng As Single
    Dim N95 As Single, NSD As Single, R95 As Single, RSD As Single

    Message = "Would you like the data to be weighted? (Y/y/N/n)" & vbCrLf & _
            "N or R: Full Weight; NP or RP: Half Weight."
            Title = "Weighting Selection for Fisher Analysis"
    Do
        DataSelected = UCase(InputBox(Message, Title))
    Loop Until DataSelected = "Y" Or DataSelected = "N" Or DataSelected = ""
    If DataSelected = "Y" Then
        Weighted = "Yes"
    ElseIf DataSelected = "N" Then
        Weighted = "No"
    Else
        Exit Sub
    End If

    Message = "Please select a data set for Fisher Analysis. " & vbCrLf & _
            "Input 'G or g' to select Geographic Data, or" & vbCrLf & _
            "Input 'T or t' to select Tilt-corrected Data"
    Title = "Selecting Data for Fisher Analysis"
    Do
        DataSelected = UCase(InputBox(Message, Title))
    Loop Until DataSelected = "G" Or DataSelected = "T" Or DataSelected = ""
    
    If DataSelected <> "" Then
        frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
            "===========================================================" _
            & "===================" & vbCrLf & _
            "Fisher Analysis using Least Square Data" & vbCrLf
        If Weighted = "Yes" Then
            frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
                "The data set is weighted: N or R full weight => Count Twice" & vbCrLf & _
                "                          NP or RP half Weight => Count Once" & vbCrLf
        Else
            frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
                "The data set is not weighted: N and NP or R and RP same weight." & vbCrLf
        End If
        If DataSelected = "G" Then
            frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
                "Geographic coordinates" & vbCrLf & vbCrLf
        Else
            frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
                "Tilt-corrected directions" & vbCrLf & vbCrLf
        End If
    Else
        Exit Sub
    End If
    
    Call frmFisher.Show

'Sort N R Samples, get NorDec

    NK = 0
    RK = 0
    num = 0
    NumNor = 0
    NumRev = 0
    Start = 2
    For I = 1 To Header.SampleNum
        Get #OpenFileNum, Start, RecordHead
        If RecordNames(I).Active = 1 Then
            If RecordHead.LSHead <> 0 Then
                Get #OpenFileNum, RecordHead.LSHead, AllLSData(I)
                If (AllLSData(I).Active = 1) And (AllLSData(I).Label = "N  " Or _
                    AllLSData(I).Label = "NP ") Then
                    NumNor = NumNor + 1
                    Nor(NumNor) = I
                    num = num + 1
                    G(num) = I
                    AllPointsTDec(num) = AllLSData(I).TDec
                    AllPointsTInc(num) = AllLSData(I).TInc
                    AllPointsGDec(num) = AllLSData(I).GDec
                    AllPointsGInc(num) = AllLSData(I).GInc
                    AllPointsMag(num) = Log(AllLSData(I).Mag)
                    NPTDec(NumNor) = AllLSData(I).TDec
                    NPTInc(NumNor) = AllLSData(I).TInc
                    NPGDec(NumNor) = AllLSData(I).GDec
                    NPGInc(NumNor) = AllLSData(I).GInc
                    NPMag(num) = Log(AllLSData(I).Mag)
                    If Weighted = "Yes" And (AllLSData(I).Label = "N  ") Then
                        NumNor = NumNor + 1
                        Nor(NumNor) = I
                        num = num + 1
                        G(num) = I
                        AllPointsTDec(num) = AllLSData(I).TDec
                        AllPointsTInc(num) = AllLSData(I).TInc
                        AllPointsGDec(num) = AllLSData(I).GDec
                        AllPointsGInc(num) = AllLSData(I).GInc
                        AllPointsMag(num) = Log(AllLSData(I).Mag)
                        NPTDec(NumNor) = AllLSData(I).TDec
                        NPTInc(NumNor) = AllLSData(I).TInc
                        NPGDec(NumNor) = AllLSData(I).GDec
                        NPGInc(NumNor) = AllLSData(I).GInc
                        NPMag(NumNor) = Log(AllLSData(I).Mag)
                    End If
                    temp = ""
                ElseIf (AllLSData(I).Active = 1) And (AllLSData(I).Label = "R  " Or _
                    AllLSData(I).Label = "RP ") Then
                    NumRev = NumRev + 1
                    Rev(NumRev) = I
                    num = num + 1
                    G(num) = I
                    AllPointsTDec(num) = AllLSData(I).TDec
                    AllPointsTInc(num) = AllLSData(I).TInc
                    AllPointsGDec(num) = AllLSData(I).GDec
                    AllPointsGInc(num) = AllLSData(I).GInc
                    AllPointsMag(num) = Log(AllLSData(I).Mag)
                    RPTDec(NumRev) = AllLSData(I).TDec
                    RPTInc(NumRev) = AllLSData(I).TInc
                    RPGDec(NumRev) = AllLSData(I).GDec
                    RPGInc(NumRev) = AllLSData(I).GInc
                    RPMag(NumRev) = Log(AllLSData(I).Mag)
                    If Weighted = "Yes" And (AllLSData(I).Label = "R  ") Then
                        NumRev = NumRev + 1
                        Rev(NumRev) = I
                        num = num + 1
                        G(num) = I
                        AllPointsTDec(num) = AllLSData(I).TDec
                        AllPointsTInc(num) = AllLSData(I).TInc
                        AllPointsGDec(num) = AllLSData(I).GDec
                        AllPointsGInc(num) = AllLSData(I).GInc
                        AllPointsMag(num) = Log(AllLSData(I).Mag)
                        RPTDec(NumRev) = AllLSData(I).TDec
                        RPTInc(NumRev) = AllLSData(I).TInc
                        RPGDec(NumRev) = AllLSData(I).GDec
                        RPGInc(NumRev) = AllLSData(I).GInc
                        RPMag(NumRev) = Log(AllLSData(I).Mag)
                    End If
                    temp = ""
                ElseIf (AllLSData(I).Active = 1) And (AllLSData(I).Label = "NPP") Then
                    temp = "NPP"
                ElseIf (AllLSData(I).Active = 1) And (AllLSData(I).Label = "RPP") Then
                    temp = "RPP"
                ElseIf (AllLSData(I).Active = 1) And (AllLSData(I).Label = "N? ") Then
                    temp = "N? "
                ElseIf (AllLSData(I).Active = 1) And (AllLSData(I).Label = "R? ") Then
                    temp = "R? "
                ElseIf (AllLSData(I).Active = 1) And (AllLSData(I).Label = "N??") Then
                    temp = "N??"
                ElseIf (AllLSData(I).Active = 1) And (AllLSData(I).Label = "R??") Then
                    temp = "R??"
                ElseIf (AllLSData(I).Active = 1) And (AllLSData(I).Label = "INT") Then
                    temp = "INT"
                ElseIf (AllLSData(I).Active = 0) Then
                    temp = "LS Data inactive"
                Else
                    temp = "Bad LS Data label"
                End If
            Else
                temp = "No LS Data"
            End If
        Else
            temp = "inactive"
        End If
        If temp <> "" Then
            frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
                RecordNames(I).Name & " omitted: " & temp & vbCrLf
        End If
        Start = RecordHead.NextRec
    Next I

    If (NumNor = 0) And (NumRev = 0) Then
        frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
            "No Least Square Data for Fisher Analysis!!!" & vbCrLf
        Exit Sub
    End If
    
    NAng = PI / 2
    RAng = PI / 2
       
         
    If NumNor > 0 Then
        frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
            ">>>>>>>> Normal Directions <<<<<<<<" & vbCrLf
        If DataSelected = "T" Then
            Call FisherSub(NPTDec(), NPTInc(), NPMag(), NumNor)
        Else
            Call FisherSub(NPGDec(), NPGInc(), NPMag(), NumNor)
        End If
        NorDec = FishDec
        NorInc = FishInc
        NorMag = FishMag
        N95 = Alpha95
        NSD = SM
        NK = K
    End If
    If NumRev > 0 Then
        frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
            ">>>>>>>> Reversed Directions <<<<<<<<" & vbCrLf
        If DataSelected = "T" Then
            Call FisherSub(RPTDec(), RPTInc(), RPMag(), NumRev)
        Else
            Call FisherSub(RPGDec(), RPGInc(), RPMag(), NumRev)
        End If
        RevDec = FishDec
        RevInc = FishInc
        RevMag = FishMag
        R95 = Alpha95
        RSD = SM
        RK = K
    End If
    
    'Now redo with a cutoff of 60 degrees or 2*Sigma(2*81/Sqr(K))
    If NK <> 0 Then NAng = DegToRad(162) / Sqr(NK)
    If NAng > PI / 3 Then NAng = PI / 3
    If RK <> 0 Then RAng = DegToRad(162) / Sqr(RK)
    If RAng > PI / 3 Then RAng = PI / 3
    frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
        "******************************************************" & vbCrLf & _
        vbCrLf & "Now Redone with New Cutoffs of " & _
        Format(RadToDeg(NAng), "0.00") & " Degrees for Normal and " & _
        Format(RadToDeg(RAng), "0.00") & " Degrees for Reversed." & vbCrLf
    If NumNor > 0 Then
        Call XYZFisher(xNormal, yNormal, zNormal, NorDec, NorInc)
    End If
    If NumRev > 0 Then
        Call XYZFisher(xReversed, yReversed, zReversed, RevDec, RevInc)
    Else
        xReversed = -xNormal
        yReversed = -yNormal
        zReversed = -zNormal
    End If
    If DataSelected = "G" Then
        Call Fisher(AllPointsGDec(), AllPointsGInc(), AllPointsMag(), _
            G(), num, NAng, RAng)
    Else
        Call Fisher(AllPointsTDec(), AllPointsTInc(), AllPointsMag(), _
            G(), num, NAng, RAng)
    End If
End Sub

'Purpose:   To perform Fisher Analysis using NRM Data.
Private Sub mnuAllFisherNRM_Click()
    Dim Start As Long, num As Long, InactiveNum As Long
    Dim Message As String, Title As String, DataSelected As String
    Dim temp As String
    Dim I As Long   'As a counter, to change its value from 1 to Header.SampleNum
    Dim Counter As Integer  'In case there are several NRM analyses
    Dim AllPointsTDec(1 To 500) As Single, AllPointsTInc(1 To 500) As Single
    Dim AllPointsGDec(1 To 500) As Single, AllPointsGInc(1 To 500) As Single
    Dim AllPointsMag(1 To 500) As Single
    Dim InactivePoints(1 To 500) As Long
    Dim G(1 To 500) As Long  'To store the sample# of selected samples
    Dim EstInc As Single, EstDec As Single
    Dim RevInc As Single, RevDec As Single
    Dim NAng As Single, RAng As Single
    
    Message = "Please select a data set for Fisher Analysis. " & vbCrLf & _
            "Input 'G or g' to select Geographic Data, or" & vbCrLf & _
            "Input 'T or t' to select Tilt-corrected Data"
    Title = "Selecting Data for Fisher Analysis"
    Do
        DataSelected = UCase(InputBox(Message, Title))
    Loop Until DataSelected = "G" Or DataSelected = "T" Or DataSelected = ""
 
    If DataSelected <> "" Then
        frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
            "===========================================================" _
            & "===================" & vbCrLf & _
            "Fisher Analysis using NRM Data" & vbCrLf
        If DataSelected = "G" Then
            frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
                "Geographic coordinates" & vbCrLf & vbCrLf
        Else
            frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
                "Tilt-corrected directions" & vbCrLf & vbCrLf
        End If
    Else
        Exit Sub
    End If
    
    NK = 0
    RK = 0
    num = 0
    Weighted = "No"
    InactiveNum = 0
    Start = 2
    For I = 1 To Header.SampleNum
        Get #OpenFileNum, Start, RecordHead
        If RecordNames(I).Active = 1 Then
            For Counter = 1 To 6
                Get #OpenFileNum, Start + Counter, Data(Counter)
                If Data(Counter).DeMag = "NRM" And Data(Counter).Plot = 1 Then
                    num = num + 1
                    G(num) = I
                    AllPointsTDec(num) = Data(Counter).TDec
                    AllPointsTInc(num) = Data(Counter).TInc
                    AllPointsGDec(num) = Data(Counter).GDec
                    AllPointsGInc(num) = Data(Counter).GInc
                    AllPointsMag(num) = Log(Data(Counter).Mag)
                End If
            Next Counter
        Else
            InactiveNum = InactiveNum + 1
            InactivePoints(InactiveNum) = I
        End If
        Start = RecordHead.NextRec
    Next I
    
    If InactiveNum <> 0 Then
        For I = 1 To InactiveNum
            frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
                RecordNames(InactivePoints(I)).Name & " omitted: inactive" & vbCrLf
        Next I
    Else
        frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
            "Every sample is active and used in Fisher Analysis." & vbCrLf
    End If
    Call frmFisher.Show
    
    'Purpose: Get Initial Normal Direction from the user.
    Title = "Estimated Normal Inclination (-90 to 90 Degree)"
    Message = "A rough estimate of the Normal direction is needed. " & vbCrLf & _
            "for an initial cutoff of Normal vs. Reversed Polarity." & vbCrLf & _
            "Input "
    Do
        Do
            temp = InputBox(Message & Title & ":", Title)
        Loop Until IsNumeric(temp) = True Or temp = ""
        If temp = "" Then Exit Sub
        EstInc = CSng(temp)
    Loop Until EstInc >= -90 And EstInc <= 90
    Title = "Estimated Normal Declination (0 to 360 Degree)"
    Do
        Do
            temp = InputBox(Message & Title & ":", Title)
        Loop Until IsNumeric(temp) = True Or temp = ""
        If temp = "" Then Exit Sub
        EstDec = CSng(temp)
    Loop Until EstDec >= 0 And EstDec < 360
    
    NAng = PI / 2
    RAng = PI / 2
    'NorDec, NorInc, RevDec, and RevInc are all in Radians.
    EstInc = DegToRad(EstInc)
    EstDec = DegToRad(EstDec)
    NorInc = EstInc
    NorDec = EstDec
    RevInc = -EstInc
    RevDec = EstDec + PI
    If RevDec >= 2 * PI Then RevDec = RevDec - 2 * PI
       
    'Purpose: Determine the XYZ or Normal and Reversed Comparison Vectors.
    Call XYZFisher(xNormal, yNormal, zNormal, NorDec, NorInc)
    Call XYZFisher(xReversed, yReversed, zReversed, RevDec, RevInc)
         
    If DataSelected = "G" Then
        Call Fisher(AllPointsGDec(), AllPointsGInc(), AllPointsMag(), _
            G(), num, NAng, RAng)
    Else
        Call Fisher(AllPointsTDec(), AllPointsTInc(), AllPointsMag(), _
            G(), num, NAng, RAng)
    End If
    
    'Now redo with a cutoff of 60 degrees or 2*Sigma(2*81/Sqr(K))
    If NK <> 0 Then NAng = DegToRad(162) / Sqr(NK)
    If NAng > PI / 3 Then NAng = PI / 3
    If RK <> 0 Then RAng = DegToRad(162) / Sqr(RK)
    If RAng > PI / 3 Then RAng = PI / 3
    frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
        "******************************************************" & vbCrLf & _
        vbCrLf & "Now Redone with New Cutoffs of " & _
        Format(RadToDeg(NAng), "0.00") & " Degrees for Normal and " & _
        Format(RadToDeg(RAng), "0.00") & " Degrees for Reversed." & vbCrLf
    Call XYZFisher(xNormal, yNormal, zNormal, NorDec, NorInc)
    Call XYZFisher(xReversed, yReversed, zReversed, RevDec, RevInc)
    
    If DataSelected = "G" Then
        Call Fisher(AllPointsGDec(), AllPointsGInc(), AllPointsMag(), _
            G(), num, NAng, RAng)
    Else
        Call Fisher(AllPointsTDec(), AllPointsTInc(), AllPointsMag(), _
            G(), num, NAng, RAng)
    End If
End Sub

'Purpose:   To plot all qualified Data at T in the *.mag file.
'In the following "mnuAllSPlotAT", AT = Arbitrary Temperature.
Private Sub mnuAllSPlotAF_Click()
    Dim Message As String, Title As String, AFStrength As Single
    Dim Start As Long, num As Long, Counter As Long, temp As String
    Dim I As Long   'As a counter, to change its value from 1 to Header.SampleNum
    Dim AllPointsTDec(1 To 500) As Single, AllPointsTInc(1 To 500) As Single
    Dim AllPointsGDec(1 To 500) As Single, AllPointsGInc(1 To 500) As Single
    
    Message = "Please enter a desired strength of" & vbCrLf & _
            "Alternating Field for Fisher Analysis: "
    Title = "Alternating Field Strength Selection"
    Do
        temp = InputBox(Message, Title)
    Loop Until IsNumeric(temp) = True Or temp = ""
    If temp = "" Then Exit Sub
    AFStrength = CSng(temp)
    
    frmSPlot.Caption = "Right Panel: Projection of all samples using data at " & _
                        Format(AFStrength, "0") & " mT"
    
    Call frmSPlot.picSPlot.Cls
    Call frmSPlot.Show
            
    num = 0
    Start = 2
    For I = 1 To Header.SampleNum
        Get #OpenFileNum, Start, RecordHead
        If RecordNames(I).Active = 1 Then
            For Counter = 1 To RecordHead.Number - 1
                Get #OpenFileNum, Start + Counter, Data(Counter)
                If (Data(Counter).DeMagLevel = AFStrength) And _
                    (Data(Counter).Plot = 1) Then
                        num = num + 1
                        AllPointsTDec(num) = Data(Counter).TDec
                        AllPointsTInc(num) = Data(Counter).TInc
                        AllPointsGDec(num) = Data(Counter).GDec
                        AllPointsGInc(num) = Data(Counter).GInc
                End If
            Next Counter
        End If
        Start = RecordHead.NextRec
    Next I
    If mnuSPlotTilt.Checked Then
'        mnuSPlotTilt.Checked = False
        Call SPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call SPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    ElseIf mnuSPlotGeographic.Checked Then
'        mnuSPlotGeographic.Checked = False
        Call SPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call SPlotAllPoints(AllPointsGDec(), AllPointsGInc(), num)
    ElseIf mnuEQPlotTilt.Checked Then
'        mnuEQPlotTilt.Checked = False
        Call EQPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call EQPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    ElseIf mnuEQPlotGeographic.Checked Then
'        mnuEQPlotGeographic.Checked = False
        Call EQPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call EQPlotAllPoints(AllPointsGDec(), AllPointsGInc(), num)
    Else
        frmSPlot.lblSPlot.Caption = "Lambert Equal-area Projection: Tilt-corrected"
        Call EQPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call EQPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    End If
End Sub

'Purpose:   To plot all qualified Data at T in the *.mag file.
'In the following "mnuAllSPlotAT", AT = Arbitrary Temperature.
Private Sub mnuAllSPlotAT_Click()
    Dim Message As String, Title As String, Temperature As Single
    Dim Start As Long, num As Long, Counter As Long, temp As String
    Dim I As Long   'As a counter, to change its value from 1 to Header.SampleNum
    Dim AllPointsTDec(1 To 500) As Single, AllPointsTInc(1 To 500) As Single
    Dim AllPointsGDec(1 To 500) As Single, AllPointsGInc(1 To 500) As Single
    
    Message = "Please enter a desired temperature for plotting:" & vbCrLf & _
            "e.g., 250, 300, 350, 400 degree, etc. "
    Title = "Temperature Selection"
    Do
        temp = InputBox(Message, Title)
    Loop Until IsNumeric(temp) = True Or temp = ""
    If temp = "" Then Exit Sub
    Temperature = CSng(temp)
    
    frmSPlot.Caption = "Right Panel: Projection of all samples using data at " & _
                        Format(Temperature, "0") & " degree"
    
    Call frmSPlot.picSPlot.Cls
    Call frmSPlot.Show
            
    num = 0
    Start = 2
    For I = 1 To Header.SampleNum
        Get #OpenFileNum, Start, RecordHead
        If RecordNames(I).Active = 1 Then
            For Counter = 1 To RecordHead.Number - 1
                Get #OpenFileNum, Start + Counter, Data(Counter)
                If (Data(Counter).DeMagLevel = Temperature) And _
                    (Data(Counter).Plot = 1) Then
                        num = num + 1
                        AllPointsTDec(num) = Data(Counter).TDec
                        AllPointsTInc(num) = Data(Counter).TInc
                        AllPointsGDec(num) = Data(Counter).GDec
                        AllPointsGInc(num) = Data(Counter).GInc
                End If
            Next Counter
        End If
        Start = RecordHead.NextRec
    Next I
    If mnuSPlotTilt.Checked Then
'        mnuSPlotTilt.Checked = False
        Call SPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call SPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    ElseIf mnuSPlotGeographic.Checked Then
'        mnuSPlotGeographic.Checked = False
        Call SPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call SPlotAllPoints(AllPointsGDec(), AllPointsGInc(), num)
    ElseIf mnuEQPlotTilt.Checked Then
'        mnuEQPlotTilt.Checked = False
        Call EQPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call EQPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    ElseIf mnuEQPlotGeographic.Checked Then
'        mnuEQPlotGeographic.Checked = False
        Call EQPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call EQPlotAllPoints(AllPointsGDec(), AllPointsGInc(), num)
    Else
        frmSPlot.lblSPlot.Caption = "Lambert Equal-area Projection: Tilt-corrected"
        Call EQPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call EQPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    End If
End Sub

'Purpose:   To plot all qualified Least Square Data in the *.mag file.
Private Sub mnuAllSPlotLSquare_Click()
    Dim Start As Long, num As Long
    Dim I As Long   'As a counter, to change its value from 1 to Header.SampleNum
    Dim AllPointsTDec(1 To 500) As Single, AllPointsTInc(1 To 500) As Single
    Dim AllPointsGDec(1 To 500) As Single, AllPointsGInc(1 To 500) As Single
    
    frmSPlot.Caption = "Right Panel: Projection of all samples using Least Square data"
    
    Call frmSPlot.picSPlot.Cls
    Call frmSPlot.Show
            
    num = 0
    Start = 2
    For I = 1 To Header.SampleNum
        Get #OpenFileNum, Start, RecordHead
        If RecordNames(I).Active = 1 Then
            If RecordHead.LSHead <> 0 Then
                Get #OpenFileNum, RecordHead.LSHead, AllLSData(I)
                If (AllLSData(I).Active = 1) And (AllLSData(I).Label = "N  " Or _
                    AllLSData(I).Label = "R  " Or AllLSData(I).Label = "NP " Or _
                    AllLSData(I).Label = "RP ") Then
                    num = num + 1
                    AllPointsTDec(num) = AllLSData(I).TDec
                    AllPointsTInc(num) = AllLSData(I).TInc
                    AllPointsGDec(num) = AllLSData(I).GDec
                    AllPointsGInc(num) = AllLSData(I).GInc
                End If
            End If
        End If
        Start = RecordHead.NextRec
    Next I
    If mnuSPlotTilt.Checked Then
'        mnuSPlotTilt.Checked = False
        Call SPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call SPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    ElseIf mnuSPlotGeographic.Checked Then
'        mnuSPlotGeographic.Checked = False
        Call SPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call SPlotAllPoints(AllPointsGDec(), AllPointsGInc(), num)
    ElseIf mnuEQPlotTilt.Checked Then
'        mnuEQPlotTilt.Checked = False
        Call EQPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call EQPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    ElseIf mnuEQPlotGeographic.Checked Then
'        mnuEQPlotGeographic.Checked = False
        Call EQPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call EQPlotAllPoints(AllPointsGDec(), AllPointsGInc(), num)
    Else
        frmSPlot.lblSPlot.Caption = "Lambert Equal-area Projection: Tilt-corrected"
        Call EQPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call EQPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    End If
End Sub

'Purpose:   To plot all NRM data in the *.mag file.
Private Sub mnuAllSPlotNRM_Click()
    Dim Start As Long, num As Long
    Dim I As Long   'As a counter, to change its value from 1 to Header.SampleNum
    Dim AllPointsTDec(1 To 500) As Single, AllPointsTInc(1 To 500) As Single
    Dim AllPointsGDec(1 To 500) As Single, AllPointsGInc(1 To 500) As Single
    
    frmSPlot.Caption = "Right Panel: Projection of all samples using NRM data"
    Call frmSPlot.picSPlot.Cls
    Call frmSPlot.Show
            
    num = 0
    Start = 2
    For I = 1 To Header.SampleNum
        Get #OpenFileNum, Start, RecordHead
        If RecordNames(I).Active = 1 Then
            For Counter = 1 To 6
                Get #OpenFileNum, Start + Counter, Data(Counter)
                If Data(Counter).DeMag = "NRM" And Data(Counter).Plot = 1 Then
                    num = num + 1
                    AllPointsTDec(num) = Data(Counter).TDec
                    AllPointsTInc(num) = Data(Counter).TInc
                    AllPointsGDec(num) = Data(Counter).GDec
                    AllPointsGInc(num) = Data(Counter).GInc
                End If
            Next Counter
        End If
        Start = RecordHead.NextRec
    Next I
       
    If mnuSPlotTilt.Checked Then
'        mnuSPlotTilt.Checked = False
        Call SPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call SPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    ElseIf mnuSPlotGeographic.Checked Then
'        mnuSPlotGeographic.Checked = False
        Call SPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call SPlotAllPoints(AllPointsGDec(), AllPointsGInc(), num)
    ElseIf mnuEQPlotTilt.Checked Then
'        mnuEQPlotTilt.Checked = False
        Call EQPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call EQPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    ElseIf mnuEQPlotGeographic.Checked Then
'        mnuEQPlotGeographic.Checked = False
        Call EQPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call EQPlotAllPoints(AllPointsGDec(), AllPointsGInc(), num)
    Else
        frmSPlot.lblSPlot.Caption = "Lambert Equal-area Projection: Tilt-corrected"
        Call EQPlotBackground
        frmSPlot.lblSPlot.Caption = frmSPlot.lblSPlot.Caption & " (All)"
        Call EQPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    End If
End Sub

'Purpose:   To copy selected information to the Clipboard.
Private Sub mnuEditCopy_Click()
    Dim temp As String, I As Integer
    
    Clipboard.Clear
    If TypeOf Screen.ActiveControl Is TextBox Then
        Clipboard.SetText Screen.ActiveControl.SelText
    ElseIf TypeOf Screen.ActiveControl Is ComboBox Then
        Clipboard.SetText Screen.ActiveControl.Text
    ElseIf TypeOf Screen.ActiveControl Is PictureBox Then
        Clipboard.SetData Screen.ActiveControl.Picture
    ElseIf TypeOf Screen.ActiveControl Is ListBox Then
        If Screen.ActiveControl = lstRecord Then
            For I = 0 To lstRecord.ListCount - 1
                If lstRecord.Selected(I) = True Then
                    temp = temp & lstRecord.List(I) & vbCrLf
                End If
            Next I
        ElseIf Screen.ActiveControl = lstRecordData Then
            For I = 0 To lstRecordData.ListCount - 1
                If lstRecordData.Selected(I) = True Then
                    temp = temp & lstRecordData.List(I) & vbCrLf
                End If
            Next I
        End If
        Clipboard.SetText temp
   Else
      ' No action makes sense for the other controls.
   End If
End Sub

'Purpose:   To do Lambert Equal-area projection using geographic data.
Public Sub mnuEQPlotGeographic_Click()
    If lstRecord.ListIndex = 0 Then Exit Sub 'Prevent crash when no sample is selected
    Call frmSPlot.picSPlot.Cls
    mnuEQPlotGeographic.Checked = Not (mnuEQPlotGeographic.Checked)
    If mnuEQPlotGeographic.Checked = False Then
        frmSPlot.lblSPlot.Caption = ""
        Exit Sub
    End If
    mnuEQPlotTilt.Checked = False
    mnuSPlotGeographic.Checked = False
    mnuSPlotTilt.Checked = False
    Call frmSPlot.Show
    Call EQPlotBackground
    Call EQPlotGeogDisplay(DemagStepNum)
End Sub

'Purpose:   To do Lambert Equal-area projection using Tilt-corrected data.
Public Sub mnuEQPlotTilt_Click()
    If lstRecord.ListIndex = 0 Then Exit Sub 'Prevent crash when no sample is selected
    Call frmSPlot.picSPlot.Cls
    mnuEQPlotTilt.Checked = Not (mnuEQPlotTilt.Checked)
    If mnuEQPlotTilt.Checked = False Then
        frmSPlot.lblSPlot.Caption = ""
        Exit Sub
    End If
    mnuEQPlotGeographic.Checked = False
    mnuSPlotGeographic.Checked = False
    mnuSPlotTilt.Checked = False
    Call frmSPlot.Show
    Call EQPlotBackground
    Call EQPlotTiltDisplay(DemagStepNum)
End Sub

'Purpose:   To close the Current .mag file and open/convert another file.
Private Sub mnuFileClose_Click()
    Close #OpenFileNum
    Call lstRecordData.Clear
    Unload frmSPlot
    Unload frmFisher
    Unload frmLSquare
    OpenFileName = ""
    frmMain.Caption = "Paleomagnetic Analysis Program - by Chunfu Zhang (July 2006)"
    mnuFileOpen.Enabled = True
    mnuFileConvert.Enabled = True
    mnuFileClose.Enabled = False
    mnuFilePrint.Enabled = False
    mnuZijGeographic.Checked = False
    mnuZijTilt.Checked = False
    mnuSPlotTilt.Checked = False
    mnuSPlotGeographic.Checked = False
    mnuEQPlotGeographic.Checked = False
    mnuEQPlotTilt.Checked = False
    Call HideMenus
    lstRecord.Visible = False
    lstRecord.Enabled = False
    lstRecordData.Visible = False
    lstRecordData.Enabled = False
    cmdDeselectPoints.Visible = False
    cmdLSquarePoints.Visible = False
    cmdDeactivate.Visible = False
End Sub

Private Sub mnuFileConvert_Click()
    Call frmFileConvert.Show
End Sub

'Purpose:   To Exit Paleomagnetic Analysis Program.
Private Sub mnuFileExit_Click()
    If OpenFileName <> "" And OpenFileNum <> 0 Then
        Close #OpenFileNum
    End If
    Unload frmFileOpen
    Unload frmFileConvert
    Unload frmSPlot
    Unload frmFisher
    Unload frmLSquare
    Unload frmHelp
    Unload frmAbout
    Unload frmCoorConv
    Unload frmProjections
    Unload frmPointsPlot
    Unload frmKono
    Unload frmMain
End Sub

Private Sub mnuFileOpen_Click()
    Call frmFileOpen.Show
End Sub

'Purpose:   To load the names of all records.
'Called from:   Private Sub Form_Click()
Private Sub LoadRecordNames(ByVal SampleNumber As Long, ByVal OpenFileNum As Long)
    Dim Start As Long
    Dim N As Long
    
    Start = 2
    For N = 1 To SampleNumber
        Get #OpenFileNum, Start, RecordHead
        RecordNames(N).Name = RecordHead.Name
        RecordNames(N).RecordNum = Start
        RecordNames(N).Active = RecordHead.Active
        Start = RecordHead.NextRec
    Next N
End Sub

'Purpose:   To load the data within one record
Private Sub LoadRecord(ByVal Start As Long, ByVal OpenFileNum As Long)
    Dim x As Long
    
    For x = Start + 1 To Start + RecordHead.Number
        Get #OpenFileNum, x, Data(x - Start)
    Next x
End Sub

'Purpose:   To hide menus not available when start up or when no files
'           are open.
Private Sub HideMenus()
    mnuEdit(1).Enabled = False
    mnuZijderveld(2).Enabled = False
    mnuStereoPlot(3).Enabled = False
    mnuEQPlot(4).Enabled = False
    mnuLeastSquare(5).Enabled = False
    mnuAll(6).Enabled = False
End Sub

'Purpose:   To show menus when a file is open.
Private Sub ShowMenus()
    mnuEdit(1).Enabled = True
    mnuZijderveld(2).Enabled = True
    mnuStereoPlot(3).Enabled = True
    mnuEQPlot(4).Enabled = True
    mnuLeastSquare(5).Enabled = True
    mnuAll(6).Enabled = True
End Sub

'Purpose:   To pass the filename from frmFileOpen to here.
Public Function GetOpenFileName(ByVal FileName As String) As String
    OpenFileName = FileName
End Function

'Print the Lambert Equal-Area Plot of all samples.
Private Sub mnuFilePrintAllEQPlot_Click()
    Dim BeginPage, EndPage, NumCopies, Orientation, I
    Dim Message As String, Title As String, temp As String
    
    Message = "Please select a data set for printing:" & vbCrLf & _
            "N/n:   NRM data" & vbCrLf & _
            "A/a:   AF  data" & vbCrLf & _
            "T/t:   TT  data" & vbCrLf & _
            "L/l:   Least Square data"
    Title = "Data Set Selection for Printing All Points"
    Do
        temp = UCase(InputBox(Message, Title))
    Loop Until temp = "N" Or temp = "A" Or temp = "T" Or temp = "L" Or temp = ""
    If temp = "" Then Exit Sub
        
    ' Set Cancel to True.
    dlgPrinter.CancelError = True
    On Error GoTo ErrHandler
    ' Display the Print dialog box.
    dlgPrinter.ShowPrinter
    ' Get user-selected values from the dialog box.
    BeginPage = dlgPrinter.FromPage
    EndPage = dlgPrinter.ToPage
    NumCopies = dlgPrinter.Copies
    Orientation = dlgPrinter.Orientation
    For I = 1 To NumCopies
        If temp = "N" Then
            Call PrintAllEQPlotNRM
        ElseIf temp = "A" Then
            Call PrintAllEQPlotAF
        ElseIf temp = "T" Then
            Call PrintAllEQPlotAT
        Else
            Call PrintAllEQPlotLSquare
        End If
    Next I
    Printer.EndDoc
    Exit Sub
ErrHandler:
    ' User pressed Cancel button.
    Exit Sub
End Sub

'Print the Stereographic Plot of all samples.
Private Sub mnuFilePrintAllSPlot_Click()
    Dim BeginPage, EndPage, NumCopies, Orientation, I
    Dim Message As String, Title As String, temp As String
    
    Message = "Please select a data set for printing:" & vbCrLf & _
            "N/n:   NRM data" & vbCrLf & _
            "A/a:   AF  data" & vbCrLf & _
            "T/t:   TT  data" & vbCrLf & _
            "L/l:   Least Square data"
    Title = "Data Set Selection for Printing All Points"
    Do
        temp = UCase(InputBox(Message, Title))
    Loop Until temp = "N" Or temp = "A" Or temp = "T" Or temp = "L" Or temp = ""
    If temp = "" Then Exit Sub
            
    ' Set Cancel to True.
    dlgPrinter.CancelError = True
    On Error GoTo ErrHandler
    ' Display the Print dialog box.
    dlgPrinter.ShowPrinter
    ' Get user-selected values from the dialog box.
    BeginPage = dlgPrinter.FromPage
    EndPage = dlgPrinter.ToPage
    NumCopies = dlgPrinter.Copies
    Orientation = dlgPrinter.Orientation
    For I = 1 To NumCopies
        If temp = "N" Then
            Call PrintAllSPlotNRM
        ElseIf temp = "A" Then
            Call PrintAllSPlotAF
        ElseIf temp = "T" Then
            Call PrintAllSPlotAT
        Else
            Call PrintAllSPlotLSquare
        End If
    Next I
    Printer.EndDoc
    Exit Sub
ErrHandler:
    ' User pressed Cancel button.
    Exit Sub
End Sub

'Print the Lambert Equal-Area Plot of a selected sample.
Private Sub mnuFilePrintEQPlot_Click()
    Dim BeginPage, EndPage, NumCopies, Orientation, I
    
    If lstRecord.ListIndex = 0 Then Exit Sub 'No sample selected
    
    ' Set Cancel to True.
    dlgPrinter.CancelError = True
    On Error GoTo ErrHandler
    ' Display the Print dialog box.
    dlgPrinter.ShowPrinter
    ' Get user-selected values from the dialog box.
    BeginPage = dlgPrinter.FromPage
    EndPage = dlgPrinter.ToPage
    NumCopies = dlgPrinter.Copies
    Orientation = dlgPrinter.Orientation
    For I = 1 To NumCopies
        If mnuEQPlotGeographic.Checked Then
            Call PrintEQPlotBackground
            Printer.CurrentX = CenterX - Radius
            Printer.CurrentY = CenterY - Radius - 1440
            Printer.Print "Lambert Equal-Area Projection: " & _
                RecordNames(lstRecord.ListIndex).Name & "- Geographic"
            Call PrintEQPlotGeog(DemagStepNum)
        ElseIf mnuEQPlotTilt.Checked Then
            Call PrintEQPlotBackground
            Printer.CurrentX = CenterX - Radius
            Printer.CurrentY = CenterY - Radius - 1440
            Printer.Print "Lambert Equal-Area Projection: " & _
                RecordNames(lstRecord.ListIndex).Name & "- Tilt-Corrected"
            Call PrintEQPlotTilt(DemagStepNum)
        Else
            mnuEQPlotTilt_Click
            Call PrintEQPlotBackground
            Printer.CurrentX = CenterX - Radius
            Printer.CurrentY = CenterY - Radius - 1440
            Printer.Print "Lambert Equal-Area Projection: " & _
                RecordNames(lstRecord.ListIndex).Name & "- Tilt-Corrected"
            Call PrintEQPlotTilt(DemagStepNum)
        End If
    Next
    Printer.EndDoc
    Exit Sub
ErrHandler:
    ' User pressed Cancel button.
    Exit Sub
End Sub

'Purpose:   To print the projection window.
Private Sub mnuFilePrintMain_Click()
    Dim BeginPage, EndPage, NumCopies, Orientation, I
    
    ' Set Cancel to True.
    dlgPrinter.CancelError = True
    On Error GoTo ErrHandler
    ' Display the Print dialog box.
    dlgPrinter.ShowPrinter
    ' Get user-selected values from the dialog box.
    BeginPage = dlgPrinter.FromPage
    EndPage = dlgPrinter.ToPage
    NumCopies = dlgPrinter.Copies
    Orientation = dlgPrinter.Orientation
    For I = 1 To NumCopies
    ' Put code here to send data to your printer.
        frmMain.PrintForm
    Next
    Printer.EndDoc
    Exit Sub
ErrHandler:
    ' User pressed Cancel button.
    Exit Sub
End Sub

'Print the Stereographic Plot of a selected sample.
Private Sub mnuFilePrintSPlot_Click()
    Dim BeginPage, EndPage, NumCopies, Orientation, I
    
    If lstRecord.ListIndex = 0 Then Exit Sub 'No sample selected
    
    ' Set Cancel to True.
    dlgPrinter.CancelError = True
    On Error GoTo ErrHandler
    ' Display the Print dialog box.
    dlgPrinter.ShowPrinter
    ' Get user-selected values from the dialog box.
    BeginPage = dlgPrinter.FromPage
    EndPage = dlgPrinter.ToPage
    NumCopies = dlgPrinter.Copies
    Orientation = dlgPrinter.Orientation
    For I = 1 To NumCopies
        If mnuSPlotGeographic.Checked Then
            Call PrintSPlotBackground
            Printer.CurrentX = CenterX - Radius
            Printer.CurrentY = CenterY - Radius - 1440
            Printer.Print "Stereographic Projection: " & _
                RecordNames(lstRecord.ListIndex).Name & "- Geographic"
            Call PrintSPlotGeog(DemagStepNum)
        ElseIf mnuSPlotTilt.Checked Then
            Call PrintSPlotBackground
            Printer.CurrentX = CenterX - Radius
            Printer.CurrentY = CenterY - Radius - 1440
            Printer.Print "Stereographic Projection: " & _
                RecordNames(lstRecord.ListIndex).Name & "- Tilt-Corrected"
            Call PrintSPlotTilt(DemagStepNum) 'Default to print Tilt-corrected data.
        Else
            mnuSPlotTilt_Click
            Call PrintSPlotBackground
            Printer.CurrentX = CenterX - Radius
            Printer.CurrentY = CenterY - Radius - 1440
            Printer.Print "Stereographic Projection: " & _
                RecordNames(lstRecord.ListIndex).Name & "- Tilt-Corrected"
            Call PrintSPlotTilt(DemagStepNum) 'Default to print Tilt-corrected data.
        End If
    Next
    Printer.EndDoc
    Exit Sub
ErrHandler:
    ' User pressed Cancel button.
    Exit Sub
End Sub

'Print the Zijderveld Plot of a selected sample.
Private Sub mnuFilePrintZPlot_Click()
    Dim BeginPage, EndPage, NumCopies, Orientation, I
    
    If lstRecord.ListIndex = 0 Then Exit Sub
    
    ' Set Cancel to True.
    dlgPrinter.CancelError = True
    On Error GoTo ErrHandler
    ' Display the Print dialog box.
    dlgPrinter.ShowPrinter
    ' Get user-selected values from the dialog box.
    BeginPage = dlgPrinter.FromPage
    EndPage = dlgPrinter.ToPage
    NumCopies = dlgPrinter.Copies
    Orientation = dlgPrinter.Orientation
    For I = 1 To NumCopies
        If ((mnuZijGeographic.Checked = False) And (mnuZijTilt.Checked = False)) Then
            mnuZijTilt_Click
        End If
        Call PrintZijderveldPlot(DemagStepNum)
    Next I
    Printer.EndDoc
    Exit Sub
ErrHandler:
    ' User pressed Cancel button.
    Exit Sub
End Sub

Private Sub mnuHelpAbout_Click()
    Call frmAbout.Show
End Sub

'To provide the help information for users who are not familiar with this program.
Private Sub mnuHelpMain_Click()
    Call frmHelp.Show
End Sub

'Purpose:   To display all the results of Least Square Analysis in frmLSquare.
Private Sub mnuLSAllResults_Click()
    Dim num As Long, SamNum(1 To 500) As Long, Start As Long, I As Long
    Dim temp As String, Counter As Long
    Dim Meters(1 To 500) As Single 'To store the meter levels of the samples selected
    
    num = 0
    Start = 2
    For I = 1 To Header.SampleNum
        Get #OpenFileNum, Start, RecordHead
        If RecordNames(I).Active = 1 Then
            If RecordHead.LSHead <> 0 Then
                num = num + 1
                SamNum(num) = I
                Meters(num) = RecordHead.Meters
                Get #OpenFileNum, RecordHead.LSHead, AllLSData(num)
            End If
        End If
        Start = RecordHead.NextRec
    Next I
    
    If num > 0 Then
        temp = "   Sample         Meters  Label   GDec   GInc    TDec   TInc " & _
            "Intensity  Error #Points"
        frmLSquare.txtLSResults.Text = temp & vbCrLf
        
        For I = 1 To num
            temp = LeftAlign(RecordNames(SamNum(I)).Name, 16) & _
                    RightAlign(Format(Meters(I), "0.00"), 8) & "  " & _
                    LeftAlign(AllLSData(I).Label, 4) & _
                    RightAlign(Format(AllLSData(I).GDec, "0.00"), 8) & _
                    RightAlign(Format(AllLSData(I).GInc, "0.00"), 7) & _
                    RightAlign(Format(AllLSData(I).TDec, "0.00"), 8) & _
                    RightAlign(Format(AllLSData(I).TInc, "0.00"), 7) & _
                    RightAlign(Format(AllLSData(I).Mag, "Scientific"), 10) & _
                    RightAlign(Format(AllLSData(I).Errer, "0.00"), 7) & _
                    RightAlign(Format(AllLSData(I).num, "0"), 6)
            frmLSquare.txtLSResults.Text = frmLSquare.txtLSResults.Text & _
                temp & vbCrLf
        Next I
        
        'Purpose:   To list the Temperature Steps used in LS Analysis.
        frmLSquare.txtLSResults.Text = frmLSquare.txtLSResults.Text & vbCrLf & _
            "******** (AF) Temperature Steps Used in Least Square Analysis ********" _
            & vbCrLf
        For I = 1 To num
            Start = RecordNames(SamNum(I)).RecordNum
            temp = LeftAlign(RecordNames(SamNum(I)).Name, 16)
            Get #OpenFileNum, Start, RecordHead
            DemagStepNum = RecordHead.Number
            For Counter = 1 To DemagStepNum - 1
                Get #OpenFileNum, Start + Counter, Data(Counter)
                If Data(Counter).LSquare = 1 Then
                    temp = temp & RightAlign(Format(Data(Counter).DeMagLevel, "0"), 5)
                End If
            Next Counter
            Get #OpenFileNum, Start + DemagStepNum, Data(Counter)
            If Data(Counter).LSquare = 1 Then
                temp = temp & "  Org Tied"
            End If
            frmLSquare.txtLSResults.Text = frmLSquare.txtLSResults.Text & _
                temp & vbCrLf
        Next I
    Else
        frmLSquare.txtLSResults.Text = "No Least Square Data Available!"
    End If
    Call frmLSquare.Show
End Sub

'Purpose:   To perform Least Square Analysis on selected analyses of a sample.
Private Sub mnuLSAnalysis_Click()
    Dim G(50) As Integer, num As Integer, N As Integer, LSnum As Integer
    Dim Anchor As Integer, Eror As Single
    Dim tot As Single, I As Integer
    Dim Message As String, Title As String, temp As String
    
    If lstRecord.ListIndex = 0 Then Exit Sub 'Prevent crash when no sample is selected
    
    'Purpose:   To get the Ns of analyses for Least Square Analysis, and store them
    '       in the array G().
    num = 0
    For N = 1 To RecordHead.Number
        If (Data(N).LSquare = 1) Then
            num = num + 1
            G(num) = N
        End If
    Next N
       
    If num > 0 Then
        LSnum = lstRecord.ListIndex     'LSnum = Sample Number
        Anchor = 0
        
        If Data(RecordHead.Number).LSquare = 1 Then
            LSInfo(LSnum).Tied = 1
            Anchor = 1
        Else
            LSInfo(LSnum).Tied = 0
        End If
    
        Message = "Please enter a label for the sample:" & vbCrLf & _
                "N or R - Good, full-weight " & vbCrLf & _
                "NP or RP - Fair, half-weight " & vbCrLf & _
                "NPP or RPP - Poor, not used in Fisher " & vbCrLf & _
                "N? or R? - Questionable polarity, not used " & vbCrLf & _
                "INT - Indeterminate, not used"
        Title = "Polarity Assignment and Rating"
        Do
            temp = UCase(InputBox(Message, Title))
        Loop Until temp = "N" Or temp = "R" Or temp = "NP" Or temp = "RP" _
            Or temp = "NPP" Or temp = "RPP" Or temp = "N?" Or temp = "R?" _
            Or temp = "INT" Or temp = ""
        If temp = "" Then Exit Sub
        LSInfo(LSnum).Label = temp
        
        RecordHead.LSHead = Header.Last + lstRecord.ListIndex - 1
        Put #OpenFileNum, RecordNames(lstRecord.ListIndex).RecordNum, _
            RecordHead
        
        If (num = 1) Or (((num = 2) And (Data(RecordHead.Number).LSquare = 1))) Then
            LSInfo(LSnum).Errer = 0
            LSInfo(LSnum).GDec = Data(G(1)).GDec
            LSInfo(LSnum).GInc = Data(G(1)).GInc
            LSInfo(LSnum).TDec = Data(G(1)).TDec
            LSInfo(LSnum).TInc = Data(G(1)).TInc
            GoTo Intensity
        End If
        
        Call CalcLeastSq(1, G(), num, Anchor, LSInfo(LSnum).GDec, LSInfo(LSnum).GInc, Eror)
        Call CalcLeastSq(0, G(), num, Anchor, LSInfo(LSnum).TDec, LSInfo(LSnum).TInc, _
            LSInfo(LSnum).Errer)
        
Intensity:
        If LSInfo(LSnum).Tied = 1 Then
            num = num - 1
        End If
        
        LSInfo(LSnum).num = num
        tot = 0
        If num > 0 Then
            For I = 1 To num
                tot = tot + Data(G(I)).Mag
            Next I
            LSInfo(LSnum).Mag = tot / num
        Else
            LSInfo(LSnum).Mag = 0
        End If
        LSInfo(LSnum).NextLs = 0
        LSInfo(LSnum).Active = 1
    '^^^^^ save header information (if this was the first least-square in set
    '    If LSnum = 0 Then
            Put #OpenFileNum, RecordHead.LSHead, LSInfo(LSnum)
    '    Else
    '        LSInfo(LSnum - 1).NextLs = Header.Last
    '    End If
    '^^^^^ print out LeastSquare and save it
    '    LSpos = LSnum
    '    Vector$ = Vector$ + "                                 "
    '    LSInfo(LSnum - 1).Vectors = LTrim$(Left$(Vector$, 32))
    '    SaveLS (LSnum - 1)
    '    Header.num = Header.num + 1: Put #1, 1, Header
    Else
        RecordHead.LSHead = 0
        Put #OpenFileNum, RecordNames(lstRecord.ListIndex).RecordNum, _
            RecordHead
    End If
    lstRecord_Click
End Sub

'Purpose:   To change the display from tilt-corrected to geographic.
Public Sub mnuSPlotGeographic_Click()
    If lstRecord.ListIndex = 0 Then Exit Sub 'Prevent crash when no sample is selected
    Call frmSPlot.picSPlot.Cls
    mnuSPlotGeographic.Checked = Not (mnuSPlotGeographic.Checked)
    If mnuSPlotGeographic.Checked = False Then
        frmSPlot.lblSPlot.Caption = ""
        Exit Sub
    End If
    mnuSPlotTilt.Checked = False
    mnuEQPlotTilt.Checked = False
    mnuEQPlotGeographic.Checked = False
    Call frmSPlot.Show
    Call SPlotBackground
    Call SPlotGeogDisplay(DemagStepNum)
End Sub

'Purpose:   To change the display from geographic to tilt-corrected.
Public Sub mnuSPlotTilt_Click()
    If lstRecord.ListIndex = 0 Then Exit Sub 'Prevent crash when no sample is selected
    Call frmSPlot.picSPlot.Cls
    mnuSPlotTilt.Checked = Not (mnuSPlotTilt.Checked)
    If mnuSPlotTilt.Checked = False Then
        frmSPlot.lblSPlot.Caption = ""
        Exit Sub
    End If
    mnuSPlotGeographic.Checked = False
    mnuEQPlotTilt.Checked = False
    mnuEQPlotGeographic.Checked = False
    Call frmSPlot.Show
    Call SPlotBackground
    Call SPlotTiltDisplay(DemagStepNum)
End Sub

'Purpose:   To display stereographic projection using Tilt-corrected data.
Public Sub SPlotTiltDisplay(ByVal SampleNum As Long)
    Dim Color As Long
    frmSPlot.lblSPlot = "Stereographic Projection: Tilt-corrected"
    PrevCounter = 0
    For Counter = 1 To SampleNum - 1
        If Data(Counter).LSquare = 1 Then
            Color = RGB(0, 255, 0)
        Else
            Color = RGB(255, 0, 0)
        End If
        If Data(Counter).Plot = 1 Then
            RSample = SPlotRadius(Radius, Abs(Data(Counter).TInc))
            Call DXDYCalc(DX, DY, RSample, Data(Counter).TDec)
            If Counter = 1 Then
                Call CurrXY(CurrX, CurrY)
                If Data(1).TInc < 0 Then
                    frmSPlot.picSPlot.Line (CurrX - 35, CurrY - 35)-Step(70, 70), , B
                Else
                    frmSPlot.picSPlot.Line (CurrX - 35, CurrY - 35)-Step(70, 70), , BF
                End If
                PrevCounter = Counter
            Else
                If PrevCounter <> 0 Then
                    Call ConnectPoints(Radius, Data(PrevCounter).TDec, _
                        Data(PrevCounter).TInc, Data(Counter).TDec, _
                        Data(Counter).TInc)
                    frmSPlot.picSPlot.Line (CurrX, CurrY)-(CenterX + DX, CenterY - DY), RGB(0, 0, 255)
                End If
                PrevCounter = Counter
                Call CurrXY(CurrX, CurrY)
                If Data(Counter).TInc < 0 Then
                    frmSPlot.picSPlot.Circle (CurrX, CurrY), 35, Color
                Else
                    frmSPlot.picSPlot.FillStyle = 0
                    frmSPlot.picSPlot.FillColor = Color
                    frmSPlot.picSPlot.Circle (CurrX, CurrY), 35, Color
                    frmSPlot.picSPlot.FillStyle = 1
                    frmSPlot.picSPlot.FillColor = frmSPlot.picSPlot.ForeColor
                End If
            End If
        End If
    Next Counter
End Sub

'Purpose:   To display stereographic projection using Geographic data.
Private Sub SPlotGeogDisplay(ByVal SampleNum As Long)
    Dim Color As Long
    frmSPlot.lblSPlot = "Stereographic Projection: Geographic"
    PrevCounter = 0
    For Counter = 1 To SampleNum - 1
        If Data(Counter).LSquare = 1 Then
            Color = RGB(0, 255, 0)
        Else
            Color = RGB(255, 0, 0)
        End If
        If Data(Counter).Plot = 1 Then
            RSample = SPlotRadius(Radius, Abs(Data(Counter).GInc))
            Call DXDYCalc(DX, DY, RSample, Data(Counter).GDec)
            If Counter = 1 Then
                Call CurrXY(CurrX, CurrY)
                If Data(1).GInc < 0 Then
                    frmSPlot.picSPlot.Line (CurrX - 35, CurrY - 35)-Step(70, 70), , B
                Else
                    frmSPlot.picSPlot.Line (CurrX - 35, CurrY - 35)-Step(70, 70), , BF
                End If
                PrevCounter = Counter
            Else
                If PrevCounter <> 0 Then
                    Call ConnectPoints(Radius, Data(PrevCounter).GDec, _
                        Data(PrevCounter).GInc, Data(Counter).GDec, _
                        Data(Counter).GInc)
                    frmSPlot.picSPlot.Line (CurrX, CurrY)-(CenterX + DX, CenterY - DY), RGB(0, 0, 255)
                End If
                PrevCounter = Counter
                Call CurrXY(CurrX, CurrY)
                If Data(Counter).GInc < 0 Then
                    frmSPlot.picSPlot.Circle (CurrX, CurrY), 35, Color
                Else
                    frmSPlot.picSPlot.FillStyle = 0
                    frmSPlot.picSPlot.FillColor = Color
                    frmSPlot.picSPlot.Circle (CurrX, CurrY), 35, Color
                    frmSPlot.picSPlot.FillStyle = 1
                    frmSPlot.picSPlot.FillColor = frmSPlot.picSPlot.ForeColor
                End If
            End If
        End If
    Next Counter
End Sub

'Purpose:   To calculate DX and DY for stereographic projection.
'Theta:     Declination of Sample, i.e., from North to sample clockwise.
Private Sub DXDYCalc(ByRef DX As Single, ByRef DY As Single, _
    ByVal RSample As Single, ByVal Theta As Single)
            DX = RSample * Sin(DegToRad(Theta))
            DY = RSample * Cos(DegToRad(Theta))
End Sub

'Purpose:   To calculate the coordinates of the Current point to be plotted
Private Sub CurrXY(ByRef CurrX As Single, ByRef CurrY As Single)
    CurrX = CenterX + DX
    CurrY = CenterY - DY
End Sub

'Purpose:   To connect two points in Stereographic Projection or
'           Lambert Equal-area Projection
'Radius:    Radius of the projection circle.
'AngleDec1 & AngleDec2: Declination of the first and second points.
'AngleInc1 & AngleInc2: Inclination of the first and second points.
Private Sub ConnectPoints(ByVal Radius As Single, _
    ByVal AngleDec1 As Single, ByVal AngleInc1 As Single, _
    ByVal AngleDec2 As Single, ByVal AngleInc2 As Single)
       
    Dim I As Integer, StepNumber As Integer
    Dim X1 As Single, Y1 As Single, Z1 As Single
    Dim X2 As Single, Y2 As Single, Z2 As Single
    Dim StepX As Single, StepY As Single, StepZ As Single
    Dim DecPoint As Single, IncPoint As Single
    
    
    Call XYZFromDecInc(X1, Y1, Z1, Radius, AngleDec1, AngleInc1)
    Call XYZFromDecInc(X2, Y2, Z2, Radius, AngleDec2, AngleInc2)
    StepNumber = 100         'Number of Steps from (X1, Y1, Z1) to (X2, Y2, Z2)
    StepX = (X2 - X1) / StepNumber
    StepY = (Y2 - Y1) / StepNumber
    StepZ = (Z2 - Z1) / StepNumber
    For I = 1 To 99
        Call XYZToDecInc(X1 + I * StepX, Y1 + I * StepY, Z1 + I * StepZ, _
            DecPoint, IncPoint)
        If mnuSPlotGeographic.Checked Or mnuSPlotTilt.Checked Then
            RSample = SPlotRadius(Radius, Abs(IncPoint))
        ElseIf mnuEQPlotGeographic.Checked Or mnuEQPlotTilt.Checked Then
            RSample = EQPlotRadius(Radius, Abs(IncPoint))
        End If
        Call DXDYCalc(DX, DY, RSample, DecPoint)
        Call CurrXY(CurrX, CurrY)
        frmSPlot.picSPlot.Line -(CurrX, CurrY), RGB(0, 0, 255)
    Next I
End Sub

'Purpose:   To display the background of Lambert Equal-area projection.
Private Sub EQPlotBackground()
    Dim Inclination As Single
    Dim Theta As Single
    
    If frmSPlot.picSPlot.ScaleWidth > frmSPlot.picSPlot.ScaleHeight Then
        Radius = (frmSPlot.picSPlot.ScaleHeight - 720) / 2
    Else
        Radius = (frmSPlot.picSPlot.ScaleWidth - 720) / 2
    End If
    
    CenterX = frmSPlot.picSPlot.ScaleWidth / 2
    CenterY = frmSPlot.picSPlot.ScaleHeight / 2
    
    frmSPlot.picSPlot.Circle (CenterX, CenterY), Radius
    For Inclination = 10 To 80 Step 10
        frmSPlot.picSPlot.Circle (CenterX, CenterY), EQPlotRadius(Radius, Inclination)
    Next Inclination
    For Theta = 0 To 170 Step 10
        frmSPlot.picSPlot.Line (CenterX + Radius * Cos(DegToRad(Theta)), _
            CenterY + Radius * Sin(DegToRad(Theta)))- _
            (CenterX - Radius * Cos(DegToRad(Theta)), _
            CenterY - Radius * Sin(DegToRad(Theta)))
    Next Theta
    frmSPlot.picSPlot.CurrentX = CenterX - 100
    frmSPlot.picSPlot.CurrentY = CenterY - Radius - 280
    frmSPlot.picSPlot.Print "N"
    frmSPlot.picSPlot.CurrentX = CenterX + Radius + 40
    frmSPlot.picSPlot.CurrentY = CenterY - 120
    frmSPlot.picSPlot.Print "E"
    frmSPlot.picSPlot.CurrentX = CenterX - 100
    frmSPlot.picSPlot.CurrentY = CenterY + Radius + 30
    frmSPlot.picSPlot.Print "S"
    frmSPlot.picSPlot.CurrentX = CenterX - Radius - 260
    frmSPlot.picSPlot.CurrentY = CenterY - 120
    frmSPlot.picSPlot.Print "W"
End Sub

'Purpose:   To display Lambert Equal-area projection using Geographic data.
Private Sub EQPlotGeogDisplay(ByVal SampleNum As Long)
    Dim Color As Long
    frmSPlot.lblSPlot = "Lambert Equal-area Projection: Geographic"
    PrevCounter = 0
    For Counter = 1 To SampleNum - 1
        If Data(Counter).LSquare = 1 Then
            Color = RGB(0, 255, 0)
        Else
            Color = RGB(255, 0, 0)
        End If
        If Data(Counter).Plot = 1 Then
            RSample = EQPlotRadius(Radius, Abs(Data(Counter).GInc))
            Call DXDYCalc(DX, DY, RSample, Data(Counter).GDec)
            If Counter = 1 Then
                Call CurrXY(CurrX, CurrY)
                If Data(1).GInc < 0 Then
                    frmSPlot.picSPlot.Line (CurrX - 35, CurrY - 35)-Step(70, 70), , B
                Else
                    frmSPlot.picSPlot.Line (CurrX - 35, CurrY - 35)-Step(70, 70), , BF
                End If
                PrevCounter = Counter
            Else
                If PrevCounter <> 0 Then
                    Call ConnectPoints(Radius, Data(PrevCounter).GDec, _
                        Data(PrevCounter).GInc, Data(Counter).GDec, Data(Counter).GInc)
                    frmSPlot.picSPlot.Line (CurrX, CurrY)-(CenterX + DX, CenterY - DY), _
                        RGB(0, 0, 255)
                End If
                PrevCounter = Counter
                Call CurrXY(CurrX, CurrY)
                If Data(Counter).GInc < 0 Then
                    frmSPlot.picSPlot.Circle (CurrX, CurrY), 35, Color
                Else
                    frmSPlot.picSPlot.FillStyle = 0
                    frmSPlot.picSPlot.FillColor = Color
                    frmSPlot.picSPlot.Circle (CurrX, CurrY), 35, Color
                    frmSPlot.picSPlot.FillStyle = 1
                    frmSPlot.picSPlot.FillColor = frmSPlot.picSPlot.ForeColor
                End If
            End If
        End If
    Next Counter
End Sub

'Purpose:   To display Lambert Equal-area projection using Tilt-corrected data.
Private Sub EQPlotTiltDisplay(ByVal SampleNum As Long)
    Dim Color As Long
    PrevCounter = 0
    frmSPlot.lblSPlot = "Lambert Equal-area Projection: Tilt-corrected"
    For Counter = 1 To SampleNum - 1
        If Data(Counter).LSquare = 1 Then
            Color = RGB(0, 255, 0)
        Else
            Color = RGB(255, 0, 0)
        End If
        If Data(Counter).Plot = 1 Then
            RSample = EQPlotRadius(Radius, Abs(Data(Counter).TInc))
            Call DXDYCalc(DX, DY, RSample, Data(Counter).TDec)
            If Counter = 1 Then
                Call CurrXY(CurrX, CurrY)
                If Data(1).TInc < 0 Then
                    frmSPlot.picSPlot.Line (CurrX - 35, CurrY - 35)-Step(70, 70), , B
                Else
                    frmSPlot.picSPlot.Line (CurrX - 35, CurrY - 35)-Step(70, 70), , BF
                End If
                PrevCounter = Counter
            Else
                If PrevCounter <> 0 Then
                    Call ConnectPoints(Radius, Data(PrevCounter).TDec, _
                        Data(PrevCounter).TInc, Data(Counter).TDec, Data(Counter).TInc)
                    frmSPlot.picSPlot.Line (CurrX, CurrY)-(CenterX + DX, CenterY - DY), _
                        RGB(0, 0, 255)
                End If
                PrevCounter = Counter
                Call CurrXY(CurrX, CurrY)
                If Data(Counter).TInc < 0 Then
                    frmSPlot.picSPlot.Circle (CurrX, CurrY), 35, Color
                Else
                    frmSPlot.picSPlot.FillStyle = 0
                    frmSPlot.picSPlot.FillColor = Color
                    frmSPlot.picSPlot.Circle (CurrX, CurrY), 35, Color
                    frmSPlot.picSPlot.FillStyle = 1
                    frmSPlot.picSPlot.FillColor = frmSPlot.picSPlot.ForeColor
                End If
            End If
        End If
    Next Counter
End Sub

'Purpose:   To perform Zijderveld Projection.
Private Sub ZijderveldPlot(ByVal SampleNum As Long)
    'DecX(1 to 50), DecY(1 to 50): Declination converted to x and y.
    Dim DecX(1 To 50) As Single, DecY(1 To 50) As Single
    
    'IncX(1 to 50), IncY(1 to 50): Inclination converted to x and y.
    Dim IncX(1 To 50) As Single, IncY(1 To 50) As Single
    
    Dim ScaleLength As Single      'Scale Length of one tick mark
    Dim ScaleTwips As Single      'Screen Scale Length (in twips) of one tick mark
    Dim TickNum As Integer              'Number of Tick Marks Needed
    Dim N As Integer                    '
    Dim Range As Single                 'Range of X and Y Data
    Dim PlotLS(1 To 50) As Integer      '????
    Dim NumPlot As Integer              'Number of plotable points
    Dim HorizontalVector As Double      'Horizontal Component of the Demag Vector
    Dim MinX As Single, MaxX As Single, MinY As Single, MaxY As Single
    Dim I As Integer
    Dim DX As Single, DY As Single, CurrDX As Single, CurrDY As Single
    Dim IX As Single, IY As Single, CurrIX As Single, CurrIY As Single
    Dim PrevDX As Single, PrevDY As Single, PrevIX As Single, PrevIY As Single
    Dim DecColor As ColorConstants, IncColor As ColorConstants
    
    If mnuZijGeographic.Checked Then
        If mnuZijModified.Checked Then
            frmSPlot.lblZPlot.Caption = "Modified Zijderveld Progressive Demagnetization Diagram : Geographic"
        Else
            frmSPlot.lblZPlot.Caption = "Zijderveld Progressive Demagnetization Diagram : Geographic"
        End If
    Else
        If mnuZijModified.Checked Then
            frmSPlot.lblZPlot.Caption = "Modified Zijderveld Progressive Demagnetization Diagram : Tilt-corrected"
        Else
            frmSPlot.lblZPlot.Caption = "Zijderveld Progressive Demagnetization Diagram : Tilt-corrected"
        End If
    End If
    
    
    If mnuZijModified.Checked Then  'For Modified Zijderveld Projection: "N" up (same as convention)
        For I = 1 To SampleNum - 1
            If Data(I).Plot = 1 Then
                'If ZPlotGeographic is checked
                'Horizontal Component
                If mnuZijGeographic.Checked Then
                    HorizontalVector = Data(I).Mag * Cos(DegToRad(Data(I).GInc))
                    DecX(I) = HorizontalVector * Sin(DegToRad(Data(I).GDec))
                    DecY(I) = -HorizontalVector * Cos(DegToRad(Data(I).GDec))
                    'Vertical Component:
                    If RecordHead.Theta = -2 Then   'No Projection
                        IncX(I) = Data(I).Mag * Cos(DegToRad(Data(I).GInc))
                    Else    'Projection Plane = RecordHead.Theta
                        IncX(I) = Data(I).Mag * Cos(DegToRad(Data(I).GInc)) _
                                    * Cos(DegToRad(Data(I).GDec - RecordHead.Theta))
                    End If
                    IncY(I) = Data(I).Mag * Sin(DegToRad(Data(I).GInc))
                    Call FindMaxMin(MinX, MaxX, MinY, MaxY, DecX(I), DecY(I), IncX(I), IncY(I))
            
                'If ZPlotTilt is checked
                'Horizontal Component
                ElseIf mnuZijTilt.Checked Then
                    HorizontalVector = Data(I).Mag * Cos(DegToRad(Data(I).TInc))
                    DecX(I) = HorizontalVector * Sin(DegToRad(Data(I).TDec))
                    DecY(I) = -HorizontalVector * Cos(DegToRad(Data(I).TDec))
                    'Vertical Component:
                    If RecordHead.Theta = -2 Then   'No Projection
                        IncX(I) = Data(I).Mag * Cos(DegToRad(Data(I).TInc))
                    Else    'Projection Plane = RecordHead.Theta
                        IncX(I) = Data(I).Mag * Cos(DegToRad(Data(I).TInc)) _
                                    * Cos(DegToRad(Data(I).TDec - RecordHead.Theta))
                    End If
                    IncY(I) = Data(I).Mag * Sin(DegToRad(Data(I).TInc))
                    Call FindMaxMin(MinX, MaxX, MinY, MaxY, DecX(I), DecY(I), IncX(I), IncY(I))
                End If
            End If
        Next I
    Else    'For Zijderveld Projection: "N" to the right (conventionally East)
        For I = 1 To SampleNum - 1
            If Data(I).Plot = 1 Then
                'If ZPlotGeographic is checked
                'Horizontal Component
                If mnuZijGeographic.Checked Then
                    HorizontalVector = Data(I).Mag * Cos(DegToRad(Data(I).GInc))
                    DecY(I) = HorizontalVector * Sin(DegToRad(Data(I).GDec))
                    DecX(I) = HorizontalVector * Cos(DegToRad(Data(I).GDec))
                    'Vertical Component:
                    If RecordHead.Theta = -2 Then   'No Projection
                        IncX(I) = Data(I).Mag * Cos(DegToRad(Data(I).GInc))
                    Else    'Projection Plane = RecordHead.Theta
                        IncX(I) = Data(I).Mag * Cos(DegToRad(Data(I).GInc)) _
                                    * Cos(DegToRad(Data(I).GDec - RecordHead.Theta))
                    End If
                    IncY(I) = Data(I).Mag * Sin(DegToRad(Data(I).GInc))
                    Call FindMaxMin(MinX, MaxX, MinY, MaxY, DecX(I), DecY(I), IncX(I), IncY(I))
            
                'If ZPlotTilt is checked
                'Horizontal Component
                ElseIf mnuZijTilt.Checked Then
                    HorizontalVector = Data(I).Mag * Cos(DegToRad(Data(I).TInc))
                    DecY(I) = HorizontalVector * Sin(DegToRad(Data(I).TDec))
                    DecX(I) = HorizontalVector * Cos(DegToRad(Data(I).TDec))
                    'Vertical Component:
                    If RecordHead.Theta = -2 Then   'No Projection
                        IncX(I) = Data(I).Mag * Cos(DegToRad(Data(I).TInc))
                    Else    'Projection Plane = RecordHead.Theta
                        IncX(I) = Data(I).Mag * Cos(DegToRad(Data(I).TInc)) _
                                    * Cos(DegToRad(Data(I).TDec - RecordHead.Theta))
                    End If
                    IncY(I) = Data(I).Mag * Sin(DegToRad(Data(I).TInc))
                    Call FindMaxMin(MinX, MaxX, MinY, MaxY, DecX(I), DecY(I), IncX(I), IncY(I))
                End If
            End If
        Next I
    End If
   
    If mnuZijGeographic.Checked Or mnuZijTilt.Checked Then
        'Purpose:   To determine number of tick marks needed.
        'Tick mark numbers: minimum - 8, maximum - 20.
        Call FindRange(Range, MinX, MaxX, MinY, MaxY)
        ScaleLength = FindScaleLength(Range)
        TickNum = Int(Range / ScaleLength) + 2
        ScaleTwips = (frmSPlot.picZPlot.ScaleWidth - 1000) / TickNum
        
        'Purpose:   To find the origin on the plot.
        If MinX < 0 Then
            If MaxX < 0 Then
                OriginX = frmSPlot.picZPlot.ScaleWidth - 1000
            Else
                OriginX = ScaleTwips * (Int(Abs(MinX / ScaleLength)) + 1) + 600
            End If
        Else    'MinX>0
            OriginX = 1000
        End If
        If MinY < 0 Then
            If MaxY < 0 Then
                OriginY = frmSPlot.picZPlot.ScaleHeight - 1000
            Else
                OriginY = ScaleTwips * (Int(Abs(MinY) / ScaleLength) + 1) + 600
            End If
        Else
            OriginY = 1000
        End If
        
        If mnuZijModified.Checked Then
            Call DrawZPlotAxes_Modified(OriginX, OriginY, ScaleTwips, ScaleLength, _
                RecordHead.Theta)
        Else
            Call DrawZPlotAxes(OriginX, OriginY, ScaleTwips, ScaleLength, _
                RecordHead.Theta)
        End If
        
        'Purpose:    To display the points on Zijderveld Plot.
        PrevDX = 100000
        PrevDY = 100000
        PrevIX = 100000
        PrevIY = 100000
        For I = 1 To SampleNum - 1
            If Data(I).Plot = 1 Then
                If Data(I).LSquare = 1 Then
                    DecColor = RGB(255, 0, 255)
                    IncColor = vbGreen
                Else
                    DecColor = vbRed
                    IncColor = vbBlue
                End If
                DX = DecX(I) / ScaleLength * ScaleTwips
                DY = DecY(I) / ScaleLength * ScaleTwips
                CurrDX = OriginX + DX
                CurrDY = OriginY + DY
                
                IX = IncX(I) / ScaleLength * ScaleTwips
                IY = IncY(I) / ScaleLength * ScaleTwips
                CurrIX = OriginX + IX
                CurrIY = OriginY + IY
                
                If I = 1 Then   'Plot the first point with square symble
                    frmSPlot.picZPlot.Line (CurrDX - 35, CurrDY - 35)-Step(70, 70), _
                        RGB(255, 0, 0), BF
                    frmSPlot.picZPlot.Line (CurrIX - 35, CurrIY - 35)-Step(70, 70), _
                        RGB(0, 0, 255), BF
                    PrevDX = CurrDX
                    PrevDY = CurrDY
                    PrevIX = CurrIX
                    PrevIY = CurrIY
                Else
                    If PrevDX <> 100000 And PrevDY <> 100000 Then
                        frmSPlot.picZPlot.Line (PrevDX, PrevDY)-(CurrDX, CurrDY), _
                            RGB(255, 0, 0)
                    End If
'                    frmSPlot.picZPlot.Circle (CurrDX, CurrDY), 35, RGB(255, 0, 0) 'Original
                    frmSPlot.picZPlot.FillStyle = 0
                    frmSPlot.picZPlot.FillColor = DecColor

                    frmSPlot.picZPlot.Circle (CurrDX, CurrDY), 35, DecColor
                    If PrevIX <> 100000 And PrevIY <> 100000 Then
                        frmSPlot.picZPlot.Line (PrevIX, PrevIY)-(CurrIX, _
                            CurrIY), RGB(0, 0, 255)
                    End If
                    frmSPlot.picZPlot.FillColor = IncColor
                    frmSPlot.picZPlot.Circle (CurrIX, CurrIY), 35, IncColor
                    frmSPlot.picZPlot.FillStyle = 1
                    PrevDX = CurrDX
                    PrevDY = CurrDY
                    PrevIX = CurrIX
                    PrevIY = CurrIY
                End If
            End If
        Next I
    End If
End Sub


Private Sub mnuToolboxCoorConv_Click()
    Call frmCoorConv.Show
    Call frmCoorConv.txtDeclination.SetFocus
End Sub

Private Sub mnuToolboxKonoLatCalc_Click()
    Call frmKono.Show
    Call frmKono.txtData.SetFocus
End Sub

Private Sub mnuToolboxLatCal_Click()
    Call frmCoorConv.Show
    Call frmCoorConv.txtInclination2.SetFocus
End Sub

Private Sub mnuToolboxPointProj_Click()
    Call frmProjections.Show
End Sub

'Purpose:   Perform Zijderveld Plot using Geographic Data.
Public Sub mnuZijGeographic_Click()
    If lstRecord.ListIndex = 0 Then
        Exit Sub 'Prevent crash when no sample is selected
    End If
    Call frmSPlot.picZPlot.Cls
    mnuZijGeographic.Checked = Not (mnuZijGeographic.Checked)
    If mnuZijGeographic.Checked = False Then
        frmSPlot.lblZPlot.Caption = ""
        Exit Sub
    End If
    mnuZijTilt.Checked = False
    Call frmSPlot.Show
    Call ZijderveldPlot(DemagStepNum)
End Sub

'Purpose: To provide modified Zijderveld Plot function as some people may prefer
Private Sub mnuZijModified_Click()
    If mnuZijModified.Checked Then
        mnuZijModified.Checked = False
    Else
        mnuZijModified.Checked = True
    End If
    
    If mnuZijGeographic.Checked Then
        mnuZijGeographic.Checked = False
        mnuZijGeographic_Click
    ElseIf mnuZijTilt.Checked Then
        mnuZijTilt.Checked = False
        mnuZijTilt_Click
    End If
End Sub

'Purpose:   To let the user select any projection plane
'       to plot the vertical component.
Private Sub mnuZijProjectionPlane_Click()
    Dim Message As String, Title As String, temp As String
    
    Message = "Please input the declination of the" & vbCrLf & _
              "projection plane: 0-360 (degree)." & vbCrLf & _
              "To change back to default (No Projection)," & vbCrLf & _
              "please input: -2"
    Title = "Projection Plane Dialogbox"
    Do
        temp = InputBox(Message, Title)
    Loop Until IsNumeric(temp) = True Or temp = ""
    If temp = "" Then Exit Sub
    RecordHead.Theta = CLng(temp)
    Put #OpenFileNum, RecordNames(lstRecord.ListIndex).RecordNum, RecordHead
    lstRecord_Click
End Sub

'Purpose:   Perform Zijderveld Plot using Tilt-corrected Data.
Public Sub mnuZijTilt_Click()
    If lstRecord.ListIndex = 0 Then
        Exit Sub 'Prevent crash when no sample is selected
    End If
    Call frmSPlot.picZPlot.Cls
    mnuZijTilt.Checked = Not (mnuZijTilt.Checked)
    If mnuZijTilt.Checked = False Then
        frmSPlot.lblZPlot.Caption = ""
        Exit Sub
    End If
    mnuZijGeographic.Checked = False
    Call frmSPlot.Show
    Call ZijderveldPlot(DemagStepNum)
End Sub


Private Sub CalcLeastSq(ByRef GEO As Integer, ByRef G() As Integer, _
    ByRef h As Integer, ByRef Anchor As Integer, ByRef Dec As Single, _
    ByRef Inc As Single, ByRef Eror As Single)
'****************************************************************************
'**
'**         Module:
'**            LeastSq.bas - CalcLeastSq
'**
'**         Purpose:
'**            Compute N,I and Z values from dec. & inc. inputs.
'**            Calculate eigenvalues and eigenvectors (see discussion later).
'**               GEO = geographic (if "1") or tilt-corrected
'**               G() = ???
'**               h = number of points ???
'**               Anchor = "1" if anchored to Origin
'**               dec, inc = mean direction (vector through points)
'**               Eror = circular standard deviation on mean direction
'**
'**         Called from:
'**            Calc        - in LeastSq.bas
'**
'**         Subroutines called:
'**            none
'**
'****************************************************************************
'    CurrentSub = "CalcLeastSq"
    Dim GN(50) As Single, GE(50) As Single, GZ(50) As Single, PS(50)  As Single
    Dim AG(3, 3) As Single, A(3, 3) As Single, s(3, 3) As Single
    Dim B(3, 3) As Single, t(3, 3) As Single
    Dim N As Integer, PGN As Single, PGE As Single, PGZ As Single
    Dim ID As Single, NI As Single, NF As Single, TH As Single
    Dim l As Single, M As Single, O As Single, Z As Single
    Dim ST As Single, CT As Single
    Dim I As Integer, J As Integer, II As Integer, K As Integer, f As Integer
    Dim P As Integer, q As Integer
    Dim L1 As Single, L2 As Single, L3 As Single
    Dim XC As Single, YC As Single, ZC As Single
    Dim V7 As Single, V8 As Single, V9 As Single
    Dim Magnitude As Single, UpDown As Single
    Dim Dpt As Single, Ipt As Single
' compute N,E,Z components from D,I
    For N = 1 To RecordHead.Number
        Magnitude = 1000000 * Data(N).Mag      '** to avoid very small fractions
        If (GEO = 1) Then          '** case of geographic (not tilt-corrected)
            Dpt = DegToRad(Data(N).GDec)
            Ipt = DegToRad(Data(N).GInc)
        Else
            Dpt = DegToRad(Data(N).TDec)
            Ipt = DegToRad(Data(N).TInc)
        End If
        GN(N) = Magnitude * Cos(Dpt) * Cos(Ipt)
        GE(N) = Magnitude * Cos(Ipt) * Sin(Dpt)
        GZ(N) = Magnitude * Sin(Ipt)
    Next
'^^^^^ now begin the grunge
'       initialize variables
    PGN = 0
    PGE = 0
    PGZ = 0
    For I = 1 To 3
        For J = 1 To 3
            AG(I, J) = 0
        Next J
    Next I
'^^^^^ find centroid -- if Un-Anchored
    If Anchor = 0 Then
         For I = 1 To h
            PGN = GN(G(I)) + PGN
            PGE = GE(G(I)) + PGE
            PGZ = GZ(G(I)) + PGZ
         Next I
         PGN = PGN / h
         PGE = PGE / h
         PGZ = PGZ / h
     End If
'^^^^^  generate matrix of sums and squares and products
     For I = 1 To h:
        AG(1, 1) = AG(1, 1) + (GN(G(I)) - PGN) ^ 2
        AG(1, 2) = AG(1, 2) + (GN(G(I)) - PGN) * (GE(G(I)) - PGE)
        AG(1, 3) = AG(1, 3) + (GN(G(I)) - PGN) * (GZ(G(I)) - PGZ)
        AG(2, 2) = AG(2, 2) + (GE(G(I)) - PGE) ^ 2
        AG(2, 3) = AG(2, 3) + (GE(G(I)) - PGE) * (GZ(G(I)) - PGZ)
        AG(3, 3) = AG(3, 3) + (GZ(G(I)) - PGZ) ^ 2
     Next I
     For I = 1 To 3
        For J = 1 To 3
            If I > J Then
                A(I, J) = AG(J, I)
            Else
                A(I, J) = AG(I, J)
            End If
        Next J
    Next I
'****************************************************************************
'                    *** Find EigenValues and Vectors ***
'Subroutine to extract eigenvales and eigenvectors is lifted from
'  "Mathematical Methods of Digital Computers" (Chap. 7) with slight
'  changes for N x N matrix.
'The input matrix is A(3,3), which is destroyed to form the eigenvalues on
'  the diagonal.  The matrix S(3,3) is returned with the eigenvectors.
'****************************************************************************
    For J = 1 To 3
        For I = 1 To 3
            If I <> J Then s(I, J) = 0 Else s(I, J) = 1
        Next I
    Next J
    ID = 0
    NI = Sqr(2 * A(1, 2) ^ 2 + 2 * A(1, 3) ^ 2 + 2 * A(2, 3) ^ 2)
    NF = NI * 10 ^ -9 / 3
    TH = NI
S4:
    TH = TH / 3
S5:
    For q = 2 To 3
        For P = 1 To q - 1
            If Abs(A(P, q)) < TH Then GoTo S6
            ID = 1
            l = -A(P, q)
            M = (A(P, P) - A(q, q)) / 2
            If M < 0 Then Z = -1 Else Z = 1
            O = Z * l / Sqr(l * l + M * M)
            ST = O / Sqr(2 * (1 + Sqr(1 - O * O)))
            CT = Sqr(1 - ST * ST)
            For I = 1 To 3
                B(I, P) = A(I, P) * CT - A(I, q) * ST
                B(I, q) = A(I, P) * ST + A(I, q) * CT
                t(I, P) = s(I, P) * CT - s(I, q) * ST
                t(I, q) = s(I, P) * ST + s(I, q) * CT
                A(I, P) = B(I, P): A(I, q) = B(I, q)
                s(I, P) = t(I, P): s(I, q) = t(I, q)
            Next I
            B(P, P) = A(P, P) * CT - A(q, P) * ST
            B(q, q) = A(P, q) * ST + A(q, q) * CT
            B(P, q) = A(P, q) * CT - A(q, q) * ST
            B(q, P) = A(P, P) * ST + A(q, P) * CT
            A(P, P) = B(P, P): A(q, q) = B(q, q)
            A(q, P) = B(q, P): A(P, q) = B(P, q)
            For I = 1 To 3
                A(P, I) = A(I, P)
                A(q, I) = A(I, q)
            Next I
S6:
        Next P
    Next q
'   IF ID = 1 THEN ID = 0: GOTO S5
    If TH > NF Then GoTo S4
    For J = 1 To 3
        For I = 1 To 3
            If Abs(A(I, J)) < TH Then A(I, J) = 0
        Next I
    Next J
'^^^^^ sort eigenvectors and eigenvalues
    For II = 1 To 3
'     find Max eigenvalue
        If (A(II, II) >= A(1, 1)) And (A(II, II) >= A(2, 2)) And _
            (A(II, II) >= A(3, 3)) Then I = II
'     find Min eigenvalue
        If (A(II, II) <= A(1, 1)) And (A(II, II) <= A(2, 2)) And _
            (A(II, II) <= A(3, 3)) Then K = II
    Next II
    J = 6 - I - K
'^^^^^ compute standard deviation   [EROR = 0 if have 2 points]
    L1 = A(I, I): L2 = A(J, J): L3 = A(K, K)
    If Abs(L1) > 0.0000001 Then
        If (L2 + L3) / L1 > 0# Then
            Eror = RadToDeg(Atn(Sqr((L2 + L3) / L1)))
        Else
            Eror = 0
        End If
    Else
        Eror = 0
    End If
    If h = 2 Then Eror = 0
    If Eror < 0.01 Then Eror = 0
'^^^^^ compute X,Y,Z of final direction
    XC = s(1, I): YC = s(2, I): ZC = s(3, I)
    V7 = s(1, K): V8 = s(2, K): V9 = s(3, K)
'^^^^^ text direction (compare 1st and last points)
    f = h
'    If Anchor = 1 Then f = h - 1
    UpDown = XC * (GN(G(1)) - GN(G(h))) + YC * (GE(G(1)) - GE(G(h)))
    UpDown = UpDown + ZC * (GZ(G(1)) - GZ(G(h)))
    If UpDown < 0 Then XC = -XC: YC = -YC: ZC = -ZC
'^^^^^ compute corresponding Inclination and Declination
    Inc = RadToDeg(Atn(ZC / Sqr(XC * XC + YC * YC)))
'^^^^^ declination computation  [ ArcTan (YC/XC) ]
    If XC <> 0 Then
        Dec = Atn(YC / XC)
        If (XC < 0 And YC < 0) Then Dec = Dec - 3.14159265358979
        If (XC < 0 And YC >= 0) Then Dec = Dec + 3.14159265358979
    Else
        If YC < 0 Then Dec = -3.14159265358979 / 2
        If YC > 0 Then Dec = 3.14159265358979 / 2
        If YC = 0 Then Dec = 0
    End If
    If Dec < 0 Then Dec = 2 * 3.14159265358979 + Dec
    Dec = RadToDeg(Dec)
End Sub

'Purpose:   To display all qualified points in the *.mag file using
'       stereographic projection.
Private Sub SPlotAllPoints(ByRef AllPointsDec() As Single, _
    ByRef AllPointsInc() As Single, ByVal SampleNumber As Long)
    Dim Counter As Long
        For Counter = 1 To SampleNumber
            RSample = SPlotRadius(Radius, Abs(AllPointsInc(Counter)))
            Call DXDYCalc(DX, DY, RSample, AllPointsDec(Counter))
            Call CurrXY(CurrX, CurrY)
            If AllPointsInc(Counter) < 0 Then
                frmSPlot.picSPlot.Circle (CurrX, CurrY), 35, RGB(255, 0, 0)
            Else
                frmSPlot.picSPlot.FillStyle = 0
                frmSPlot.picSPlot.FillColor = RGB(255, 0, 0)
                frmSPlot.picSPlot.Circle (CurrX, CurrY), 35, RGB(255, 0, 0)
                frmSPlot.picSPlot.FillStyle = 1
                frmSPlot.picSPlot.FillColor = frmSPlot.picSPlot.ForeColor
            End If
        Next Counter
End Sub

'Purpose:   To display all qualified points in the *.mag file using
'       Lambert Equal-area projection.
Private Sub EQPlotAllPoints(ByRef AllPointsDec() As Single, _
    ByRef AllPointsInc() As Single, ByVal SampleNumber As Long)
    Dim Counter As Long
        For Counter = 1 To SampleNumber
            RSample = EQPlotRadius(Radius, Abs(AllPointsInc(Counter)))
            Call DXDYCalc(DX, DY, RSample, AllPointsDec(Counter))
            Call CurrXY(CurrX, CurrY)
            If AllPointsInc(Counter) < 0 Then
                frmSPlot.picSPlot.Circle (CurrX, CurrY), 35, RGB(255, 0, 0)
            Else
                frmSPlot.picSPlot.FillStyle = 0
                frmSPlot.picSPlot.FillColor = RGB(255, 0, 0)
                frmSPlot.picSPlot.Circle (CurrX, CurrY), 35, RGB(255, 0, 0)
                frmSPlot.picSPlot.FillStyle = 1
                frmSPlot.picSPlot.FillColor = frmSPlot.picSPlot.ForeColor
            End If
        Next Counter
End Sub

'Purpose:   To perform Fisher Analysis.
Private Sub Fisher(ByRef Dec() As Single, ByRef Inc() As Single, ByRef Mag() As Single, _
    ByRef G() As Long, ByVal num As Long, ByVal NAng As Single, ByVal RAng As Single)
    Dim I As Long
    Dim x As Single, Y As Single, Z As Single 'x = North, y = East, z = Down
    Dim OmitN As String, OmitR As String
    Dim DF As Single    'To store the projection of one vector on another.
    Dim NumNor As Long, NumRev As Long
    Dim NPDec(1 To 500) As Single, NPInc(1 To 500) As Single, NPMag(1 To 500) As Single
    Dim RPDec(1 To 500) As Single, RPInc(1 To 500) As Single, RPMag(1 To 500) As Single
    Dim dFish(1 To 500) As Single, iFish(1 To 500) As Single, mFish(1 To 500) As Single
    Dim N95 As Single, NSD As Single
    Dim R95 As Single, RSD As Single
    Dim XS As Single, YS As Single, ZS As Single
    Dim XA As Single, YA As Single, ZA As Single
    Dim MS As Single, MA As Single
    Dim DC As Single
    
    NumNor = 0
    NumRev = 0
    For I = 1 To num
        x = Cos(DegToRad(Dec(I))) * Cos(DegToRad(Inc(I)))
        Y = Sin(DegToRad(Dec(I))) * Cos(DegToRad(Inc(I)))
        Z = Sin(DegToRad(Inc(I)))
        'First Do Normal Comparison
        DF = ArcCos(x * xNormal + Y * yNormal + Z * zNormal)
        If DF > NAng Then
            OmitN = "Yes"
        Else
            OmitN = "No"
            NumNor = NumNor + 1
            NPDec(NumNor) = Dec(I)
            NPInc(NumNor) = Inc(I)
            NPMag(NumNor) = Mag(I)
        End If
        'Then Do Reversed Comparison
        DF = ArcCos(x * xReversed + Y * yReversed + Z * zReversed)
        If DF > RAng Then
            OmitR = "Yes"
        Else
            OmitR = "No"
            NumRev = NumRev + 1
            RPDec(NumRev) = Dec(I)
            RPInc(NumRev) = Inc(I)
            RPMag(NumRev) = Mag(I)
        End If
        
        'If the point does not fall within cutoff, print the information.
        If OmitN = "Yes" And OmitR = "Yes" Then
            frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
                RecordNames(G(I)).Name & " omitted from both N and R" & vbCrLf
        End If
    Next I
    
    If NumNor > 0 Then
        frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
            ">>>>>>>> Normal Directions <<<<<<<<" & vbCrLf
        For I = 1 To NumNor
            dFish(I) = NPDec(I)
            iFish(I) = NPInc(I)
            mFish(I) = NPMag(I)
        Next I
        Call FisherSub(dFish(), iFish(), mFish(), NumNor)
        NorDec = FishDec
        NorInc = FishInc
        NorMag = FishMag
        N95 = Alpha95
        NSD = SM
        NK = K
    End If
    If NumRev > 0 Then
        frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
            ">>>>>>>> Reversed Directions <<<<<<<<" & vbCrLf
        For I = 1 To NumRev
            dFish(I) = RPDec(I)
            iFish(I) = RPInc(I)
            mFish(I) = RPMag(I)
        Next I
        Call FisherSub(dFish(), iFish(), mFish(), NumRev)
        RevDec = FishDec
        RevInc = FishInc
        RevMag = FishMag
        R95 = Alpha95
        RSD = SM
        RK = K
    End If
    
    '** Now for both combined.
    If NumRev = 0 Or NumNor = 0 Then
        Exit Sub
    Else
        frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
            ">>>>>>>> Combined Directions <<<<<<<<" & vbCrLf
        For I = 1 To NumRev
            dFish(I) = dFish(I) + 180
            If dFish(I) >= 360 Then
                dFish(I) = dFish(I) - 360
            End If
            iFish(I) = -iFish(I)
        Next I
        For I = 1 To NumNor
            dFish(I + NumRev) = NPDec(I)
            iFish(I + NumRev) = NPInc(I)
            mFish(I + NumRev) = NPMag(I)
        Next I
        Call FisherSub(dFish(), iFish(), mFish(), NumRev + NumNor)
        Call XYZFisher(xNormal, yNormal, zNormal, NorDec, NorInc)
        Call XYZFisher(xReversed, yReversed, zReversed, RevDec, RevInc)
        xNormal = xNormal * NorMag
        yNormal = yNormal * NorMag
        zNormal = zNormal * NorMag
        xReversed = xReversed * RevMag
        yReversed = yReversed * RevMag
        zReversed = zReversed * RevMag
        XS = xNormal + xReversed
        YS = yNormal + yReversed
        ZS = zNormal + zReversed
        XA = xNormal - xReversed
        YA = yNormal - yReversed
        ZA = zNormal - zReversed
        MS = (Sqr(XS ^ 2 + YS ^ 2 + ZS ^ 2)) / 2
        MA = (Sqr(XA ^ 2 + YA ^ 2 + ZA ^ 2)) / 2
        'Compute Secondary Vector
        DC = ArcTan(XS, YS)
        FishInc = ArcSin(ZS / (MS * 2))
        frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
            "******** Vector Combination ********" & vbCrLf & _
            "Secondary vector:" & vbCrLf & "  Declination = " & _
            Format(RadToDeg(DC), "0.00") & ";   Inclination = " & _
            Format(RadToDeg(FishInc), "0.00") & " (degree);   Intensity = " & _
            Format(MS, "Scientific") & vbCrLf
        'Compute "Actual" Normal
        FishDec = ArcTan(XA, YA)
        FishInc = ArcSin(ZA / (MA * 2))
        frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & vbCrLf & _
            "'Actual' Normal vector:" & vbCrLf & "  Declination = " & _
            Format(RadToDeg(FishDec), "0.00") & ";   Inclination = " & _
            Format(RadToDeg(FishInc), "0.00") & " (degree);   Intensity = " & _
            Format(MA, "Scientific") & vbCrLf
        Call VGP(FishDec, FishInc, Alpha95)
    End If
End Sub


Private Sub FisherSub(ByRef dFish() As Single, ByRef iFish() As Single, _
    ByRef mFish() As Single, ByVal N As Long)
    'NT = North Total, ET = East Total, DT = Down Total, MT = Intensity Total
    Dim NT As Single, ET As Single, DT As Single, MT As Single
    Dim R As Single     'R: Length of the sum of all vectors
    Dim I As Long, Dec As Single, Inc As Single
    Dim ST As Single
    Dim A As Single, B As Single    'Coefficients for Calculating Alpha95
    Dim S1 As Single, S2 As Single
    Dim ResultDisplay As String
    Dim NPrime As Single    'To replace N/2 in case N is an odd integer.
    '(X1,Y1,Z1) and (X2,Y2,Z2) For calculating the angle between the only two samples.
    Dim X1 As Single, Y1 As Single, Z1 As Single
    Dim X2 As Single, Y2 As Single, Z2 As Single
    
    NT = 0
    ET = 0
    DT = 0
    MT = 0
    If N > 1 Then
        For I = 1 To N
            Dec = DegToRad(dFish(I))
            Inc = DegToRad(iFish(I))
            NT = NT + Cos(Dec) * Cos(Inc)
            ET = ET + Sin(Dec) * Cos(Inc)
            DT = DT + Sin(Inc)
            MT = MT + mFish(I)
        Next I
        R = Sqr(NT ^ 2 + ET ^ 2 + DT ^ 2)
        FishInc = ArcSin(DT / R)
        FishDec = ArcTan(NT, ET)
        FishMag = MT / N
        If N > 2 Then
            If Weighted = "Yes" Then    'Correct for Weighted Least Square Data.
                NPrime = N / 2
                R = R / 2
                If NPrime > 2 Then
                    K = (NPrime - 1) / (NPrime - R)
                    A = 20 ^ (1 / (NPrime - 1))
                    B = (NPrime - R) / R
                    Alpha95 = ArcCos(1 - B * (A - 1))
                Else
                    K = (NPrime - 1) / (NPrime - R)
                    Alpha95 = 1
                    frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
                        "Caution: <= 4 Weighted Analyses! Doubtful K " & _
                        "and Artificial Alpha95!" & vbCrLf
                End If
            Else
                K = (N - 1) / (N - R)
                A = 20 ^ (1 / (N - 1))
                B = (N - R) / R
                Alpha95 = ArcCos(1 - B * (A - 1))   'Probable Bug When N = 2, A = 20, Overflow
            End If
            ST = 0
            For I = 1 To N
                ST = ST + (mFish(I) - FishMag) ^ 2
            Next I
            SM = Sqr(ST / (N - 1))
            S1 = Exp(FishMag + SM) - Exp(FishMag)
            S2 = Exp(FishMag) - Exp(FishMag - SM)
        ElseIf N = 2 Then
            If Weighted = "Yes" Then    'Correct for Weighted Least Square Data.
                K = 0
            Else
                K = (N - 1) / (N - R)
            End If
            Call XYZFisher(X1, Y1, Z1, dFish(1), iFish(1))
            Call XYZFisher(X2, Y2, Z2, dFish(2), iFish(2))
            Alpha95 = Abs(ArcCos(X1 * X2 + Y1 * Y2 + Z1 * Z2) / 2)
            ST = 0
            For I = 1 To N
                ST = ST + (mFish(I) - FishMag) ^ 2
            Next I
            SM = Sqr(ST / (N - 1))
            S1 = Exp(FishMag + SM) - Exp(FishMag)
            S2 = Exp(FishMag) - Exp(FishMag - SM)
        End If
    ElseIf N = 1 Then
        R = 1
        FishInc = DegToRad(iFish(1))
        FishDec = DegToRad(dFish(1))
        FishMag = mFish(1)
        Alpha95 = 0.000001
        K = 100
        SM = 0.000001
        S1 = Exp(FishMag + SM) - Exp(FishMag)
        S2 = Exp(FishMag) - Exp(FishMag - SM)
        frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
            "Caution: Only One Sample Available! Artificial K and Alpha95!" & vbCrLf
    Else
        Exit Sub
    End If
    
    FishMag = Exp(FishMag)
        
    frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
        "  Declination  Inclination  Alpha95    K     Intensity" & _
        "   Std.Dev.    R     N" & vbCrLf
    ResultDisplay = RightAlign(Format((RadToDeg(FishDec)), "0.00"), 10) & _
        RightAlign(Format((RadToDeg(FishInc)), "0.00"), 14) & _
        RightAlign(Format((RadToDeg(Alpha95)), "0.00"), 10) & _
        RightAlign(Format(K, "0.00"), 8) & _
        RightAlign(Format(FishMag, "Scientific"), 12) & _
        RightAlign("+ " & Format(S1, "Scientific"), 11) & _
        RightAlign(Format(R, "0.00"), 7)
    If Weighted = "Yes" Then
        ResultDisplay = ResultDisplay & RightAlign(Format(NPrime, "0.0"), 6)
    Else
        ResultDisplay = ResultDisplay & RightAlign(Format(N, "0"), 4)
    End If
    frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & _
        ResultDisplay & vbCrLf & _
        RightAlign("- " & Format(S2, "Scientific"), 65) & vbCrLf
    Call VGP(FishDec, FishInc, Alpha95)
End Sub

'Purpose:   To Calculates Virtual Geomagnetic Pole (VGP). All Angles in Radian.
Private Sub VGP(ByVal FishDec As Single, ByVal FishInc As Single, ByVal Alpha95 As Single)
    Dim Latitude As Single, Longitude As Single
    Dim DP As Single, DM As Single, temp As String
    Dim CoLat As Single, PaleoLat As Single, PolLat As Single, PolLng As Single
    Latitude = DegToRad(Header.Latitude)
    Longitude = DegToRad(Header.Longitude)

    Call VGPFromSite(FishDec, FishInc, Latitude, Longitude, PolLat, PolLng)
'================================Original VGP Calculation: Something Probably Wrong
'    Dim Latitude As Single, Longitude As Single
'    Dim A As Single, B As Single, C As Single, D As Single
'    Dim CoLat As Single, PaleoLat As Single, PolLat As Single, PolLng As Single
'    Dim W As Single, DP As Single, DM As Single
'    Dim temp As String
'
'    Latitude = DegToRad(Header.Latitude)
'    Longitude = DegToRad(Header.Longitude)
'    A = Sin(FishDec)
'    B = Cos(FishDec)
'    C = Sin(FishInc)
'    D = Cos(FishInc)
'    CoLat = Atn(2 * D / C)
'    If CoLat < 0 Then CoLat = CoLat + PI:              '**  COLATITUDE
'    PaleoLat = Atn(C / (D * 2))                       '**  PALEOLATITUDE in Radians
'    PaleoLat = RadToDeg(PaleoLat)                     '**  PALEOLATITUDE in Degrees
'    W = Sin(Latitude) * Cos(CoLat) + Cos(Latitude) * Sin(CoLat) * B
'    If W > 1 Then W = 1
'    If W < -1 Then W = -1
'    PolLat = ArcSin(W)                                '**  POLE LATITUDE
'    W = Sin(CoLat) * A / Cos(PolLat)
'    If W > 1 Then W = 1
'    If W < -1 Then W = -1
'    W = ArcSin(W)
'    If ((Sin(PolLat) * Sin(Latitude) - Cos(CoLat)) > 0) Then W = PI - W
'    PolLng = Longitude + W
''**  POLE LONGITUDE IS -180 TO +180
'    If PolLng >= PI Then PolLng = PolLng - 2 * PI
'    If PolLng <= -PI Then PolLng = 2 * PI + PolLng
'    PolLat = RadToDeg(PolLat)
'    PolLng = RadToDeg(PolLng)
'================================Original VGP Calculation: Something Probably Wrong
    PaleoLat = RadToDeg(Atn(Tan(FishInc) / 2))
    CoLat = Atn(2 / Tan(FishInc))
    If CoLat < 0 Then CoLat = CoLat + PI
    DP = Alpha95 * (1 + 3 * Cos(CoLat) * Cos(CoLat)) / 2
    DM = Alpha95 * Sin(CoLat) / Cos(FishInc)
    DP = RadToDeg(DP)
    DM = RadToDeg(DM)
    temp = ">>>>>>>> Mean Virtual Geomagnetic Pole (VGP): <<<<<<<<" & vbCrLf & _
        "  Latitude       Longitude     DP      DM   " & vbCrLf & _
        RightAlign(Format((PolLat), "0.00"), 10) & _
        RightAlign(Format((PolLng), "0.00"), 14) & _
        RightAlign(Format((DP), "0.00"), 10) & _
        RightAlign(Format((DM), "0.00"), 8) & " (degree)"
    frmFisher.txtFisher.Text = frmFisher.txtFisher.Text & temp & vbCrLf & _
        "  PaleoLatitude = " & Format(PaleoLat, "0.00") & " degree" & vbCrLf
End Sub

'Purpose:   To calculate X, Y, and Z from Declination and Inclination
'       Fisher Analysis. X = North, Y = East, Z = Down.
'Dec, Inc in Radians
Private Sub XYZFisher(ByRef x As Single, ByRef Y As Single, ByRef Z As Single, _
    ByVal Dec As Single, ByVal Inc As Single)
    x = Cos(Dec) * Cos(Inc)
    Y = Sin(Dec) * Cos(Inc)
    Z = Sin(Inc)
End Sub

'Purpose:   To display the background of stereographic plot.
Private Sub SPlotBackground()
    Dim Inclination As Single
    Dim Theta As Single
    
    If frmSPlot.picSPlot.ScaleWidth > frmSPlot.picSPlot.ScaleHeight Then
        Radius = (frmSPlot.picSPlot.ScaleHeight - 720) / 2
    Else
        Radius = (frmSPlot.picSPlot.ScaleWidth - 720) / 2
    End If
    
    CenterX = frmSPlot.picSPlot.ScaleWidth / 2
    CenterY = frmSPlot.picSPlot.ScaleHeight / 2
    
    frmSPlot.picSPlot.Circle (CenterX, CenterY), Radius
    For Inclination = 10 To 80 Step 10
        frmSPlot.picSPlot.Circle (CenterX, CenterY), SPlotRadius(Radius, Inclination)
    Next Inclination
    For Theta = 0 To 170 Step 10
        frmSPlot.picSPlot.Line (CenterX + Radius * Cos(DegToRad(Theta)), _
            CenterY + Radius * Sin(DegToRad(Theta)))- _
            (CenterX - Radius * Cos(DegToRad(Theta)), _
            CenterY - Radius * Sin(DegToRad(Theta)))
    Next Theta
    frmSPlot.picSPlot.CurrentX = CenterX - 100
    frmSPlot.picSPlot.CurrentY = CenterY - Radius - 280
    frmSPlot.picSPlot.Print "N"
    frmSPlot.picSPlot.CurrentX = CenterX + Radius + 40
    frmSPlot.picSPlot.CurrentY = CenterY - 120
    frmSPlot.picSPlot.Print "E"
    frmSPlot.picSPlot.CurrentX = CenterX - 100
    frmSPlot.picSPlot.CurrentY = CenterY + Radius + 30
    frmSPlot.picSPlot.Print "S"
    frmSPlot.picSPlot.CurrentX = CenterX - Radius - 260
    frmSPlot.picSPlot.CurrentY = CenterY - 120
    frmSPlot.picSPlot.Print "W"
End Sub


'Purpose:   To print the background of stereographic plot.
Private Sub PrintSPlotBackground()
    Dim Inclination As Single
    Dim Theta As Single
    
    If Printer.ScaleWidth > Printer.ScaleHeight Then
        Radius = (Printer.ScaleHeight - 2880) / 2
    Else
        Radius = (Printer.ScaleWidth - 2880) / 2
    End If
    
    'Take into account the Printer.Zoom setting
    Radius = Radius * Printer.Zoom / 100
    
    CenterX = Printer.ScaleWidth / 2
    CenterY = Printer.ScaleHeight / 2 + 720
    
    Printer.Circle (CenterX, CenterY), Radius
    For Inclination = 10 To 80 Step 10
        Printer.Circle (CenterX, CenterY), SPlotRadius(Radius, Inclination)
    Next Inclination
    For Theta = 0 To 170 Step 10
        Printer.Line (CenterX + Radius * Cos(DegToRad(Theta)), _
            CenterY + Radius * Sin(DegToRad(Theta)))- _
            (CenterX - Radius * Cos(DegToRad(Theta)), _
            CenterY - Radius * Sin(DegToRad(Theta)))
    Next Theta
    Printer.CurrentX = CenterX - 100
    Printer.CurrentY = CenterY - Radius - 280
    Printer.Print "N"
    Printer.CurrentX = CenterX + Radius + 40
    Printer.CurrentY = CenterY - 120
    Printer.Print "E"
    Printer.CurrentX = CenterX - 100
    Printer.CurrentY = CenterY + Radius + 30
    Printer.Print "S"
    Printer.CurrentX = CenterX - Radius - 260
    Printer.CurrentY = CenterY - 120
    Printer.Print "W"
End Sub

'Purpose:   To display the background of Lambert Equal-area projection.
Private Sub PrintEQPlotBackground()
    Dim Inclination As Single
    Dim Theta As Single
    
    If Printer.ScaleWidth > Printer.ScaleHeight Then
        Radius = (Printer.ScaleHeight - 2880) / 2
    Else
        Radius = (Printer.ScaleWidth - 2880) / 2
    End If
    
    'Take into account the Printer.Zoom setting
    Radius = Radius * Printer.Zoom / 100
    
    CenterX = Printer.ScaleWidth / 2
    CenterY = Printer.ScaleHeight / 2 + 720
    
    Printer.Circle (CenterX, CenterY), Radius
    For Inclination = 10 To 80 Step 10
        Printer.Circle (CenterX, CenterY), EQPlotRadius(Radius, Inclination)
    Next Inclination
    For Theta = 0 To 170 Step 10
        Printer.Line (CenterX + Radius * Cos(DegToRad(Theta)), _
            CenterY + Radius * Sin(DegToRad(Theta)))- _
            (CenterX - Radius * Cos(DegToRad(Theta)), _
            CenterY - Radius * Sin(DegToRad(Theta)))
    Next Theta
    Printer.CurrentX = CenterX - 100
    Printer.CurrentY = CenterY - Radius - 280
    Printer.Print "N"
    Printer.CurrentX = CenterX + Radius + 40
    Printer.CurrentY = CenterY - 120
    Printer.Print "E"
    Printer.CurrentX = CenterX - 100
    Printer.CurrentY = CenterY + Radius + 30
    Printer.Print "S"
    Printer.CurrentX = CenterX - Radius - 260
    Printer.CurrentY = CenterY - 120
    Printer.Print "W"
End Sub

'Purpose:   To Print Lambert Equal-area projection using Geographic data.
Private Sub PrintEQPlotGeog(ByVal SampleNum As Long)
    Dim Color As Long
    PrevCounter = 0
    For Counter = 1 To SampleNum - 1
        If Data(Counter).LSquare = 1 Then
            Color = RGB(0, 255, 0)
        Else
            Color = RGB(255, 0, 0)
        End If
        If Data(Counter).Plot = 1 Then
            RSample = EQPlotRadius(Radius, Abs(Data(Counter).GInc))
            Call DXDYCalc(DX, DY, RSample, Data(Counter).GDec)
            If Counter = 1 Then
                Call CurrXY(CurrX, CurrY)
                If Data(1).GInc < 0 Then
                    Printer.Line (CurrX - 40, CurrY - 40)-Step(80, 80), , B
                Else
                    Printer.Line (CurrX - 40, CurrY - 40)-Step(80, 80), , BF
                End If
                PrevCounter = Counter
            Else
                If PrevCounter <> 0 Then
                    Call PrintConnectPoints(Radius, Data(PrevCounter).GDec, _
                        Data(PrevCounter).GInc, Data(Counter).GDec, Data(Counter).GInc)
                    Printer.Line (CurrX, CurrY)-(CenterX + DX, CenterY - DY), _
                        RGB(0, 0, 255)
                End If
                PrevCounter = Counter
                Call CurrXY(CurrX, CurrY)
                If Data(Counter).GInc < 0 Then
                    Printer.Circle (CurrX, CurrY), 50, Color
                Else
                    Printer.FillStyle = 0
                    Printer.FillColor = Color
                    Printer.Circle (CurrX, CurrY), 50, Color
                    Printer.FillStyle = 1
                    Printer.FillColor = Printer.ForeColor
                End If
            End If
        End If
    Next Counter
End Sub

'Purpose:   To print Lambert Equal-area projection using Tilt-corrected data.
Private Sub PrintEQPlotTilt(ByVal SampleNum As Long)
    Dim Color As Long
    PrevCounter = 0
    For Counter = 1 To SampleNum - 1
        If Data(Counter).LSquare = 1 Then
            Color = RGB(0, 255, 0)
        Else
            Color = RGB(255, 0, 0)
        End If
        If Data(Counter).Plot = 1 Then
            RSample = EQPlotRadius(Radius, Abs(Data(Counter).TInc))
            Call DXDYCalc(DX, DY, RSample, Data(Counter).TDec)
            If Counter = 1 Then
                Call CurrXY(CurrX, CurrY)
                If Data(1).TInc < 0 Then
                    Printer.Line (CurrX - 40, CurrY - 40)-Step(80, 80), , B
                Else
                    Printer.Line (CurrX - 40, CurrY - 40)-Step(80, 80), , BF
                End If
                PrevCounter = Counter
            Else
                If PrevCounter <> 0 Then
                    Call PrintConnectPoints(Radius, Data(PrevCounter).TDec, _
                        Data(PrevCounter).TInc, Data(Counter).TDec, Data(Counter).TInc)
                    Printer.Line (CurrX, CurrY)-(CenterX + DX, CenterY - DY), _
                        RGB(0, 0, 255)
                End If
                PrevCounter = Counter
                Call CurrXY(CurrX, CurrY)
                If Data(Counter).TInc < 0 Then
                    Printer.Circle (CurrX, CurrY), 50, Color
                Else
                    Printer.FillStyle = 0
                    Printer.FillColor = Color
                    Printer.Circle (CurrX, CurrY), 50, Color
                    Printer.FillStyle = 1
                    Printer.FillColor = Printer.ForeColor
                End If
            End If
        End If
    Next Counter
End Sub

'Purpose:   To connect two points in Stereographic Projection or
'           Lambert Equal-area Projection
'Radius:    Radius of the projection circle.
'AngleDec1 & AngleDec2: Declination of the first and second points.
'AngleInc1 & AngleInc2: Inclination of the first and second points.
Private Sub PrintConnectPoints(ByVal Radius As Single, _
    ByVal AngleDec1 As Single, ByVal AngleInc1 As Single, _
    ByVal AngleDec2 As Single, ByVal AngleInc2 As Single)
       
    Dim I As Integer, StepNumber As Integer
    Dim X1 As Single, Y1 As Single, Z1 As Single
    Dim X2 As Single, Y2 As Single, Z2 As Single
    Dim StepX As Single, StepY As Single, StepZ As Single
    Dim DecPoint As Single, IncPoint As Single
    
    
    Call XYZFromDecInc(X1, Y1, Z1, Radius, AngleDec1, AngleInc1)
    Call XYZFromDecInc(X2, Y2, Z2, Radius, AngleDec2, AngleInc2)
    StepNumber = 1000         'Number of Steps from (X1, Y1, Z1) to (X2, Y2, Z2)
    StepX = (X2 - X1) / StepNumber
    StepY = (Y2 - Y1) / StepNumber
    StepZ = (Z2 - Z1) / StepNumber
    For I = 1 To 999
        Call XYZToDecInc(X1 + I * StepX, Y1 + I * StepY, Z1 + I * StepZ, _
            DecPoint, IncPoint)
        If mnuSPlotGeographic.Checked Or mnuSPlotTilt.Checked Then
            RSample = SPlotRadius(Radius, Abs(IncPoint))
        ElseIf mnuEQPlotGeographic.Checked Or mnuEQPlotTilt.Checked Then
            RSample = EQPlotRadius(Radius, Abs(IncPoint))
        End If
        Call DXDYCalc(DX, DY, RSample, DecPoint)
        Call CurrXY(CurrX, CurrY)
        Printer.Line -(CurrX, CurrY), RGB(0, 0, 255)
    Next I
End Sub

'Purpose:   To Print stereographic projection using Geographic data.
Private Sub PrintSPlotGeog(ByVal SampleNum As Long)
    Dim Color As Long
    frmSPlot.lblSPlot = "Stereographic Projection: Geographic"
    PrevCounter = 0
    For Counter = 1 To SampleNum - 1
        If Data(Counter).LSquare = 1 Then
            Color = RGB(0, 255, 0)
        Else
            Color = RGB(255, 0, 0)
        End If
        If Data(Counter).Plot = 1 Then
            RSample = SPlotRadius(Radius, Abs(Data(Counter).GInc))
            Call DXDYCalc(DX, DY, RSample, Data(Counter).GDec)
            If Counter = 1 Then
                Call CurrXY(CurrX, CurrY)
                If Data(1).GInc < 0 Then
                    Printer.Line (CurrX - 40, CurrY - 40)-Step(80, 80), , B
                Else
                    Printer.Line (CurrX - 40, CurrY - 40)-Step(80, 80), , BF
                End If
                PrevCounter = Counter
            Else
                If PrevCounter <> 0 Then
                    Call PrintConnectPoints(Radius, Data(PrevCounter).GDec, _
                        Data(PrevCounter).GInc, Data(Counter).GDec, _
                        Data(Counter).GInc)
                    Printer.Line (CurrX, CurrY)-(CenterX + DX, CenterY - DY), RGB(0, 0, 255)
                End If
                PrevCounter = Counter
                Call CurrXY(CurrX, CurrY)
                If Data(Counter).GInc < 0 Then
                    Printer.Circle (CurrX, CurrY), 50, Color
                Else
                    Printer.FillStyle = 0
                    Printer.FillColor = Color
                    Printer.Circle (CurrX, CurrY), 50, Color
                    Printer.FillStyle = 1
                    Printer.FillColor = Printer.ForeColor
                End If
            End If
        End If
    Next Counter
End Sub

'Purpose:   To print stereographic projection using Tilt-corrected data.
Public Sub PrintSPlotTilt(ByVal SampleNum As Long)
    Dim Color As Long
    frmSPlot.lblSPlot = "Stereographic Projection: Tilt-corrected"
    PrevCounter = 0
    For Counter = 1 To SampleNum - 1
        If Data(Counter).LSquare = 1 Then
            Color = RGB(0, 255, 0)
        Else
            Color = RGB(255, 0, 0)
        End If
        If Data(Counter).Plot = 1 Then
            RSample = SPlotRadius(Radius, Abs(Data(Counter).TInc))
            Call DXDYCalc(DX, DY, RSample, Data(Counter).TDec)
            If Counter = 1 Then
                Call CurrXY(CurrX, CurrY)
                If Data(1).TInc < 0 Then
                    Printer.Line (CurrX - 40, CurrY - 40)-Step(80, 80), , B
                Else
                    Printer.Line (CurrX - 40, CurrY - 40)-Step(80, 80), , BF
                End If
                PrevCounter = Counter
            Else
                If PrevCounter <> 0 Then
                    Call PrintConnectPoints(Radius, Data(PrevCounter).TDec, _
                        Data(PrevCounter).TInc, Data(Counter).TDec, _
                        Data(Counter).TInc)
                    Printer.Line (CurrX, CurrY)-(CenterX + DX, CenterY - DY), RGB(0, 0, 255)
                End If
                PrevCounter = Counter
                Call CurrXY(CurrX, CurrY)
                If Data(Counter).TInc < 0 Then
                    Printer.Circle (CurrX, CurrY), 50, Color
                Else
                    Printer.FillStyle = 0
                    Printer.FillColor = Color
                    Printer.Circle (CurrX, CurrY), 50, Color
                    Printer.FillStyle = 1
                    Printer.FillColor = Printer.ForeColor
                End If
            End If
        End If
    Next Counter
End Sub

'Purpose:   To Print all qualified points in the *.mag file using
'       Lambert Equal-area projection.
Private Sub PrintEQPlotAllPoints(ByRef AllPointsDec() As Single, _
    ByRef AllPointsInc() As Single, ByVal SampleNumber As Long)
    Dim Counter As Long
        For Counter = 1 To SampleNumber
            RSample = EQPlotRadius(Radius, Abs(AllPointsInc(Counter)))
            Call DXDYCalc(DX, DY, RSample, AllPointsDec(Counter))
            Call CurrXY(CurrX, CurrY)
            If AllPointsInc(Counter) < 0 Then
                Printer.Circle (CurrX, CurrY), 50, RGB(255, 0, 0)
            Else
                Printer.FillStyle = 0
                Printer.FillColor = RGB(255, 0, 0)
                Printer.Circle (CurrX, CurrY), 50, RGB(255, 0, 0)
                Printer.FillStyle = 1
                Printer.FillColor = Printer.ForeColor
            End If
        Next Counter
End Sub

'Purpose:   To print all qualified points in the *.mag file using
'       stereographic projection.
Private Sub PrintSPlotAllPoints(ByRef AllPointsDec() As Single, _
    ByRef AllPointsInc() As Single, ByVal SampleNumber As Long)
    Dim Counter As Long
        For Counter = 1 To SampleNumber
            RSample = SPlotRadius(Radius, Abs(AllPointsInc(Counter)))
            Call DXDYCalc(DX, DY, RSample, AllPointsDec(Counter))
            Call CurrXY(CurrX, CurrY)
            If AllPointsInc(Counter) < 0 Then
                Printer.Circle (CurrX, CurrY), 50, RGB(255, 0, 0)
            Else
                Printer.FillStyle = 0
                Printer.FillColor = RGB(255, 0, 0)
                Printer.Circle (CurrX, CurrY), 50, RGB(255, 0, 0)
                Printer.FillStyle = 1
                Printer.FillColor = Printer.ForeColor
            End If
        Next Counter
End Sub

'Purpose:   To print all NRM data in the *.mag file.
Private Sub PrintAllSPlotNRM()
    Dim Start As Long, num As Long
    Dim I As Long   'As a counter, to change its value from 1 to Header.SampleNum
    Dim AllPointsTDec(1 To 500) As Single, AllPointsTInc(1 To 500) As Single
    Dim AllPointsGDec(1 To 500) As Single, AllPointsGInc(1 To 500) As Single
    
    num = 0
    Start = 2
    For I = 1 To Header.SampleNum
        Get #OpenFileNum, Start, RecordHead
        If RecordNames(I).Active = 1 Then
            For Counter = 1 To 6
                Get #OpenFileNum, Start + Counter, Data(Counter)
                If Data(Counter).DeMag = "NRM" And Data(Counter).Plot = 1 Then
                    num = num + 1
                    AllPointsTDec(num) = Data(Counter).TDec
                    AllPointsTInc(num) = Data(Counter).TInc
                    AllPointsGDec(num) = Data(Counter).GDec
                    AllPointsGInc(num) = Data(Counter).GInc
                End If
            Next Counter
        End If
        Start = RecordHead.NextRec
    Next I
       
    If mnuSPlotGeographic.Checked Then
        Call PrintSPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Stereographic Projection of All Samples - NRM, Geographic"
        Call PrintSPlotAllPoints(AllPointsGDec(), AllPointsGInc(), num)
    ElseIf mnuSPlotTilt.Checked Then
        Call PrintSPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Stereographic Projection of All Samples - NRM, Tilt-Corrected"
        Call PrintSPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    Else
'        mnuSPlotTilt_Click
        Call PrintSPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Stereographic Projection of All Samples - NRM, Tilt-Corrected"
        Call PrintSPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    End If
End Sub

'Purpose:   To print all NRM data in the *.mag file.
Private Sub PrintAllEQPlotNRM()
    Dim Start As Long, num As Long
    Dim I As Long   'As a counter, to change its value from 1 to Header.SampleNum
    Dim AllPointsTDec(1 To 500) As Single, AllPointsTInc(1 To 500) As Single
    Dim AllPointsGDec(1 To 500) As Single, AllPointsGInc(1 To 500) As Single
    
    num = 0
    Start = 2
    For I = 1 To Header.SampleNum
        Get #OpenFileNum, Start, RecordHead
        If RecordNames(I).Active = 1 Then
            For Counter = 1 To 6
                Get #OpenFileNum, Start + Counter, Data(Counter)
                If Data(Counter).DeMag = "NRM" And Data(Counter).Plot = 1 Then
                    num = num + 1
                    AllPointsTDec(num) = Data(Counter).TDec
                    AllPointsTInc(num) = Data(Counter).TInc
                    AllPointsGDec(num) = Data(Counter).GDec
                    AllPointsGInc(num) = Data(Counter).GInc
                End If
            Next Counter
        End If
        Start = RecordHead.NextRec
    Next I
       
    If mnuEQPlotGeographic.Checked Then
        Call PrintEQPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Equal-Area Projection of All Samples - NRM, Geographic"
        Call PrintEQPlotAllPoints(AllPointsGDec(), AllPointsGInc(), num)
    ElseIf mnuEQPlotTilt.Checked Then
        Call PrintEQPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Equal-Area Projection of All Samples - NRM, Tilt-Corrected"
        Call PrintEQPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    Else
'        mnuEQPlotTilt_Click
        Call PrintEQPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Equal-Area Projection of All Samples - NRM, Tilt-Corrected"
        Call PrintEQPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    End If
End Sub

'Purpose:   To print all qualified Data at T in the *.mag file.
'In the following "mnuAllSPlotAT", AT = Arbitrary Temperature.
Private Sub PrintAllSPlotAT()
    Dim Message As String, Title As String, Temperature As Single
    Dim Start As Long, num As Long, Counter As Long, temp As String
    Dim I As Long   'As a counter, to change its value from 1 to Header.SampleNum
    Dim AllPointsTDec(1 To 500) As Single, AllPointsTInc(1 To 500) As Single
    Dim AllPointsGDec(1 To 500) As Single, AllPointsGInc(1 To 500) As Single
    
    Message = "Please enter a desired temperature for plotting:" & vbCrLf & _
            "e.g., 250, 300, 350, 400 degree, etc. "
    Title = "Temperature Selection"
    Do
        temp = InputBox(Message, Title)
    Loop Until IsNumeric(temp) = True Or temp = ""
    If temp = "" Then Exit Sub
    Temperature = CSng(temp)
              
    num = 0
    Start = 2
    For I = 1 To Header.SampleNum
        Get #OpenFileNum, Start, RecordHead
        If RecordNames(I).Active = 1 Then
            For Counter = 1 To RecordHead.Number - 1
                Get #OpenFileNum, Start + Counter, Data(Counter)
                If (Data(Counter).DeMagLevel = Temperature) And _
                    (Data(Counter).Plot = 1) Then
                        num = num + 1
                        AllPointsTDec(num) = Data(Counter).TDec
                        AllPointsTInc(num) = Data(Counter).TInc
                        AllPointsGDec(num) = Data(Counter).GDec
                        AllPointsGInc(num) = Data(Counter).GInc
                End If
            Next Counter
        End If
        Start = RecordHead.NextRec
    Next I
    If mnuSPlotGeographic.Checked Then
        Call PrintSPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Stereographic Projection of All Samples - " & _
            Format(Temperature, "0") & " degree, Geographic"
        Call PrintSPlotAllPoints(AllPointsGDec(), AllPointsGInc(), num)
    ElseIf mnuSPlotTilt.Checked Then
        Call PrintSPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Stereographic Projection of All Samples - " & _
            Format(Temperature, "0") & " degree, Tilt-Corrected"
        Call PrintSPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    Else
'        mnuSPlotTilt_Click
        Call PrintSPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Stereographic Projection of All Samples - " & _
            Format(Temperature, "0") & " degree, Tilt-Corrected"
        Call PrintSPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    End If
End Sub

'Purpose:   To print all qualified Data at T in the *.mag file.
'In the following "mnuAllSPlotAT", AT = Arbitrary Temperature.
Private Sub PrintAllSPlotAF()
    Dim Message As String, Title As String, AFStrength As Single
    Dim Start As Long, num As Long, Counter As Long, temp As String
    Dim I As Long   'As a counter, to change its value from 1 to Header.SampleNum
    Dim AllPointsTDec(1 To 500) As Single, AllPointsTInc(1 To 500) As Single
    Dim AllPointsGDec(1 To 500) As Single, AllPointsGInc(1 To 500) As Single
    
    Message = "Please enter a desired strength of" & vbCrLf & _
            "Alternating Field for plotting: "
    Title = "Alternating Field Strength Selection"
    Do
        temp = InputBox(Message, Title)
    Loop Until IsNumeric(temp) = True Or temp = ""
    If temp = "" Then Exit Sub
    AFStrength = CSng(temp)
              
    num = 0
    Start = 2
    For I = 1 To Header.SampleNum
        Get #OpenFileNum, Start, RecordHead
        If RecordNames(I).Active = 1 Then
            For Counter = 1 To RecordHead.Number - 1
                Get #OpenFileNum, Start + Counter, Data(Counter)
                If (Data(Counter).DeMagLevel = AFStrength) And _
                    (Data(Counter).Plot = 1) Then
                        num = num + 1
                        AllPointsTDec(num) = Data(Counter).TDec
                        AllPointsTInc(num) = Data(Counter).TInc
                        AllPointsGDec(num) = Data(Counter).GDec
                        AllPointsGInc(num) = Data(Counter).GInc
                End If
            Next Counter
        End If
        Start = RecordHead.NextRec
    Next I
    If mnuSPlotGeographic.Checked Then
        Call PrintSPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Stereographic Projection of All Samples - " & _
            Format(AFStrength, "0") & " mT, Geographic"
        Call PrintSPlotAllPoints(AllPointsGDec(), AllPointsGInc(), num)
    ElseIf mnuSPlotTilt.Checked Then
        Call PrintSPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Stereographic Projection of All Samples - " & _
            Format(AFStrength, "0") & " mT, Tilt-Corrected"
        Call PrintSPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    Else
'        mnuSPlotTilt_Click
        Call PrintSPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Stereographic Projection of All Samples - " & _
            Format(AFStrength, "0") & " mT, Tilt-Corrected"
        Call PrintSPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    End If
End Sub

'Purpose:   To print all qualified Data at T in the *.mag file.
'In the following "mnuAllSPlotAT", AT = Arbitrary Temperature.
Private Sub PrintAllEQPlotAT()
    Dim Message As String, Title As String, Temperature As Single
    Dim Start As Long, num As Long, Counter As Long, temp As String
    Dim I As Long   'As a counter, to change its value from 1 to Header.SampleNum
    Dim AllPointsTDec(1 To 500) As Single, AllPointsTInc(1 To 500) As Single
    Dim AllPointsGDec(1 To 500) As Single, AllPointsGInc(1 To 500) As Single
    
    Message = "Please enter a desired temperature for plotting:" & vbCrLf & _
            "e.g., 250, 300, 350, 400 degree, etc. "
    Title = "Temperature Selection"
    Do
        temp = InputBox(Message, Title)
    Loop Until IsNumeric(temp) = True Or temp = ""
    If temp = "" Then Exit Sub
    Temperature = CSng(temp)
              
    num = 0
    Start = 2
    For I = 1 To Header.SampleNum
        Get #OpenFileNum, Start, RecordHead
        If RecordNames(I).Active = 1 Then
            For Counter = 1 To RecordHead.Number - 1
                Get #OpenFileNum, Start + Counter, Data(Counter)
                If (Data(Counter).DeMagLevel = Temperature) And _
                    (Data(Counter).Plot = 1) Then
                        num = num + 1
                        AllPointsTDec(num) = Data(Counter).TDec
                        AllPointsTInc(num) = Data(Counter).TInc
                        AllPointsGDec(num) = Data(Counter).GDec
                        AllPointsGInc(num) = Data(Counter).GInc
                End If
            Next Counter
        End If
        Start = RecordHead.NextRec
    Next I
    If mnuEQPlotGeographic.Checked Then
        Call PrintEQPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Equal-Area Projection of All Samples -  " & _
            Format(Temperature, "0") & " degree, Geographic"
        Call PrintEQPlotAllPoints(AllPointsGDec(), AllPointsGInc(), num)
    ElseIf mnuEQPlotTilt.Checked Then
        Call PrintEQPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Equal-Area Projection of All Samples - " & _
            Format(Temperature, "0") & " degree, Tilt-Corrected"
        Call PrintEQPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    Else
'        mnuEQPlotTilt_Click
        Call PrintEQPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Equal-Area Projection of All Samples - " & _
            Format(Temperature, "0") & " degree, Tilt-Corrected"
        Call PrintEQPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    End If
End Sub

'Purpose:   To print all qualified Data at T in the *.mag file.
'In the following "mnuAllSPlotAT", AT = Arbitrary Temperature.
Private Sub PrintAllEQPlotAF()
    Dim Message As String, Title As String, AFStrength As Single
    Dim Start As Long, num As Long, Counter As Long, temp As String
    Dim I As Long   'As a counter, to change its value from 1 to Header.SampleNum
    Dim AllPointsTDec(1 To 500) As Single, AllPointsTInc(1 To 500) As Single
    Dim AllPointsGDec(1 To 500) As Single, AllPointsGInc(1 To 500) As Single
    
    Message = "Please enter a desired strength of" & vbCrLf & _
            "Alternating Field for plotting: "
    Title = "Alternating Field Strength Selection"
    Do
        temp = InputBox(Message, Title)
    Loop Until IsNumeric(temp) = True Or temp = ""
    If temp = "" Then Exit Sub
    AFStrength = CSng(temp)
              
    num = 0
    Start = 2
    For I = 1 To Header.SampleNum
        Get #OpenFileNum, Start, RecordHead
        If RecordNames(I).Active = 1 Then
            For Counter = 1 To RecordHead.Number - 1
                Get #OpenFileNum, Start + Counter, Data(Counter)
                If (Data(Counter).DeMagLevel = AFStrength) And _
                    (Data(Counter).Plot = 1) Then
                        num = num + 1
                        AllPointsTDec(num) = Data(Counter).TDec
                        AllPointsTInc(num) = Data(Counter).TInc
                        AllPointsGDec(num) = Data(Counter).GDec
                        AllPointsGInc(num) = Data(Counter).GInc
                End If
            Next Counter
        End If
        Start = RecordHead.NextRec
    Next I
    If mnuEQPlotGeographic.Checked Then
        Call PrintEQPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Equal-Area Projection of All Samples -  " & _
            Format(AFStrength, "0") & " mT, Geographic"
        Call PrintEQPlotAllPoints(AllPointsGDec(), AllPointsGInc(), num)
    ElseIf mnuEQPlotTilt.Checked Then
        Call PrintEQPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Equal-Area Projection of All Samples - " & _
            Format(AFStrength, "0") & " mT, Tilt-Corrected"
        Call PrintEQPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    Else
'        mnuEQPlotTilt_Click
        Call PrintEQPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Equal-Area Projection of All Samples - " & _
            Format(AFStrength, "0") & " mT, Tilt-Corrected"
        Call PrintEQPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    End If
End Sub

'Purpose:   To print all qualified Least Square Data in the *.mag file.
Private Sub PrintAllSPlotLSquare()
    Dim Start As Long, num As Long
    Dim I As Long   'As a counter, to change its value from 1 to Header.SampleNum
    Dim AllPointsTDec(1 To 500) As Single, AllPointsTInc(1 To 500) As Single
    Dim AllPointsGDec(1 To 500) As Single, AllPointsGInc(1 To 500) As Single
    
    num = 0
    Start = 2
    For I = 1 To Header.SampleNum
        Get #OpenFileNum, Start, RecordHead
        If RecordNames(I).Active = 1 Then
            If RecordHead.LSHead <> 0 Then
                Get #OpenFileNum, RecordHead.LSHead, AllLSData(I)
                If (AllLSData(I).Active = 1) And (AllLSData(I).Label = "N  " Or _
                    AllLSData(I).Label = "R  " Or AllLSData(I).Label = "NP " Or _
                    AllLSData(I).Label = "RP ") Then
                    num = num + 1
                    AllPointsTDec(num) = AllLSData(I).TDec
                    AllPointsTInc(num) = AllLSData(I).TInc
                    AllPointsGDec(num) = AllLSData(I).GDec
                    AllPointsGInc(num) = AllLSData(I).GInc
                End If
            End If
        End If
        Start = RecordHead.NextRec
    Next I
    If mnuSPlotGeographic.Checked Then
        Call PrintSPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Stereographic Projection of All Samples - Least Square, Geographic"
        Call PrintSPlotAllPoints(AllPointsGDec(), AllPointsGInc(), num)
    ElseIf mnuSPlotTilt.Checked Then
        Call PrintSPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Stereographic Projection of All Samples - Least Square, Tilt-Corrected"
        Call PrintSPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    Else
'        mnuSPlotTilt_Click
        Call PrintSPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Stereographic Projection of All Samples - Least Square, Tilt-Corrected"
        Call PrintSPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    End If
End Sub

'Purpose:   To print all qualified Least Square Data in the *.mag file.
Private Sub PrintAllEQPlotLSquare()
    Dim Start As Long, num As Long
    Dim I As Long   'As a counter, to change its value from 1 to Header.SampleNum
    Dim AllPointsTDec(1 To 500) As Single, AllPointsTInc(1 To 500) As Single
    Dim AllPointsGDec(1 To 500) As Single, AllPointsGInc(1 To 500) As Single
    
    num = 0
    Start = 2
    For I = 1 To Header.SampleNum
        Get #OpenFileNum, Start, RecordHead
        If RecordNames(I).Active = 1 Then
            If RecordHead.LSHead <> 0 Then
                Get #OpenFileNum, RecordHead.LSHead, AllLSData(I)
                If (AllLSData(I).Active = 1) And (AllLSData(I).Label = "N  " Or _
                    AllLSData(I).Label = "R  " Or AllLSData(I).Label = "NP " Or _
                    AllLSData(I).Label = "RP ") Then
                    num = num + 1
                    AllPointsTDec(num) = AllLSData(I).TDec
                    AllPointsTInc(num) = AllLSData(I).TInc
                    AllPointsGDec(num) = AllLSData(I).GDec
                    AllPointsGInc(num) = AllLSData(I).GInc
                End If
            End If
        End If
        Start = RecordHead.NextRec
    Next I
    If mnuEQPlotGeographic.Checked Then
        Call PrintEQPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Equal-Area Projection of All Samples - Least Square, Geographic"
        Call PrintEQPlotAllPoints(AllPointsGDec(), AllPointsGInc(), num)
    ElseIf mnuEQPlotTilt.Checked Then
        Call PrintEQPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Equal-Area Projection of All Samples - Least Square, Tilt-Corrected"
        Call PrintEQPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    Else
'        mnuEQPlotTilt_Click
        Call PrintEQPlotBackground
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1440
        Printer.Print OpenFileName
        Printer.CurrentX = CenterX - Radius
        Printer.CurrentY = CenterY - Radius - 1000
        Printer.Print "Equal-Area Projection of All Samples - Least Square, Tilt-Corrected"
        Call PrintEQPlotAllPoints(AllPointsTDec(), AllPointsTInc(), num)
    End If
End Sub

'Purpose:   To print Zijderveld projection of a sample.
Private Sub PrintZijderveldPlot(ByVal SampleNum As Long)
    'DecX(1 to 50), DecY(1 to 50): Declination converted to x and y.
    Dim DecX(1 To 50) As Single, DecY(1 To 50) As Single
    
    'IncX(1 to 50), IncY(1 to 50): Inclination converted to x and y.
    Dim IncX(1 To 50) As Single, IncY(1 To 50) As Single
    
    Dim ScaleLength As Single      'Scale Length of one tick mark
    Dim ScaleTwips As Single      'Screen Scale Length (in twips) of one tick mark
    Dim TickNum As Integer              'Number of Tick Marks Needed
    Dim N As Integer                    '
    Dim Range As Single                 'Range of X and Y Data
    Dim PlotLS(1 To 50) As Integer      '????
    Dim NumPlot As Integer              'Number of plotable points
    Dim HorizontalVector As Double      'Horizontal Component of the Demag Vector
    Dim MinX As Single, MaxX As Single, MinY As Single, MaxY As Single
    Dim I As Integer
    Dim DX As Single, DY As Single, CurrDX As Single, CurrDY As Single
    Dim IX As Single, IY As Single, CurrIX As Single, CurrIY As Single
    Dim PrevDX As Single, PrevDY As Single, PrevIX As Single, PrevIY As Single
    Dim DecColor As ColorConstants, IncColor As ColorConstants
    
    Printer.CurrentX = 1200
    Printer.CurrentY = 1200
    
    If mnuZijGeographic.Checked Then
        If mnuZijModified.Checked Then
            Printer.Print "Modified Zijderveld Progressive Demagnetization Diagram : Geographic"
        Else
            Printer.Print "Zijderveld Progressive Demagnetization Diagram : Geographic"
        End If
    Else
        If mnuZijModified.Checked Then
            Printer.Print "Modified Zijderveld Progressive Demagnetization Diagram : Tilt-corrected"
        Else
            Printer.Print "Zijderveld Progressive Demagnetization Diagram : Tilt-corrected"
        End If
    End If

    If mnuZijModified.Checked Then  'For Modified Zijderveld Projection: "N" up (same as convention)
        For I = 1 To SampleNum - 1
            If Data(I).Plot = 1 Then
                'If ZPlotGeographic is checked
                'Horizontal Component
                If mnuZijGeographic.Checked Then
                    HorizontalVector = Data(I).Mag * Cos(DegToRad(Data(I).GInc))
                    DecX(I) = HorizontalVector * Sin(DegToRad(Data(I).GDec))
                    DecY(I) = -HorizontalVector * Cos(DegToRad(Data(I).GDec))
                    'Vertical Component:
                    If RecordHead.Theta = -2 Then   'No Projection
                        IncX(I) = Data(I).Mag * Cos(DegToRad(Data(I).GInc))
                    Else    'Projection Plane = RecordHead.Theta
                        IncX(I) = Data(I).Mag * Cos(DegToRad(Data(I).GInc)) _
                                    * Cos(DegToRad(Data(I).GDec - RecordHead.Theta))
                    End If
                    IncY(I) = Data(I).Mag * Sin(DegToRad(Data(I).GInc))
                    Call FindMaxMin(MinX, MaxX, MinY, MaxY, DecX(I), DecY(I), IncX(I), IncY(I))
            
                'If ZPlotTilt is checked
                'Horizontal Component
                ElseIf mnuZijTilt.Checked Then
                    HorizontalVector = Data(I).Mag * Cos(DegToRad(Data(I).TInc))
                    DecX(I) = HorizontalVector * Sin(DegToRad(Data(I).TDec))
                    DecY(I) = -HorizontalVector * Cos(DegToRad(Data(I).TDec))
                    'Vertical Component:
                    If RecordHead.Theta = -2 Then   'No Projection
                        IncX(I) = Data(I).Mag * Cos(DegToRad(Data(I).TInc))
                    Else    'Projection Plane = RecordHead.Theta
                        IncX(I) = Data(I).Mag * Cos(DegToRad(Data(I).TInc)) _
                                    * Cos(DegToRad(Data(I).TDec - RecordHead.Theta))
                    End If
                    IncY(I) = Data(I).Mag * Sin(DegToRad(Data(I).TInc))
                    Call FindMaxMin(MinX, MaxX, MinY, MaxY, DecX(I), DecY(I), IncX(I), IncY(I))
                End If
            End If
        Next I
    Else    'For Zijderveld Projection: "N" to the right (conventionally East)
        For I = 1 To SampleNum - 1
            If Data(I).Plot = 1 Then
                'If ZPlotGeographic is checked
                'Horizontal Component
                If mnuZijGeographic.Checked Then
                    HorizontalVector = Data(I).Mag * Cos(DegToRad(Data(I).GInc))
                    DecY(I) = HorizontalVector * Sin(DegToRad(Data(I).GDec))
                    DecX(I) = HorizontalVector * Cos(DegToRad(Data(I).GDec))
                    'Vertical Component:
                    If RecordHead.Theta = -2 Then   'No Projection
                        IncX(I) = Data(I).Mag * Cos(DegToRad(Data(I).GInc))
                    Else    'Projection Plane = RecordHead.Theta
                        IncX(I) = Data(I).Mag * Cos(DegToRad(Data(I).GInc)) _
                                    * Cos(DegToRad(Data(I).GDec - RecordHead.Theta))
                    End If
                    IncY(I) = Data(I).Mag * Sin(DegToRad(Data(I).GInc))
                    Call FindMaxMin(MinX, MaxX, MinY, MaxY, DecX(I), DecY(I), IncX(I), IncY(I))
            
                'If ZPlotTilt is checked
                'Horizontal Component
                ElseIf mnuZijTilt.Checked Then
                    HorizontalVector = Data(I).Mag * Cos(DegToRad(Data(I).TInc))
                    DecY(I) = HorizontalVector * Sin(DegToRad(Data(I).TDec))
                    DecX(I) = HorizontalVector * Cos(DegToRad(Data(I).TDec))
                    'Vertical Component:
                    If RecordHead.Theta = -2 Then   'No Projection
                        IncX(I) = Data(I).Mag * Cos(DegToRad(Data(I).TInc))
                    Else    'Projection Plane = RecordHead.Theta
                        IncX(I) = Data(I).Mag * Cos(DegToRad(Data(I).TInc)) _
                                    * Cos(DegToRad(Data(I).TDec - RecordHead.Theta))
                    End If
                    IncY(I) = Data(I).Mag * Sin(DegToRad(Data(I).TInc))
                    Call FindMaxMin(MinX, MaxX, MinY, MaxY, DecX(I), DecY(I), IncX(I), IncY(I))
                End If
            End If
        Next I
    End If
   
    If mnuZijGeographic.Checked Or mnuZijTilt.Checked Then
        'Purpose:   To determine number of tick marks needed.
        'Tick mark numbers: minimum - 8, maximum - 20.
        Call FindRange(Range, MinX, MaxX, MinY, MaxY)
        ScaleLength = FindScaleLength(Range)
        TickNum = Int(Range / ScaleLength) + 2
        If Printer.ScaleWidth < Printer.ScaleHeight Then
            ScaleTwips = (Printer.ScaleWidth - 2880) / TickNum
        Else
            ScaleTwips = (Printer.ScaleHeight - 2880) / TickNum
        End If
        
        'Take into account the printer zoom setting
        ScaleTwips = ScaleTwips * Printer.Zoom / 100
        
        'Purpose:   To find the origin on the plot.
        If MinX < 0 Then
            If MaxX < 0 Then
                OriginX = ScaleTwips * TickNum + 720
            Else
                OriginX = ScaleTwips * (Int(Abs(MinX / ScaleLength)) + 1) + 2160
            End If
        Else    'MinX>0
            OriginX = 2160
        End If
        If MinY < 0 Then
            If MaxY < 0 Then
                OriginY = ScaleTwips * TickNum + 2880
            Else
                OriginY = ScaleTwips * (Int(Abs(MinY / ScaleLength)) + 1) + 2160
            End If
        Else
            OriginY = 2160
        End If
        
        If mnuZijModified.Checked Then
            Call PrintZPlotAxes_Modified(OriginX, OriginY, ScaleTwips, ScaleLength, _
                TickNum, RecordHead.Theta)
        Else
            Call PrintZPlotAxes(OriginX, OriginY, ScaleTwips, ScaleLength, TickNum, _
                RecordHead.Theta)
        End If

        'Purpose:    To display the points on Zijderveld Plot.
        PrevDX = 100000
        PrevDY = 100000
        PrevIX = 100000
        PrevIY = 100000
        For I = 1 To SampleNum - 1
            If Data(I).Plot = 1 Then
                If Data(I).LSquare = 1 Then
                    DecColor = RGB(255, 0, 255)
                    IncColor = vbGreen
                Else
                    DecColor = vbRed
                    IncColor = vbBlue
                End If
                DX = DecX(I) / ScaleLength * ScaleTwips
                DY = DecY(I) / ScaleLength * ScaleTwips
                CurrDX = OriginX + DX
                CurrDY = OriginY + DY

                IX = IncX(I) / ScaleLength * ScaleTwips
                IY = IncY(I) / ScaleLength * ScaleTwips
                CurrIX = OriginX + IX
                CurrIY = OriginY + IY
                If I = 1 Then   'Plot the first point with square symble
                    Printer.Line (CurrDX - 40, CurrDY - 40)-Step(80, 80), _
                        RGB(255, 0, 0), BF
                    Printer.Line (CurrIX - 40, CurrIY - 40)-Step(80, 80), _
                        RGB(0, 0, 255), BF
                    PrevDX = CurrDX
                    PrevDY = CurrDY
                    PrevIX = CurrIX
                    PrevIY = CurrIY
                Else
                    If PrevDX <> 100000 And PrevDY <> 100000 Then
                        Printer.Line (PrevDX, PrevDY)-(CurrDX, CurrDY), _
                            RGB(255, 0, 0)
                    End If
                    Printer.FillStyle = 0
                    Printer.FillColor = DecColor
                    Printer.Circle (CurrDX, CurrDY), 50, DecColor
                    If PrevIX <> 100000 And PrevIY <> 100000 Then
                        Printer.Line (PrevIX, PrevIY)-(CurrIX, _
                            CurrIY), RGB(0, 0, 255)
                    End If
                    Printer.FillColor = IncColor
                    Printer.Circle (CurrIX, CurrIY), 50, IncColor
                    Printer.FillStyle = 1
                    PrevDX = CurrDX
                    PrevDY = CurrDY
                    PrevIX = CurrIX
                    PrevIY = CurrIY
                End If
            End If
        Next I
    End If
End Sub



