VERSION 5.00
Begin VB.Form frmFileConvert 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Convert File (*.app, *.tab, *.nta, *.cma,  or  *.txt)"
   ClientHeight    =   4935
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5985
   BeginProperty Font 
      Name            =   "Courier"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmFileConvert.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4935
   ScaleWidth      =   5985
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.Frame fraFileConvert 
      Caption         =   "File Selection"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4695
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5655
      Begin VB.DriveListBox drvPMagConvert 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   360
         Left            =   240
         TabIndex        =   6
         Top             =   360
         Width           =   2295
      End
      Begin VB.DirListBox dirPMagConvert 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   2790
         Left            =   240
         TabIndex        =   5
         Top             =   960
         Width           =   2295
      End
      Begin VB.FileListBox filPMagConvert 
         CausesValidation=   0   'False
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   3450
         Hidden          =   -1  'True
         Left            =   2760
         Pattern         =   "*.app;*.txt;*.tab;*.cma;*.nta"
         TabIndex        =   4
         Top             =   360
         Width           =   2655
      End
      Begin VB.CommandButton cmdConvert 
         Caption         =   "Con&vert"
         Default         =   -1  'True
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   12
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   495
         Left            =   240
         TabIndex        =   3
         Top             =   4080
         Width           =   1575
      End
      Begin VB.CommandButton cmdCancel 
         Caption         =   "&Cancel"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   12
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   495
         Left            =   2280
         TabIndex        =   2
         Top             =   4080
         Width           =   1335
      End
      Begin VB.CommandButton cmdExit 
         Caption         =   "E&xit"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   12
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   495
         Left            =   4080
         TabIndex        =   1
         Top             =   4080
         Width           =   1335
      End
   End
End
Attribute VB_Name = "frmFileConvert"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type HeaderType
    Name As String * 16
    Latitude As Single
    Longitude As Single
    MagDeclination As Single
    MagInclination As Single
    Last As Long
    SampleNum As Long
    LineNum As Long
End Type

Private Header As HeaderType

Private Type RecordHeadType
    Name As String * 16
    Meters As Single
    LSHead As Long
    Number As Long
    NextRec As Long
    Theta As Long
    Active As Long
End Type

Private RecordHead As RecordHeadType

Private Type DataType
    GDec As Single
    GInc As Single
    TDec As Single
    TInc As Single
    Mag As Single
    Errer As Single
    DeMagLevel As Single
    DeMag As String * 3
    LSquare As Long
    Plot As Long
End Type

Private Type NewTabSampleInfoType
    Name As String * 16
    Steps As Long
    NextRec As Long
End Type

Private NewTabSample() As NewTabSampleInfoType
Private Data(1 To 50) As DataType
Private DChar As String 'To store the character used as a delimiter (tab, comma, space)
Private ErrorLineNumber As Long

  
Private Sub cmdCancel_Click()
    Unload frmFileConvert
    Call frmMain.Show
End Sub

Private Sub cmdConvert_Click()
    Dim ConvertFileName As String   'ConvertFileName: File to be converted
    Dim ConvertFileNum As Long      'Number for the file to be converted
    Dim EmptyFileNum As Long        'EmptyFileNum for deleting existing .mag file
    Dim MagFileName As String       'Output file name *.mag
    Dim MagFileNum As Long          'Outpur file number
    Dim TempFileName As String      'Temp file name for *.mag without Drive Path
    Dim Point As Long           'Point: the position of . in the filename
    Dim temp As String * 65     'temp: to store information from each line
    Dim IndexNum As Long        'IndexNum: Line Number in the .mag file
    Dim Last As Long            'Last: last element in a record
    Dim Current As Long         'Current: current element in a record
    Dim CurrentHeader As Long   'CurrentHeader: Current Header Number
    Dim NextHeader As Long      'NextHeader: Next Header Number
    Dim Counter As Long         'Counter: Get analyses in a sample
    Dim TabString As String     'To store strings from *.tab (tab delimited files)
    Dim RemTabString As String  'To store the remaining string after one data is read.
    Dim TabStringLength As Long
    Dim TempName As String      'To store section and sample names
    Dim NotUsedString As String
    Dim TempDeMag As String     'To store the DeMag Level (NRM  0, or TT ###)
    Dim QuestionString As String    'In space delimited files, to store information string
                                    '   that can be a name of data.
    
    Dim Msg As String           'Possible run-time error message
    Dim fs, f, f1, fc, s    'Used to determine if a file exists
    Dim QuestionFileName As String
    
    'New variables for converting new tab formatted files
    Dim NumOfLines As Long  'how many lines
    Dim I As Long, SampleCounter As Long, StepCounter As Long
    Dim TempNameString As String * 16
    'how many samples, and how many steps in each sample
    ReDim NewTabSample(0 To 0) As NewTabSampleInfoType
    
    
    On Error GoTo ErrHandler
    
    'Open *.app files to convert
    ConvertFileNum = FreeFile
    ConvertFileName = CorrectFileName(filPMagConvert.Path, filPMagConvert.FileName)
    Open ConvertFileName For Input As #ConvertFileNum
        
    'Replace the file extension with .mag extension AS Output file name
    Point = InStr(filPMagConvert.FileName, ".")
    If Point = 0 Then
        TempFileName = filPMagConvert.FileName & ".mag"
    Else
        TempFileName = Left(filPMagConvert.FileName, Point) & "mag"
    End If
    
    'To determine if TempFileName exist in the folder.
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set f = fs.GetFolder(filPMagConvert.Path)
    Set fc = f.Files
    For Each f1 In fc
        If TempFileName = f1.Name Then
            QuestionFileName = InputBox(TempFileName & " already exist!!!" & vbCrLf & _
                "Please input another filename with the extension '.mag'" & vbCrLf & _
                "        to avoid overwriting the original file." & vbCrLf & _
                "To overwrite the old file, just click OK. " & vbCrLf & _
                "To cancel this operation, click Cancel.", _
                "Filename verification", TempFileName)
            If QuestionFileName <> "" Then
                TempFileName = QuestionFileName
            Else
                Exit Sub
            End If
            Exit For
        End If
    Next
    
    MagFileName = CorrectFileName(filPMagConvert.Path, TempFileName)
    
    
    'If the output .mag file exists, erase it
    EmptyFileNum = FreeFile
    Open MagFileName For Output As #EmptyFileNum
    Close #EmptyFileNum
    'Open the new .mag file in random mode
    MagFileNum = FreeFile
    Open MagFileName For Random Access Write As #MagFileNum Len = 64
    IndexNum = 1
    
    If LCase(Right(filPMagConvert.FileName, 3)) = "tab" Then
        DChar = Chr(9)
    ElseIf LCase(Right(filPMagConvert.FileName, 3)) = "nta" Then
        DChar = Chr(9)
    ElseIf LCase(Right(filPMagConvert.FileName, 3)) = "cma" Then
        DChar = ","
    ElseIf LCase(Right(filPMagConvert.FileName, 3)) = "txt" Then
        DChar = " "
    End If
    
    'Part:  To convert *.app files.
    If LCase(Right(filPMagConvert.FileName, 3)) = "app" Then
        'Read the first line of the file, convert it ans SAVE AS Header
        ErrorLineNumber = 0
        Line Input #ConvertFileNum, temp
        ErrorLineNumber = ErrorLineNumber + 1
        Header.Name = Left(temp, 16)
        Header.Latitude = CSng(Mid(temp, 17, 6))
        Header.Longitude = CSng(Mid(temp, 23, 6))
        Header.MagDeclination = CSng(Mid(temp, 29, 6))
        Header.MagInclination = CSng(Mid(temp, 35, 8))
        Header.Last = CLng(Mid(temp, 43, 7))
        Header.SampleNum = CLng(Mid(temp, 50, 5))
        Header.LineNum = CLng(Mid(temp, 61, 4))
        Put #MagFileNum, IndexNum, Header
        
        'Read through the apple format (.app) file
        IndexNum = 2
        CurrentHeader = 2
        While CurrentHeader < Header.Last
            Line Input #ConvertFileNum, temp
            ErrorLineNumber = ErrorLineNumber + 1

            RecordHead.Name = Left(temp, 16)
            RecordHead.Meters = CSng(Mid(temp, 17, 6))  'meter level of sample
            Last = CLng(Mid(temp, 50, 5))
            Current = CLng(Mid(temp, 61, 4))
            RecordHead.LSHead = 0
            RecordHead.Number = Last - Current + 1
            RecordHead.NextRec = IndexNum + RecordHead.Number + 1
'            RecordHead.Theta = -2       'default theta to no projection: Original default before 10/09/2001
            RecordHead.Theta = 0       'default theta to projection to N-S: New default after 10/09/2001
            RecordHead.Active = 1       'default the record to active
            NextHeader = CLng(Mid(temp, 55, 5))
            Put #MagFileNum, IndexNum, RecordHead   'Save this header
            'Read Demagnetization data for the sample and covert to .mag format
            For Counter = 1 To RecordHead.Number - 1
                Line Input #ConvertFileNum, temp
                ErrorLineNumber = ErrorLineNumber + 1
                Call BreakRecord(Counter, temp)
                Put #MagFileNum, IndexNum + Counter, Data(Counter)
            Next Counter
            temp = "              ORG  0      0    0      0    0         0    0     "
            Call BreakRecord(Counter, temp) 'dissect demagnetization data string
            Data(Counter).Plot = 0      'origin default not to be plotted
            Put #MagFileNum, IndexNum + Counter, Data(Counter)
            CurrentHeader = NextHeader
            IndexNum = RecordHead.NextRec
        Wend
        
    'Purpose:   To convert Tab or Comma delimited files to *.mag file
    ElseIf LCase(Right(filPMagConvert.FileName, 3)) = "tab" Or LCase(Right(filPMagConvert.FileName, 3)) = "cma" Then
'    ElseIf DChar = Chr(9) Or DChar = "," Then
        'Read the first line of the file, convert it ans SAVE AS Header
        ErrorLineNumber = 0
        Line Input #ConvertFileNum, temp
        ErrorLineNumber = ErrorLineNumber + 1
        TabStringLength = Len(temp)
        'To obtain Header.Name
        Point = InStr(temp, DChar)
        TempName = Left(temp, Point - 1)
        RemTabString = Mid(temp, Point + 1, TabStringLength)
        TabStringLength = TabStringLength - Point
        Point = InStr(RemTabString, DChar)
        TabStringLength = TabStringLength - Point
        TempName = TempName & " " & Left(RemTabString, Point - 1)
        Header.Name = TempName
        Header.Latitude = CSng(TabDataString(RemTabString, Point, TabStringLength))
        Header.Longitude = CSng(TabDataString(RemTabString, Point, TabStringLength))
        Header.MagDeclination = CSng(TabDataString(RemTabString, Point, TabStringLength))
        Header.MagInclination = CSng(TabDataString(RemTabString, Point, TabStringLength))
        Header.Last = CLng(TabDataString(RemTabString, Point, TabStringLength))
        Header.SampleNum = CLng(TabDataString(RemTabString, Point, TabStringLength))
        Header.LineNum = CLng(TabDataString(RemTabString, Point, TabStringLength))
        Put #MagFileNum, IndexNum, Header
        
        'Read through the apple format (.tab) file
        IndexNum = 2
        CurrentHeader = 2
        While CurrentHeader < Header.Last
            Line Input #ConvertFileNum, temp
            ErrorLineNumber = ErrorLineNumber + 1
            TabStringLength = Len(temp)
            'To obtain Header.Name
            Point = InStr(temp, DChar)
            TempName = Left(temp, Point - 1)
            RemTabString = Mid(temp, Point + 1, TabStringLength)
            TabStringLength = TabStringLength - Point
            Point = InStr(RemTabString, DChar)
            TabStringLength = TabStringLength - Point
            TempName = TempName & " " & Left(RemTabString, Point - 1)
            RecordHead.Name = TempName
            RecordHead.Meters = CSng(TabDataString(RemTabString, Point, TabStringLength))  'meter level of sample
            NotUsedString = ""
            For Counter = 1 To 4
                NotUsedString = NotUsedString & " " & _
                    TabDataString(RemTabString, Point, TabStringLength)
            Next Counter
            Last = CLng(TabDataString(RemTabString, Point, TabStringLength))
            NextHeader = CLng(TabDataString(RemTabString, Point, TabStringLength))
            Current = CLng(TabDataString(RemTabString, Point, TabStringLength))
            RecordHead.LSHead = 0
            RecordHead.Number = Last - Current + 1
            RecordHead.NextRec = IndexNum + RecordHead.Number + 1
'            RecordHead.Theta = -2       'default theta to no projection
            RecordHead.Theta = 0       'default theta to projection to N-S: New default after 10/09/2001
            RecordHead.Active = 1       'default the record to active
            Put #MagFileNum, IndexNum, RecordHead   'Save this header
            'Read Demagnetization data for the sample and covert to .mag format
            For Counter = 1 To RecordHead.Number - 1
                Line Input #ConvertFileNum, temp
                ErrorLineNumber = ErrorLineNumber + 1
                TabStringLength = Len(temp)
                Point = InStr(temp, DChar)
                NotUsedString = Left(temp, Point - 1)
                RemTabString = Mid(temp, Point + 1, TabStringLength)
                TabStringLength = TabStringLength - Point
                Point = InStr(RemTabString, DChar)
                TabStringLength = TabStringLength - Point
                NotUsedString = NotUsedString & " " & _
                    Left(RemTabString, Point - 1)
                TempDeMag = TabDataString(RemTabString, Point, TabStringLength)
                Data(Counter).DeMag = Left(TempDeMag, 3)
                Data(Counter).DeMagLevel = CSng(Right(TempDeMag, 3))
                Data(Counter).GDec = CSng(TabDataString(RemTabString, Point, TabStringLength))          'Geog declination
                Data(Counter).GInc = CSng(TabDataString(RemTabString, Point, TabStringLength))          'Geog inclination
                Data(Counter).TDec = CSng(TabDataString(RemTabString, Point, TabStringLength))          'Tilt declination
                Data(Counter).TInc = CSng(TabDataString(RemTabString, Point, TabStringLength))          'Tilt inclination
                Data(Counter).Mag = CSng(TabDataString(RemTabString, Point, TabStringLength))           'Magnetic intensity
                Data(Counter).Errer = CSng(TabDataString(RemTabString, Point, TabStringLength))         'CSD error
                Data(Counter).LSquare = 0
                Data(Counter).Plot = 1
                Put #MagFileNum, IndexNum + Counter, Data(Counter)
            Next Counter
            temp = "              ORG  0      0    0      0    0         0    0     "
            Call BreakRecord(Counter, temp) 'dissect demagnetization data string
            Data(Counter).Plot = 0      'origin default not to be plotted
            Put #MagFileNum, IndexNum + Counter, Data(Counter)
            CurrentHeader = NextHeader
            IndexNum = RecordHead.NextRec
        Wend
    
    
     'Purpose:   To convert New Tab delimited files to *.mag file
    ElseIf LCase(Right(filPMagConvert.FileName, 3)) = "nta" Then
        'First, Figure out how many lines, how many samples, and how many steps in each sample
        Line Input #ConvertFileNum, temp
        NumOfLines = 1
        ErrorLineNumber = NumOfLines
        TabStringLength = Len(temp)
        'To obtain Header.Name
        Point = InStr(temp, DChar)
        TempName = Left(temp, Point - 1)
        RemTabString = Mid(temp, Point + 1, TabStringLength)
        TabStringLength = TabStringLength - Point
        Point = 0
'        Point = InStr(RemTabString, DChar)
'        TabStringLength = TabStringLength - Point
'        TempName = TempName & " " & Left(RemTabString, Point - 1)
        Header.Name = TempName
        Header.Latitude = CSng(TabDataString(RemTabString, Point, TabStringLength))
        Header.Longitude = CSng(TabDataString(RemTabString, Point, TabStringLength))
        Header.MagDeclination = CSng(TabDataString(RemTabString, Point, TabStringLength))
        Header.MagInclination = CSng(TabDataString(RemTabString, Point, TabStringLength))
        Header.LineNum = 1
        SampleCounter = 0
        NewTabSample(SampleCounter).Name = ""
        While Not EOF(ConvertFileNum)
            Line Input #ConvertFileNum, temp
            NumOfLines = NumOfLines + 1
            ErrorLineNumber = NumOfLines
            
        'To figure out sample information, such as name, step number etc.
            TabStringLength = Len(temp)
            StepCounter = StepCounter + 1
            Point = InStr(temp, DChar)
            TempName = Left(temp, Point - 1)
            RemTabString = Mid(temp, Point + 1, TabStringLength)
            TabStringLength = TabStringLength - Point
            Point = InStr(RemTabString, DChar)
            TempName = TempName & " " & Left(RemTabString, Point - 1)
            TempNameString = TempName
            If TempNameString <> NewTabSample(SampleCounter).Name Then
                SampleCounter = SampleCounter + 1
                ReDim Preserve NewTabSample(0 To SampleCounter) As NewTabSampleInfoType
                NewTabSample(SampleCounter).Name = TempName
                NewTabSample(SampleCounter).NextRec = NumOfLines
                StepCounter = 0
            Else
                NewTabSample(SampleCounter).Steps = StepCounter
                NewTabSample(SampleCounter).NextRec = NumOfLines + 1
            End If
        Wend
        Header.Last = NumOfLines + 1
        Header.SampleNum = SampleCounter
        Put #MagFileNum, IndexNum, Header
        Close #ConvertFileNum
        Open ConvertFileName For Input As #ConvertFileNum   'To restart reading from the beginning
        ErrorLineNumber = 0

        Line Input #ConvertFileNum, temp 'Read but ignore the first line
        ErrorLineNumber = ErrorLineNumber + 1

        'Read through the apple format (.nta) file
        IndexNum = 2
        CurrentHeader = 2
        For I = 1 To SampleCounter
'        While CurrentHeader < Header.Last
            Line Input #ConvertFileNum, temp
            ErrorLineNumber = ErrorLineNumber + 1
            TabStringLength = Len(temp)
            'To obtain Header.Name
            Point = InStr(temp, DChar)
'            TempName = Left(temp, Point - 1)
            RemTabString = Mid(temp, Point + 1, TabStringLength)
            TabStringLength = TabStringLength - Point
            Point = InStr(RemTabString, DChar)
            TabStringLength = TabStringLength - Point
'            TempName = TempName & " " & Left(RemTabString, Point - 1)
            RecordHead.Name = NewTabSample(I).Name
            RecordHead.Meters = CSng(TabDataString(RemTabString, Point, TabStringLength))  'meter level of sample
'            NotUsedString = ""
'            For Counter = 1 To 4
'                NotUsedString = NotUsedString & " " & _
'                    TabDataString(RemTabString, Point, TabStringLength)
'            Next Counter
'            Last = CLng(TabDataString(RemTabString, Point, TabStringLength))
'            NextHeader = CLng(TabDataString(RemTabString, Point, TabStringLength))
'            Current = CLng(TabDataString(RemTabString, Point, TabStringLength))
            RecordHead.LSHead = 0
            RecordHead.Number = NewTabSample(I).Steps + 1
            RecordHead.NextRec = NewTabSample(I).NextRec + I
'            RecordHead.Theta = -2       'default theta to no projection
            RecordHead.Theta = 0       'default theta to projection to N-S: New default after 10/09/2001
            RecordHead.Active = 1       'default the record to active
            Put #MagFileNum, IndexNum, RecordHead   'Save this header
            'Read Demagnetization data for the sample and covert to .mag format
            For Counter = 1 To NewTabSample(I).Steps
                Line Input #ConvertFileNum, temp
                ErrorLineNumber = ErrorLineNumber + 1
                TabStringLength = Len(temp)
                Point = InStr(temp, DChar)
'                NotUsedString = Left(temp, Point - 1)
                RemTabString = Mid(temp, Point + 1, TabStringLength)
                TabStringLength = TabStringLength - Point
                Point = InStr(RemTabString, DChar)
                TabStringLength = TabStringLength - Point
'                NotUsedString = NotUsedString & " " & _
'                    Left(RemTabString, Point - 1)
                TempDeMag = TabDataString(RemTabString, Point, TabStringLength)
                Data(Counter).DeMag = Left(TempDeMag, 3)
                Data(Counter).DeMagLevel = CSng(Right(TempDeMag, 3))
                Data(Counter).GDec = CSng(TabDataString(RemTabString, Point, TabStringLength))          'Geog declination
                Data(Counter).GInc = CSng(TabDataString(RemTabString, Point, TabStringLength))          'Geog inclination
                Data(Counter).TDec = CSng(TabDataString(RemTabString, Point, TabStringLength))          'Tilt declination
                Data(Counter).TInc = CSng(TabDataString(RemTabString, Point, TabStringLength))          'Tilt inclination
                Data(Counter).Mag = CSng(TabDataString(RemTabString, Point, TabStringLength))           'Magnetic intensity
                Data(Counter).Errer = CSng(TabDataString(RemTabString, Point, TabStringLength))         'CSD error
                Data(Counter).LSquare = 0
                Data(Counter).Plot = 1
                Put #MagFileNum, IndexNum + Counter, Data(Counter)
            Next Counter
            temp = "              ORG  0      0    0      0    0         0    0     "
            Call BreakRecord(Counter, temp) 'dissect demagnetization data string
            Data(Counter).Plot = 0      'origin default not to be plotted
            Put #MagFileNum, IndexNum + Counter, Data(Counter)
            CurrentHeader = NextHeader
            IndexNum = RecordHead.NextRec
        Next I
    
    'Purpose:   To convert " " (Space) delimited *.txt file to *.mag file
    Else
        'Read the first line of the file, convert it ans SAVE AS Header
        ErrorLineNumber = 0
        Line Input #ConvertFileNum, temp
        ErrorLineNumber = ErrorLineNumber + 1
        TabStringLength = Len(temp)
        'To obtain Header.Name
        Point = InStr(temp, DChar)
        TempName = Left(temp, Point - 1)
        TempName = TempName & " " & TabDataString(temp, Point, TabStringLength)
        RemTabString = Mid(temp, Point + 1, TabStringLength)
        Point = InStr(RemTabString, DChar)
        QuestionString = TabDataString(RemTabString, Point, TabStringLength)
        If IsNumeric(QuestionString) = False Then
            TempName = TempName & " " & QuestionString
            Header.Latitude = CSng(TabDataString(RemTabString, Point, TabStringLength))
        Else
            Header.Latitude = CSng(QuestionString)
        End If
        Header.Name = TempName
        Header.Longitude = CSng(TabDataString(RemTabString, Point, TabStringLength))
        Header.MagDeclination = CSng(TabDataString(RemTabString, Point, TabStringLength))
        Header.MagInclination = CSng(TabDataString(RemTabString, Point, TabStringLength))
        Header.Last = CLng(TabDataString(RemTabString, Point, TabStringLength))
        Header.SampleNum = CLng(TabDataString(RemTabString, Point, TabStringLength))
        Header.LineNum = CLng(TabDataString(RemTabString, Point, TabStringLength))
        Put #MagFileNum, IndexNum, Header
        
        'Read through the apple format (.app) file
        IndexNum = 2
        CurrentHeader = 2
        While CurrentHeader < Header.Last
            Line Input #ConvertFileNum, temp
            ErrorLineNumber = ErrorLineNumber + 1
            
            TabStringLength = Len(temp)
            'To obtain Header.Name
            Point = InStr(temp, DChar)
            TempName = Left(temp, Point - 1)
            TempName = TempName & " " & TabDataString(temp, Point, TabStringLength)
            RemTabString = Mid(temp, Point + 1, TabStringLength)
            Point = InStr(RemTabString, DChar)
            QuestionString = TabDataString(RemTabString, Point, TabStringLength)
            If IsNumeric(QuestionString) = False Then
                TempName = TempName & " " & QuestionString
                RecordHead.Meters = CSng(TabDataString(RemTabString, Point, TabStringLength))
            Else
                RecordHead.Meters = CSng(QuestionString)
            End If
            RecordHead.Name = TempName
            NotUsedString = ""
            For Counter = 1 To 4
                NotUsedString = NotUsedString & " " & _
                    TabDataString(RemTabString, Point, TabStringLength)
            Next Counter
            Last = CLng(TabDataString(RemTabString, Point, TabStringLength))
            NextHeader = CLng(TabDataString(RemTabString, Point, TabStringLength))
            Current = CLng(TabDataString(RemTabString, Point, TabStringLength))
            RecordHead.LSHead = 0
            RecordHead.Number = Last - Current + 1
            RecordHead.NextRec = IndexNum + RecordHead.Number + 1
'            RecordHead.Theta = -2       'default theta to no projection
            RecordHead.Theta = 0       'default theta to projection to N-S: New default after 10/09/2001
            RecordHead.Active = 1       'default the record to active
            Put #MagFileNum, IndexNum, RecordHead   'Save this header
            'Read Demagnetization data for the sample and covert to .mag format
            For Counter = 1 To RecordHead.Number - 1
                Line Input #ConvertFileNum, temp
                ErrorLineNumber = ErrorLineNumber + 1
                
                TabStringLength = Len(temp)
                Point = InStr(temp, DChar)
                
                TempName = Left(temp, Point - 1)
                TempName = TempName & " " & TabDataString(temp, Point, TabStringLength)
                RemTabString = Mid(temp, Point + 1, TabStringLength)
                Point = InStr(RemTabString, DChar)
                QuestionString = TabDataString(RemTabString, Point, TabStringLength)
                If (QuestionString <> "NRM") And (QuestionString <> "TT") And _
                    (QuestionString <> "AF") Then
                    TempName = TempName & " " & QuestionString
                    Data(Counter).DeMag = TabDataString(RemTabString, Point, TabStringLength)
                Else
                    Data(Counter).DeMag = QuestionString
                End If
                NotUsedString = TempName
                Data(Counter).DeMagLevel = CSng(TabDataString(RemTabString, Point, TabStringLength))
                Data(Counter).GDec = CSng(TabDataString(RemTabString, Point, TabStringLength))          'Geog declination
                Data(Counter).GInc = CSng(TabDataString(RemTabString, Point, TabStringLength))          'Geog inclination
                Data(Counter).TDec = CSng(TabDataString(RemTabString, Point, TabStringLength))          'Tilt declination
                Data(Counter).TInc = CSng(TabDataString(RemTabString, Point, TabStringLength))          'Tilt inclination
                Data(Counter).Mag = CSng(TabDataString(RemTabString, Point, TabStringLength))           'Magnetic intensity
                Data(Counter).Errer = CSng(TabDataString(RemTabString, Point, TabStringLength))         'CSD error
                Data(Counter).LSquare = 0
                Data(Counter).Plot = 1
                Put #MagFileNum, IndexNum + Counter, Data(Counter)
            Next Counter
            temp = "              ORG  0      0    0      0    0         0    0     "
            Call BreakRecord(Counter, temp) 'dissect demagnetization data string
            Data(Counter).Plot = 0      'origin default not to be plotted
            Put #MagFileNum, IndexNum + Counter, Data(Counter)
            CurrentHeader = NextHeader
            IndexNum = RecordHead.NextRec
        Wend
    End If
        
        
    'finalize file header with updated next-header pointer
    Header.Last = IndexNum      'Last Empty Line in the *.mag file.
'    Header.SampleNum = IndexNum
    Put #MagFileNum, 1, Header
    Close #ConvertFileNum
    Close #MagFileNum
    
    'Purpose:   To close the Convert File Dialog box.
    Unload frmFileConvert
    
    Call frmMain.GetOpenFileName(MagFileName)
    Call frmMain.Show
    Exit Sub
ErrHandler:
    Msg = "Error # " & Str(Err.Number) & " was generated by " _
         & Err.Source & vbCrLf & "ERROR = " & Err.Description & vbCrLf _
         & "Error occurs in the data file on line #: " & ErrorLineNumber
    Call MsgBox(Msg, vbOKOnly + vbInformation)
    Close #ConvertFileNum
    Close #MagFileNum
    Exit Sub
End Sub

Private Sub cmdExit_Click()
    Unload frmFileConvert
    Unload frmMain
End Sub


'Purpose:   Update the DirListBox's path with the new drive
'       letter from the DriveListBox.
Private Sub drvPMagConvert_Change()
    dirPMagConvert.Path = drvPMagConvert.Drive
End Sub

'Purpose:   Update the FileListBox's path with the new value
'       of the DirListBox's path.
Private Sub dirPMagConvert_Change()
    filPMagConvert.Path = dirPMagConvert.Path
End Sub


Private Sub BreakRecord(ByVal num As Long, ByVal temp As String)
    Data(num).GDec = CSng(Mid(temp, 21, 7))          'Geog declination
    Data(num).GInc = CSng(Mid(temp, 28, 5))          'Geog inclination
    Data(num).TDec = CSng(Mid(temp, 34, 6))          'Tilt declination
    Data(num).TInc = CSng(Mid(temp, 40, 5))          'Tilt inclination
    Data(num).Mag = CSng(Mid(temp, 47, 8))           'Magnetic intensity
    Data(num).Errer = CSng(Mid(temp, 56, 5))         'CSD error
    Data(num).DeMagLevel = CSng(Mid(temp, 18, 3))    'Thermal or AF level
    Data(num).DeMag = Mid(temp, 15, 3)              'Demag step
    Data(num).LSquare = 0
    Data(num).Plot = 1
End Sub


Private Sub filPMagConvert_DblClick()
    cmdConvert_Click
End Sub

'Purpose:   To get a string of data from a string line
Private Function TabDataString(ByRef RemString As String, ByRef Point As Long, _
    ByRef StringLength As Long) As String
        RemString = Mid(RemString, Point + 1, StringLength)
        While Left(RemString, 1) = DChar
            RemString = Mid(RemString, 2, StringLength)
            StringLength = StringLength - 1
        Wend
        Point = InStr(RemString, DChar)
        If Point > 0 Then
            StringLength = StringLength - Point
            TabDataString = Left(RemString, Point - 1)
        Else
            TabDataString = RemString
        End If
End Function

